package com.nortel.rc.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;
import java.util.Vector;

import javax.swing.AbstractButton;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.text.Position;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Category;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;

import com.nortel.rc.dto.AddressCapabilitiesTO;
import com.nortel.rc.dto.AddressPropertyEventTO;
import com.nortel.rc.dto.AddressStateEventTO;
import com.nortel.rc.dto.AddressTO;
import com.nortel.rc.dto.AgentCapabilitiesTO;
import com.nortel.rc.dto.AgentPropertyEventTO;
import com.nortel.rc.dto.AgentStateEventTO;
import com.nortel.rc.dto.AgentTO;
import com.nortel.rc.dto.AttachedDataTO;
import com.nortel.rc.dto.AttachedDataTO.AttachedDataType;
import com.nortel.rc.dto.CapabilityTO;
import com.nortel.rc.dto.ConnectionCapabilitiesTO;
import com.nortel.rc.dto.ConnectionTO;
import com.nortel.rc.dto.ContactCapabilitiesTO;
import com.nortel.rc.dto.ContactPropertyEventTO;
import com.nortel.rc.dto.ContactTO;
import com.nortel.rc.dto.ForwardInstructionTO;
import com.nortel.rc.dto.IntrinsicTO;
import com.nortel.rc.dto.KeyValuePairTO;
import com.nortel.rc.dto.ProviderTO;
import com.nortel.rc.dto.StateEventTO;
import com.nortel.rc.dto.StateSummaryTO;
import com.nortel.rc.dto.TerminalCapabilitiesTO;
import com.nortel.rc.dto.TerminalConnectionCapabilitiesTO;
import com.nortel.rc.dto.TerminalConnectionTO;
import com.nortel.rc.dto.TerminalPropertyEventTO;
import com.nortel.rc.dto.TerminalStateEventTO;
import com.nortel.rc.dto.TerminalTO;
import com.nortel.rc.dto.UserContextDO;
import com.nortel.rc.event.NotificationManager;
import com.nortel.rc.handler.RequestHandler;
import com.nortel.soa.oi.cct.types.Address;
import com.nortel.soa.oi.cct.types.ConnectionState;

public class SOARefClient extends javax.swing.JFrame
{    
    private static final Category log = Category.getInstance(SOARefClient.class.getName());
    private static final String PARAM_NAME_STATE_EVENT_TO = "StateEventTO";
    private static final String HELD_REASON_CONSULT_INIT = "CONSULT_INIT";
    private static final String HELD_REASON_TRANSFER_INIT = "TRANSFER_INIT";
    private static final String HELD_REASON_CONFERENCE_INIT = "CONFERENCE_INIT";
    private static final String ROOT = "Root";
    private DefaultMutableTreeNode root = null;
    private DefaultTreeModel contactDetailsModel = null;
       
    public SOARefClient() {
        initComponents();
        initLookAndFeel();
        initAppComponents();
    }
    // <editor-fold defaultstate="collapsed" desc="Generated Code">                          
    private void initComponents() {
        jFrame1 = new javax.swing.JFrame();
        jPanel4 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jTextField4 = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jPasswordField1 = new javax.swing.JPasswordField();
        jFrame2 = new javax.swing.JFrame();
        jPanel5 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel8 = new javax.swing.JLabel();
        jPasswordField2 = new javax.swing.JPasswordField();
        jComboBox9 = new javax.swing.JComboBox();
        jLabel68 = new javax.swing.JLabel();
        jFrame3 = new javax.swing.JFrame();
        jPanel6 = new javax.swing.JPanel();
        jButton15 = new javax.swing.JButton();
        jButton16 = new javax.swing.JButton();
        jButton45 = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel22 = new javax.swing.JPanel();
        jScrollPane23 = new javax.swing.JScrollPane();
        jTable11 = new javax.swing.JTable();
        jPanel23 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jPanel24 = new javax.swing.JPanel();
        jScrollPane22 = new javax.swing.JScrollPane();
        jTextArea6 = new javax.swing.JTextArea();
        jFrame4 = new javax.swing.JFrame();
        jPanel7 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTree2 = new javax.swing.JTree();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jTextField8 = new javax.swing.JTextField();
        jTextField12 = new javax.swing.JTextField();
        jTextField13 = new javax.swing.JTextField();
        jTextField18 = new javax.swing.JTextField();
        jTextField38 = new javax.swing.JTextField();
        jTextField39 = new javax.swing.JTextField();
        jLabel31 = new javax.swing.JLabel();
        jLabel33 = new javax.swing.JLabel();
        jScrollPane14 = new javax.swing.JScrollPane();
        jTable5 = new javax.swing.JTable();
        jTextField40 = new javax.swing.JTextField();
        jScrollPane21 = new javax.swing.JScrollPane();
        jTable3 = new javax.swing.JTable();
        jFrame5 = new javax.swing.JFrame();
        jPanel8 = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        jTree3 = new javax.swing.JTree();
        jLabel19 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        jLabel24 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        jLabel26 = new javax.swing.JLabel();
        jLabel27 = new javax.swing.JLabel();
        jLabel28 = new javax.swing.JLabel();
        jLabel29 = new javax.swing.JLabel();
        jLabel30 = new javax.swing.JLabel();
        jLabel32 = new javax.swing.JLabel();
        jLabel34 = new javax.swing.JLabel();
        jLabel36 = new javax.swing.JLabel();
        jLabel35 = new javax.swing.JLabel();
        jLabel37 = new javax.swing.JLabel();
        jLabel38 = new javax.swing.JLabel();
        jTextField7 = new javax.swing.JTextField();
        jTextField19 = new javax.swing.JTextField();
        jTextField20 = new javax.swing.JTextField();
        jTextField21 = new javax.swing.JTextField();
        jTextField22 = new javax.swing.JTextField();
        jTextField24 = new javax.swing.JTextField();
        jTextField25 = new javax.swing.JTextField();
        jTextField26 = new javax.swing.JTextField();
        jTextField27 = new javax.swing.JTextField();
        jTextField28 = new javax.swing.JTextField();
        jTextField29 = new javax.swing.JTextField();
        jTextField30 = new javax.swing.JTextField();
        jTextField31 = new javax.swing.JTextField();
        jTextField32 = new javax.swing.JTextField();
        jTextField33 = new javax.swing.JTextField();
        jTextField34 = new javax.swing.JTextField();
        jTextField48 = new javax.swing.JTextField();
        jTextField49 = new javax.swing.JTextField();
        jTextField50 = new javax.swing.JTextField();
        jTextField51 = new javax.swing.JTextField();
        jLabel48 = new javax.swing.JLabel();
        jLabel49 = new javax.swing.JLabel();
        jLabel50 = new javax.swing.JLabel();
        jTextField52 = new javax.swing.JTextField();
        jTextField53 = new javax.swing.JTextField();
        jTextField54 = new javax.swing.JTextField();
        jTextField55 = new javax.swing.JTextField();
        jLabel51 = new javax.swing.JLabel();
        jLabel52 = new javax.swing.JLabel();
        jLabel53 = new javax.swing.JLabel();
        jLabel54 = new javax.swing.JLabel();
        jLabel55 = new javax.swing.JLabel();
        jScrollPane10 = new javax.swing.JScrollPane();
        jTable6 = new javax.swing.JTable();
        jScrollPane15 = new javax.swing.JScrollPane();
        jTable7 = new javax.swing.JTable();
        jScrollPane16 = new javax.swing.JScrollPane();
        jTable8 = new javax.swing.JTable();
        jComboBox4 = new javax.swing.JComboBox();
        jFrame6 = new javax.swing.JFrame();
        jPanel9 = new javax.swing.JPanel();
        jButton19 = new javax.swing.JButton();
        jScrollPane11 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jFrame7 = new javax.swing.JFrame();
        jPanel13 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jScrollPane7 = new javax.swing.JScrollPane();
        jTextPane3 = new javax.swing.JTextPane();
        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItem22 = new javax.swing.JMenuItem();
        jMenuItem23 = new javax.swing.JMenuItem();
        jMenuItem24 = new javax.swing.JMenuItem();
        jMenuItem25 = new javax.swing.JMenuItem();
        jMenuItem26 = new javax.swing.JMenuItem();
        jFrame8 = new javax.swing.JFrame();
        jPanel10 = new javax.swing.JPanel();
        jLabel56 = new javax.swing.JLabel();
        jLabel57 = new javax.swing.JLabel();
        jButton17 = new javax.swing.JButton();
        jButton18 = new javax.swing.JButton();
        jComboBox6 = new javax.swing.JComboBox();
        jLabel58 = new javax.swing.JLabel();
        jTextField57 = new javax.swing.JTextField();
        jPasswordField3 = new javax.swing.JPasswordField();
        jFrame9 = new javax.swing.JFrame();
        jPanel11 = new javax.swing.JPanel();
        jLabel59 = new javax.swing.JLabel();
        jLabel60 = new javax.swing.JLabel();
        jTextField23 = new javax.swing.JTextField();
        jTextField58 = new javax.swing.JTextField();
        jButton29 = new javax.swing.JButton();
        jButton30 = new javax.swing.JButton();
        httpRadioButton = new javax.swing.JRadioButton();
        httpsRadioButton = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        jPopupMenu2 = new javax.swing.JPopupMenu();
        jMenuItem27 = new javax.swing.JMenuItem();
        jMenuItem28 = new javax.swing.JMenuItem();
        jPopupMenu3 = new javax.swing.JPopupMenu();
        jMenuItem29 = new javax.swing.JMenuItem();
        jMenuItem30 = new javax.swing.JMenuItem();
        jMenuItem31 = new javax.swing.JMenuItem();
        jFrame10 = new javax.swing.JFrame();
        jPanel12 = new javax.swing.JPanel();
        jLabel61 = new javax.swing.JLabel();
        jTextField56 = new javax.swing.JTextField();
        jButton34 = new javax.swing.JButton();
        jButton35 = new javax.swing.JButton();
        jPopupMenu4 = new javax.swing.JPopupMenu();
        jMenuItem32 = new javax.swing.JMenuItem();
        jMenuItem33 = new javax.swing.JMenuItem();
        jMenuItem34 = new javax.swing.JMenuItem();
        jFrame11 = new javax.swing.JFrame();
        jPanel14 = new javax.swing.JPanel();
        jLabel62 = new javax.swing.JLabel();
        jTextField59 = new javax.swing.JTextField();
        jButton36 = new javax.swing.JButton();
        jButton37 = new javax.swing.JButton();
        jPopupMenu5 = new javax.swing.JPopupMenu();
        jMenuItem35 = new javax.swing.JMenuItem();
        jMenuItem36 = new javax.swing.JMenuItem();
        jPopupMenu6 = new javax.swing.JPopupMenu();
        jMenuItem37 = new javax.swing.JMenuItem();
        jMenuItem38 = new javax.swing.JMenuItem();
        jFrame12 = new javax.swing.JFrame();
        jPanel15 = new javax.swing.JPanel();
        jLabel63 = new javax.swing.JLabel();
        jLabel65 = new javax.swing.JLabel();
        jLabel66 = new javax.swing.JLabel();
        jLabel67 = new javax.swing.JLabel();
        jTextField60 = new javax.swing.JTextField();
        jTextField67 = new javax.swing.JTextField();
        jComboBox7 = new javax.swing.JComboBox();
        jScrollPane9 = new javax.swing.JScrollPane();
        jTable4 = new javax.swing.JTable();
        jComboBox8 = new javax.swing.JComboBox();
        jButton38 = new javax.swing.JButton();
        jButton39 = new javax.swing.JButton();
        jButton40 = new javax.swing.JButton();
        jButton41 = new javax.swing.JButton();
        jButton42 = new javax.swing.JButton();
        jFrame13 = new javax.swing.JFrame();
        jPanel16 = new javax.swing.JPanel();
        jLabel64 = new javax.swing.JLabel();
        jTextField61 = new javax.swing.JTextField();
        jButton43 = new javax.swing.JButton();
        jButton44 = new javax.swing.JButton();
        jFrame14 = new javax.swing.JFrame();
        jPanel17 = new javax.swing.JPanel();
        jScrollPane12 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        jFrame15 = new javax.swing.JFrame();
        jPanel18 = new javax.swing.JPanel();
        jScrollPane17 = new javax.swing.JScrollPane();
        jTree4 = new javax.swing.JTree();
        jLabel70 = new javax.swing.JLabel();
        jLabel71 = new javax.swing.JLabel();
        jLabel72 = new javax.swing.JLabel();
        jLabel73 = new javax.swing.JLabel();
        jLabel74 = new javax.swing.JLabel();
        jLabel75 = new javax.swing.JLabel();
        jLabel76 = new javax.swing.JLabel();
        jLabel77 = new javax.swing.JLabel();
        jTextField62 = new javax.swing.JTextField();
        jTextField63 = new javax.swing.JTextField();
        jTextField64 = new javax.swing.JTextField();
        jTextField65 = new javax.swing.JTextField();
        jTextField66 = new javax.swing.JTextField();
        jTextField68 = new javax.swing.JTextField();
        jTextField69 = new javax.swing.JTextField();
        jTextField70 = new javax.swing.JTextField();
        jTextField71 = new javax.swing.JTextField();
        jTextField72 = new javax.swing.JTextField();
        jTextField73 = new javax.swing.JTextField();
        jTextField74 = new javax.swing.JTextField();
        jTextField75 = new javax.swing.JTextField();
        jTextField76 = new javax.swing.JTextField();
        jComboBox10 = new javax.swing.JComboBox();
        jLabel78 = new javax.swing.JLabel();
        jLabel79 = new javax.swing.JLabel();
        jLabel80 = new javax.swing.JLabel();
        jLabel81 = new javax.swing.JLabel();
        jLabel82 = new javax.swing.JLabel();
        jLabel83 = new javax.swing.JLabel();
        jLabel84 = new javax.swing.JLabel();
        jTextField77 = new javax.swing.JTextField();
        jTextField78 = new javax.swing.JTextField();
        jLabel85 = new javax.swing.JLabel();
        jLabel86 = new javax.swing.JLabel();
        jTextField79 = new javax.swing.JTextField();
        jLabel87 = new javax.swing.JLabel();
        jTextField80 = new javax.swing.JTextField();
        jLabel88 = new javax.swing.JLabel();
        jScrollPane18 = new javax.swing.JScrollPane();
        jTable9 = new javax.swing.JTable();
        jScrollPane19 = new javax.swing.JScrollPane();
        jTable10 = new javax.swing.JTable();
        jFrame16 = new javax.swing.JFrame();
        jPanel19 = new javax.swing.JPanel();
        jButton47 = new javax.swing.JButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextArea4 = new javax.swing.JTextArea();
        jButton48 = new javax.swing.JButton();
        jFrame17 = new javax.swing.JFrame();
        jPanel20 = new javax.swing.JPanel();
        jButton49 = new javax.swing.JButton();
        jButton50 = new javax.swing.JButton();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jButton51 = new javax.swing.JButton();
        jFrame18 = new javax.swing.JFrame();
        jPanel21 = new javax.swing.JPanel();
        jScrollPane20 = new javax.swing.JScrollPane();
        jTextArea5 = new javax.swing.JTextArea();
        jFrame19 = new javax.swing.JFrame();
        jPanel25 = new javax.swing.JPanel();
        jLabel69 = new javax.swing.JLabel();
        jTextField81 = new javax.swing.JTextField();
        jButton46 = new javax.swing.JButton();
        jButton52 = new javax.swing.JButton();
        jMenuBar5 = new javax.swing.JMenuBar();
        jMenu17 = new javax.swing.JMenu();
        jMenu18 = new javax.swing.JMenu();
        jAgentStatusPanel = new javax.swing.JPanel();
        jTextField2 = new javax.swing.JTextField();
        jButton6 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jComboBox3 = new javax.swing.JComboBox();
        jTextField36 = new javax.swing.JTextField();
        jButton21 = new javax.swing.JButton();
        jTextField37 = new javax.swing.JTextField();
        jCheckBox1 = new javax.swing.JCheckBox();
        jInitiateContactsPanel = new javax.swing.JPanel();
        jTextField9 = new javax.swing.JTextField();
        originateButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jTextField10 = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextField11 = new javax.swing.JTextField();
        jButton20 = new javax.swing.JButton();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        activityCodeButton = new javax.swing.JButton();
        forwardingButton = new javax.swing.JButton();
        dndButton = new javax.swing.JButton();
        jButton25 = new javax.swing.JButton();
        jButton26 = new javax.swing.JButton();
        jButton27 = new javax.swing.JButton();
        jButton28 = new javax.swing.JButton();
        jComboBox2 = new javax.swing.JComboBox();
        jLabel20 = new javax.swing.JLabel();
        jCurrentContactsPanel = new javax.swing.JPanel();
        jContactPanel = new javax.swing.JPanel();
        jContactPanelButtons = new javax.swing.JPanel();
        jButton8 = new javax.swing.JButton();
        jButton9 = new javax.swing.JButton();
        jButton10 = new javax.swing.JButton();
        jButton11 = new javax.swing.JButton();
        jButton12 = new javax.swing.JButton();
        jButton14 = new javax.swing.JButton();
        jButton13 = new javax.swing.JButton();
        jScrollPane13 = new javax.swing.JScrollPane();
        jContactsTable = new javax.swing.JTable();
        jButton31 = new javax.swing.JButton();
        jButton32 = new javax.swing.JButton();
        jIntrinsicsButton = new javax.swing.JButton();
        jInformationTextField = new javax.swing.JTextField();
        jRoutePointPanel = new javax.swing.JPanel();
        jTextField14 = new javax.swing.JTextField();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel39 = new javax.swing.JLabel();
        jTextField15 = new javax.swing.JTextField();
        jScrollPane24 = new javax.swing.JScrollPane();
        jTable12 = new javax.swing.JTable();
        jButton53 = new javax.swing.JButton();
        jButton54 = new javax.swing.JButton();
        jButton55 = new javax.swing.JButton();
        jButton56 = new javax.swing.JButton();
        jButton57 = new javax.swing.JButton();
        jButton58 = new javax.swing.JButton();
        jButton59 = new javax.swing.JButton();
        jButton60 = new javax.swing.JButton();
        jScrollPane25 = new javax.swing.JScrollPane();
        jTable13 = new javax.swing.JTable();
        jMenuBar4 = new javax.swing.JMenuBar();
        jMenu13 = new javax.swing.JMenu();
        jMenuItem41 = new javax.swing.JMenuItem();
        jMenuItem42 = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JSeparator();
        jMenuItem43 = new javax.swing.JMenuItem();
        jMenu14 = new javax.swing.JMenu();
        jMenuItem44 = new javax.swing.JMenuItem();
        jMenuItem45 = new javax.swing.JMenuItem();
        jMenuItem46 = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JSeparator();
        jMenuItem47 = new javax.swing.JMenuItem();
        jMenu15 = new javax.swing.JMenu();
        jMenuItem48 = new javax.swing.JMenuItem();
        jMenu16 = new javax.swing.JMenu();
        jMenuItem49 = new javax.swing.JMenuItem();
        jFrame20 = new javax.swing.JFrame();
        jTextField82 = new javax.swing.JTextField();
        
        jFrame1.setTitle("CCT Login");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel4.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel4.setPreferredSize(new java.awt.Dimension(225, 160));

        jLabel2.setText("Username");

        jLabel4.setText("Password");

        jLabel5.setText("Domain");
        
        jButton1.setText("Connect");
        jButton1.setToolTipText("Connect to CCT");
        jButton1.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton3.setText("Cancel");
        jButton3.setToolTipText("Cancel Login");
        jButton3.setDefaultCapable(false);
        jButton3.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel4Layout = new org.jdesktop.layout.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel2)
                    .add(jLabel4)
                    .add(jLabel5))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(jTextField1)
                        .add(jPanel4Layout.createSequentialGroup()
                            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                            .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField4)
                                .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel4Layout.createSequentialGroup()
                                    .add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(jButton3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                    .add(jPasswordField1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 156, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(jTextField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(jPasswordField1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel5)
                    .add(jTextField4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame1Layout = new org.jdesktop.layout.GroupLayout(jFrame1.getContentPane());
        jFrame1.getContentPane().setLayout(jFrame1Layout);
        jFrame1Layout.setHorizontalGroup(
            jFrame1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 232, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame1Layout.setVerticalGroup(
            jFrame1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 126, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame2.setTitle("Agent Login");
        jFrame2.setSize(new Dimension(270, 170));

        jPanel5.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel5.setPreferredSize(new java.awt.Dimension(225, 160));

        jLabel6.setText("Agent ID");

        jLabel7.setText("Password");

        jTextField5.setBackground(new java.awt.Color(204, 204, 204));
        jTextField5.setEditable(false);

        jButton4.setText("OK");
        jButton4.setToolTipText("Login Agent");
        jButton4.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jButton5.setText("Cancel");
        jButton5.setToolTipText("Cancel Login");
        jButton5.setDefaultCapable(false);
        jButton5.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Ready", "Not Ready" }));

        jLabel8.setText("State");
        jLabel8.setToolTipText("Agent Ready State");

        jLabel68.setText("Voice Terminal");

        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(jLabel8)
                        .addContainerGap(186, Short.MAX_VALUE))
                    .add(jPanel5Layout.createSequentialGroup()
                        .add(jLabel7)
                        .addContainerGap(166, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel5Layout.createSequentialGroup()
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel5Layout.createSequentialGroup()
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(jPasswordField2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 109, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, jComboBox1, 0, 109, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 109, Short.MAX_VALUE))
                                .add(18, 18, 18))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel5Layout.createSequentialGroup()
                                .add(jLabel6)
                                .add(32, 32, 32))
                            .add(jPanel5Layout.createSequentialGroup()
                                .add(jButton4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
                        .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jComboBox9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jPanel5Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(jButton5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel68))))
                        .addContainerGap())))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel6)
                    .add(jLabel68))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jComboBox9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTextField5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel7)
                .add(1, 1, 1)
                .add(jPasswordField2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel8)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jComboBox1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame2Layout = new org.jdesktop.layout.GroupLayout(jFrame2.getContentPane());
        jFrame2.getContentPane().setLayout(jFrame2Layout);
        jFrame2Layout.setHorizontalGroup(
            jFrame2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 226, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame2Layout.setVerticalGroup(
            jFrame2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 192, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame3.setTitle("Attach Data");
        jFrame3.setSize(new Dimension(310, 200));

        jPanel6.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel6.setToolTipText("Enter data to be attached");
        jPanel6.setPreferredSize(new java.awt.Dimension(225, 160));

        jButton15.setText("Delete");
        jButton15.setToolTipText("Remove Attached Data");
        jButton15.setDefaultCapable(false);
        jButton15.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton15ActionPerformed(evt);
            }
        });

        jButton16.setText("Cancel");
        jButton16.setToolTipText("Cancel Attach Operation");
        jButton16.setDefaultCapable(false);
        jButton16.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton16ActionPerformed(evt);
            }
        });

        jButton45.setText("Update");
        jButton45.setToolTipText("Attach Data");
        jButton45.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton45.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton45ActionPerformed(evt);
            }
        });

        jPanel22.setName("KVP"); // NOI18N

        jTable11.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTable11.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Key", "Value"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jScrollPane23.setViewportView(jTable11);

        org.jdesktop.layout.GroupLayout jPanel22Layout = new org.jdesktop.layout.GroupLayout(jPanel22);
        jPanel22.setLayout(jPanel22Layout);
        jPanel22Layout.setHorizontalGroup(
            jPanel22Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 316, Short.MAX_VALUE)
            .add(jPanel22Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                .add(jPanel22Layout.createSequentialGroup()
                    .add(2, 2, 2)
                    .add(jScrollPane23, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 311, Short.MAX_VALUE)
                    .add(3, 3, 3)))
        );
        jPanel22Layout.setVerticalGroup(
            jPanel22Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 173, Short.MAX_VALUE)
            .add(jPanel22Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                .add(jPanel22Layout.createSequentialGroup()
                    .add(26, 26, 26)
                    .add(jScrollPane23, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE)
                    .add(27, 27, 27)))
        );

        jTabbedPane1.addTab("Key / Value Pairs", jPanel22);

        jPanel23.setName("String"); // NOI18N

        jTextArea1.setColumns(20);
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(5);
        jScrollPane4.setViewportView(jTextArea1);

        org.jdesktop.layout.GroupLayout jPanel23Layout = new org.jdesktop.layout.GroupLayout(jPanel23);
        jPanel23.setLayout(jPanel23Layout);
        jPanel23Layout.setHorizontalGroup(
            jPanel23Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel23Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 296, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel23Layout.setVerticalGroup(
            jPanel23Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel23Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane1.addTab("String Data", jPanel23);

        jPanel24.setName("Binary"); // NOI18N

        jTextArea6.setColumns(20);
        jTextArea6.setLineWrap(true);
        jTextArea6.setRows(5);
        jScrollPane22.setViewportView(jTextArea6);

        org.jdesktop.layout.GroupLayout jPanel24Layout = new org.jdesktop.layout.GroupLayout(jPanel24);
        jPanel24.setLayout(jPanel24Layout);
        jPanel24Layout.setHorizontalGroup(
            jPanel24Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 316, Short.MAX_VALUE)
            .add(jPanel24Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane22, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 296, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel24Layout.setVerticalGroup(
            jPanel24Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 173, Short.MAX_VALUE)
            .add(jPanel24Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane22, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 151, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane1.addTab("Binary Data", jPanel24);

        org.jdesktop.layout.GroupLayout jPanel6Layout = new org.jdesktop.layout.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel6Layout.createSequentialGroup()
                .addContainerGap(84, Short.MAX_VALUE)
                .add(jButton45, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .add(jPanel6Layout.createSequentialGroup()
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 321, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 20, Short.MAX_VALUE)
                .add(jPanel6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton45, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout jFrame3Layout = new org.jdesktop.layout.GroupLayout(jFrame3.getContentPane());
        jFrame3.getContentPane().setLayout(jFrame3Layout);
        jFrame3Layout.setHorizontalGroup(
            jFrame3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 335, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame3Layout.setVerticalGroup(
            jFrame3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 272, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel6.getAccessibleContext().setAccessibleName("Enter data to be attached");

        jFrame4.setTitle("Capabilities");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder("Agent Details"));
        jPanel7.setPreferredSize(new java.awt.Dimension(225, 160));

        jScrollPane2.setViewportView(jTree2);

        jLabel11.setText("Agent Detail:");

        jLabel12.setText("Supervisor:");

        jLabel13.setText("State:");

        jLabel14.setText("Is Logged In:");

        jLabel15.setText("Is Ready:");

        jTextField8.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTextField8.setColumns(16);
        jTextField8.setEditable(false);
        jTextField8.setBorder(null);

        jTextField12.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTextField12.setColumns(16);
        jTextField12.setEditable(false);
        jTextField12.setBorder(null);

        jTextField13.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTextField13.setColumns(16);
        jTextField13.setEditable(false);
        jTextField13.setBorder(null);

        jTextField18.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTextField18.setColumns(16);
        jTextField18.setEditable(false);
        jTextField18.setBorder(null);

        jTextField38.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTextField38.setColumns(16);
        jTextField38.setEditable(false);
        jTextField38.setBorder(null);

        jTextField39.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTextField39.setColumns(16);
        jTextField39.setEditable(false);
        jTextField39.setBorder(null);

        jLabel31.setText("Not Ready Code:");

        jLabel33.setText("Voice Terminal:");

        jTable5.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable5.setGridColor(new java.awt.Color(255, 255, 255));
        jTable5.setShowHorizontalLines(false);
        jTable5.setShowVerticalLines(false);
        jTable5.getTableHeader().setReorderingAllowed(false);
        jScrollPane14.setViewportView(jTable5);
        jTable5.getColumnModel().getColumn(0).setResizable(false);
        jTable5.getColumnModel().getColumn(1).setResizable(false);

        jTextField40.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTextField40.setColumns(16);
        jTextField40.setEditable(false);
        jTextField40.setBorder(null);

        jTable3.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null},
                {null},
                {null}
            },
            new String [] {
                "ContactTypes"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable3.setGridColor(new java.awt.Color(255, 255, 255));
        jTable3.setShowHorizontalLines(false);
        jTable3.setShowVerticalLines(false);
        jScrollPane21.setViewportView(jTable3);

        org.jdesktop.layout.GroupLayout jPanel7Layout = new org.jdesktop.layout.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 139, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jScrollPane21, 0, 0, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel15)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel7Layout.createSequentialGroup()
                        .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(jLabel33, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(jLabel31, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel13)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel14)
                            .add(jLabel11, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 88, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(jTextField8, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                            .add(jTextField18, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                            .add(jTextField12, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                            .add(jTextField13, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                            .add(jTextField38, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                            .add(jTextField39, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel7Layout.createSequentialGroup()
                        .add(jLabel12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 86, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(6, 6, 6)
                        .add(jTextField40, 0, 0, Short.MAX_VALUE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane14, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 152, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane14, 0, 0, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel7Layout.createSequentialGroup()
                        .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel11)
                            .add(jTextField18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel13)
                            .add(jTextField8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel14)
                            .add(jTextField12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel15)
                            .add(jTextField13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel31)
                            .add(jTextField38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel33)
                            .add(jTextField39, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel12)
                            .add(jTextField40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel7Layout.createSequentialGroup()
                        .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jScrollPane21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 71, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(23, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame4Layout = new org.jdesktop.layout.GroupLayout(jFrame4.getContentPane());
        jFrame4.getContentPane().setLayout(jFrame4Layout);
        jFrame4Layout.setHorizontalGroup(
            jFrame4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame4Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 526, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame4Layout.setVerticalGroup(
            jFrame4Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame4Layout.createSequentialGroup()
                .add(jPanel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 213, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame5.setTitle("Contact Capabilities");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder("Contact Details"));
        jPanel8.setPreferredSize(new java.awt.Dimension(225, 160));

        jScrollPane8.setViewportView(jTree3);

        jLabel19.setForeground(java.awt.SystemColor.activeCaption);
        jLabel19.setText("Connection Detail:");

        jLabel21.setText("Current State:");

        jLabel22.setText("Previous State:");

        jLabel23.setText("Permissions:");

        jLabel24.setText("Type:");

        jLabel25.setText("Current State");

        jLabel26.setText("Permissions:");

        jLabel27.setForeground(java.awt.SystemColor.activeCaption);
        jLabel27.setText("Contact Detail:");

        jLabel28.setText("Called Address:");

        jLabel29.setText("Calling Address:");

        jLabel30.setText("Calling Terminal:");

        jLabel32.setText("State Reason:");

        jLabel34.setText("Treatment:");

        jLabel36.setForeground(java.awt.SystemColor.activeCaption);
        jLabel36.setText("Terminal Connection Detail:");

        jLabel35.setText("State Reson:");

        jLabel37.setText("Type:");

        jLabel38.setText("Previous State:");

        jTextField7.setEditable(false);

        jTextField19.setEditable(false);

        jTextField20.setEditable(false);

        jTextField21.setEditable(false);

        jTextField22.setEditable(false);

        jTextField24.setEditable(false);

        jTextField25.setEditable(false);

        jTextField26.setEditable(false);

        jTextField27.setEditable(false);

        jTextField28.setEditable(false);

        jTextField29.setEditable(false);

        jTextField30.setEditable(false);

        jTextField31.setEditable(false);

        jTextField32.setEditable(false);

        jTextField33.setEditable(false);

        jTextField34.setEditable(false);

        jTextField48.setEditable(false);

        jTextField49.setEditable(false);

        jTextField50.setEditable(false);

        jTextField51.setEditable(false);

        jLabel48.setText("Conference Consult:");

        jLabel49.setText("Transfer Consult:");

        jLabel50.setText("ContactType:");

        jTextField52.setEditable(false);

        jTextField53.setEditable(false);

        jTextField54.setEditable(false);

        jTextField55.setEditable(false);

        jLabel51.setText("Redirected Addr:");

        jLabel52.setText("Original Dest:");

        jLabel53.setText("Data:");

        jLabel54.setText("UUI:");

        jLabel55.setText("Contact Types:");

        jTable6.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable6.setGridColor(new java.awt.Color(255, 255, 255));
        jTable6.setShowHorizontalLines(false);
        jTable6.setShowVerticalLines(false);
        jTable6.getTableHeader().setReorderingAllowed(false);
        jScrollPane10.setViewportView(jTable6);
        jTable6.getColumnModel().getColumn(0).setResizable(false);
        jTable6.getColumnModel().getColumn(1).setResizable(false);

        jTable7.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable7.setGridColor(new java.awt.Color(255, 255, 255));
        jTable7.setShowHorizontalLines(false);
        jTable7.setShowVerticalLines(false);
        jTable7.getTableHeader().setReorderingAllowed(false);
        jScrollPane15.setViewportView(jTable7);
        jTable7.getColumnModel().getColumn(0).setResizable(false);
        jTable7.getColumnModel().getColumn(1).setResizable(false);

        jTable8.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable8.setGridColor(new java.awt.Color(255, 255, 255));
        jTable8.setShowHorizontalLines(false);
        jTable8.setShowVerticalLines(false);
        jTable8.getTableHeader().setReorderingAllowed(false);
        jScrollPane16.setViewportView(jTable8);
        jTable8.getColumnModel().getColumn(0).setResizable(false);
        jTable8.getColumnModel().getColumn(1).setResizable(false);

        org.jdesktop.layout.GroupLayout jPanel8Layout = new org.jdesktop.layout.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel8Layout.createSequentialGroup()
                .add(jScrollPane8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 139, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel8Layout.createSequentialGroup()
                        .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel19)
                            .add(jLabel24)
                            .add(jLabel35)
                            .add(jLabel22)
                            .add(jLabel25)
                            .add(jLabel26)
                            .add(jLabel34)
                            .add(jLabel37)
                            .add(jLabel21)
                            .add(jLabel38)
                            .add(jLabel32)
                            .add(jLabel23)
                            .add(jLabel48)
                            .add(jLabel49)
                            .add(jLabel28)
                            .add(jLabel27)
                            .add(jLabel29)
                            .add(jLabel30)
                            .add(jLabel50)
                            .add(jLabel51)
                            .add(jLabel52)
                            .add(jLabel53)
                            .add(jLabel54)
                            .add(jLabel55))
                        .add(45, 45, 45)
                        .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel8Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jTextField26, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField27, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField28, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField29, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jTextField30, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField49, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField50, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField51, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField31, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField32, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField33, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField34, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jTextField52, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jTextField53, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField54, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jTextField55, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                                    .add(jComboBox4, 0, 155, Short.MAX_VALUE)))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField48, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField24, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField22, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField21, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField20, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField19, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel8Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(jTextField25, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 155, Short.MAX_VALUE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                    .add(jLabel36))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane10, 0, 0, Short.MAX_VALUE)
                    .add(jScrollPane15, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
                    .add(jScrollPane16, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel8Layout.createSequentialGroup()
                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel8Layout.createSequentialGroup()
                        .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jPanel8Layout.createSequentialGroup()
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel19)
                                    .add(jTextField7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel24)
                                    .add(jTextField19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel25)
                                    .add(jTextField20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel22)
                                    .add(jTextField21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel35)
                                    .add(jTextField22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel26)
                                    .add(jTextField24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel34)
                                    .add(jTextField48, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(jScrollPane16, 0, 0, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel8Layout.createSequentialGroup()
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel36)
                                    .add(jTextField25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel37))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel21))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel38))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel32))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel23))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField49, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel48))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel49))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField51, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel50)))
                            .add(jScrollPane15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 218, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel8Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField31, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel27))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField32, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel28))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel29))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField34, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel30))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField52, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel51))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField53, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel52))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField54, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel53))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jTextField55, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel54))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel55)
                                    .add(jComboBox4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(jPanel8Layout.createSequentialGroup()
                                .add(7, 7, 7)
                                .add(jScrollPane10, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE))))
                    .add(jScrollPane8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 394, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout jFrame5Layout = new org.jdesktop.layout.GroupLayout(jFrame5.getContentPane());
        jFrame5.getContentPane().setLayout(jFrame5Layout);
        jFrame5Layout.setHorizontalGroup(
            jFrame5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 613, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(30, Short.MAX_VALUE))
        );
        jFrame5Layout.setVerticalGroup(
            jFrame5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 680, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame6.setTitle("Fatal Error");
        jFrame3.setSize(new Dimension(310, 200));

        jPanel9.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel9.setToolTipText("Enter data to be attached");
        jPanel9.setPreferredSize(new java.awt.Dimension(225, 160));

        jButton19.setText("OK");
        jButton19.setToolTipText("OK");
        jButton19.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton19ActionPerformed(evt);
            }
        });

        jTextArea2.setColumns(20);
        jTextArea2.setFont(new java.awt.Font("Times New Roman", 0, 12));
        jTextArea2.setRows(5);
        jTextArea2.setText(" Fatal System Error:\n Connection to CCT has been lost\n RefClient must shutdown immediately");
        jTextArea2.setAutoscrolls(false);
        jScrollPane11.setViewportView(jTextArea2);

        org.jdesktop.layout.GroupLayout jPanel9Layout = new org.jdesktop.layout.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel9Layout.createSequentialGroup()
                .add(21, 21, 21)
                .add(jScrollPane11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 219, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(18, Short.MAX_VALUE))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel9Layout.createSequentialGroup()
                .addContainerGap(93, Short.MAX_VALUE)
                .add(jButton19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(90, 90, 90))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 61, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jButton19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame6Layout = new org.jdesktop.layout.GroupLayout(jFrame6.getContentPane());
        jFrame6.getContentPane().setLayout(jFrame6Layout);
        jFrame6Layout.setHorizontalGroup(
            jFrame6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame6Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 262, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame6Layout.setVerticalGroup(
            jFrame6Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame6Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 123, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame7.setTitle("About CCT Ref Client");
        jFrame3.setSize(new Dimension(310, 200));

        jPanel13.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel13.setPreferredSize(new java.awt.Dimension(225, 160));

        jTextPane1.setText("SOA Version 8.3.02.005");
        jScrollPane3.setViewportView(jTextPane1);

        jTextPane3.setText("Avaya CCT Reference Client");
        jScrollPane7.setViewportView(jTextPane3);

        org.jdesktop.layout.GroupLayout jPanel13Layout = new org.jdesktop.layout.GroupLayout(jPanel13);
        jPanel13.setLayout(jPanel13Layout);
        jPanel13Layout.setHorizontalGroup(
            jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel13Layout.createSequentialGroup()
                .add(jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel13Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel13Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(jScrollPane7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(12, Short.MAX_VALUE))
        );
        jPanel13Layout.setVerticalGroup(
            jPanel13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel13Layout.createSequentialGroup()
                .add(7, 7, 7)
                .add(jScrollPane7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame7Layout = new org.jdesktop.layout.GroupLayout(jFrame7.getContentPane());
        jFrame7.getContentPane().setLayout(jFrame7Layout);
        jFrame7Layout.setHorizontalGroup(
            jFrame7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame7Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel13, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 169, Short.MAX_VALUE)
                .addContainerGap())
        );
        jFrame7Layout.setVerticalGroup(
            jFrame7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame7Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jMenuItem22.setText("Agent Login");
        jMenuItem22.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem22ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem22);

        jMenuItem23.setText("Agent Logout");
        jMenuItem23.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem23ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem23);

        jMenuItem24.setText("Ready");
        jMenuItem24.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem24ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem24);

        jMenuItem25.setText("Not Ready");
        jMenuItem25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem25ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem25);

        jMenuItem26.setText("Not Ready with Reason");
        jMenuItem26.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem26ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem26);

        jFrame8.setTitle("Agent Login");
        jFrame2.setSize(new Dimension(270, 170));

        jPanel10.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel10.setPreferredSize(new java.awt.Dimension(225, 160));

        jLabel56.setText("Agent ID");

        jLabel57.setText("Password");

        jButton17.setText("Login");
        jButton17.setToolTipText("Login Agent");
        jButton17.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton17ActionPerformed(evt);
            }
        });

        jButton18.setText("Cancel");
        jButton18.setToolTipText("Cancel Login");
        jButton18.setDefaultCapable(false);
        jButton18.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton18ActionPerformed(evt);
            }
        });

        jComboBox6.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Ready", "Not Ready" }));

        jLabel58.setText("State");
        jLabel58.setToolTipText("Agent Ready State");

        jTextField57.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField57ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel10Layout = new org.jdesktop.layout.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(jLabel56)
                        .add(jLabel57))
                    .add(jLabel58))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel10Layout.createSequentialGroup()
                        .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jComboBox6, 0, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jButton17, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jTextField57, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                    .add(jPasswordField3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel56)
                    .add(jTextField57, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel57)
                    .add(jPasswordField3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel58)
                    .add(jComboBox6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton17, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame8Layout = new org.jdesktop.layout.GroupLayout(jFrame8.getContentPane());
        jFrame8.getContentPane().setLayout(jFrame8Layout);
        jFrame8Layout.setHorizontalGroup(
            jFrame8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame8Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 232, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame8Layout.setVerticalGroup(
            jFrame8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame8Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 129, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame9.setTitle("Server Settings");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel11.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel11.setPreferredSize(new java.awt.Dimension(225, 160));

        jLabel59.setText("Address");

        jLabel60.setText("Port");

        jButton29.setText("OK");
        jButton29.setToolTipText("Apply Server Endpoint Settings");
        jButton29.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton29.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton29ActionPerformed(evt);
            }
        });

        jButton30.setText("Cancel");
        jButton30.setToolTipText("Cancel Server Settings Change");
        jButton30.setDefaultCapable(false);
        jButton30.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton30.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton30ActionPerformed(evt);
            }
        });

        httpRadioButton.setText("http");

        httpsRadioButton.setText("https");

        jLabel1.setText("Client restart required");

        org.jdesktop.layout.GroupLayout jPanel11Layout = new org.jdesktop.layout.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel59)
                    .add(jLabel60))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jPanel11Layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(httpRadioButton)
                        .add(18, 18, 18)
                        .add(httpsRadioButton))
                    .add(jTextField58)
                    .add(jTextField23)
                    .add(jPanel11Layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel1)
                            .add(jPanel11Layout.createSequentialGroup()
                                .add(jButton29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jButton30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel59)
                    .add(jTextField23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel60)
                    .add(jTextField58, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(httpRadioButton)
                    .add(httpsRadioButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jButton30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton29, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 17, Short.MAX_VALUE)
                .add(jLabel1)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout jFrame9Layout = new org.jdesktop.layout.GroupLayout(jFrame9.getContentPane());
        jFrame9.getContentPane().setLayout(jFrame9Layout);
        jFrame9Layout.setHorizontalGroup(
            jFrame9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame9Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 223, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame9Layout.setVerticalGroup(
            jFrame9Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame9Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel11, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                .addContainerGap())
        );

        jMenuItem27.setText("Supervised Transfer");
        jMenuItem27.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem27ActionPerformed(evt);
            }
        });
        jPopupMenu2.add(jMenuItem27);

        jMenuItem28.setText("Blind Transfer");
        jMenuItem28.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem28ActionPerformed(evt);
            }
        });
        jPopupMenu2.add(jMenuItem28);

        jMenuItem29.setText("Ready");
        jMenuItem29.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem29ActionPerformed(evt);
            }
        });
        jPopupMenu3.add(jMenuItem29);

        jMenuItem30.setText("Not Ready");
        jMenuItem30.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem30ActionPerformed(evt);
            }
        });
        jPopupMenu3.add(jMenuItem30);

        jMenuItem31.setText("Not Ready With Reason");
        jMenuItem31.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem31ActionPerformed(evt);
            }
        });
        jPopupMenu3.add(jMenuItem31);

        jFrame10.setTitle("Enter Not Ready Reason");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel12.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel12.setPreferredSize(new java.awt.Dimension(225, 160));

        jLabel61.setText("Not Ready Reason");

        jButton34.setText("OK");
        jButton34.setToolTipText("Set to Not Ready");
        jButton34.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton34.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton34ActionPerformed(evt);
            }
        });

        jButton35.setText("Cancel");
        jButton35.setToolTipText("Cancel");
        jButton35.setDefaultCapable(false);
        jButton35.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton35.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton35ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel12Layout = new org.jdesktop.layout.GroupLayout(jPanel12);
        jPanel12.setLayout(jPanel12Layout);
        jPanel12Layout.setHorizontalGroup(
            jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel12Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jTextField56)
                    .add(jLabel61, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(18, 18, 18)
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jButton35, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jButton34, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel12Layout.setVerticalGroup(
            jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel12Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel61)
                    .add(jButton34, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextField56, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton35, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame10Layout = new org.jdesktop.layout.GroupLayout(jFrame10.getContentPane());
        jFrame10.getContentPane().setLayout(jFrame10Layout);
        jFrame10Layout.setHorizontalGroup(
            jFrame10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame10Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 207, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame10Layout.setVerticalGroup(
            jFrame10Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame10Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 82, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jMenuItem32.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem32ActionPerformed(evt);
            }
        });
        jPopupMenu4.add(jMenuItem32);

        jMenuItem33.setText("Set / Change");
        jMenuItem33.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem33ActionPerformed(evt);
            }
        });
        jPopupMenu4.add(jMenuItem33);

        jMenuItem34.setText("Clear");
        jMenuItem34.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem34ActionPerformed(evt);
            }
        });
        jPopupMenu4.add(jMenuItem34);

        jFrame11.setTitle("Enter Activity Code");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel14.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel14.setPreferredSize(new java.awt.Dimension(225, 160));

        jLabel62.setText("Activity Code");

        jButton36.setText("OK");
        jButton36.setToolTipText("Set Activity Code");
        jButton36.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton36.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton36ActionPerformed(evt);
            }
        });

        jButton37.setText("Cancel");
        jButton37.setToolTipText("Cancel");
        jButton37.setDefaultCapable(false);
        jButton37.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton37.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton37ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel14Layout = new org.jdesktop.layout.GroupLayout(jPanel14);
        jPanel14.setLayout(jPanel14Layout);
        jPanel14Layout.setHorizontalGroup(
            jPanel14Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel14Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel14Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jTextField59)
                    .add(jLabel62, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(18, 18, 18)
                .add(jPanel14Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jButton37, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jButton36, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel14Layout.setVerticalGroup(
            jPanel14Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel14Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel14Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel62)
                    .add(jButton36, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel14Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextField59, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame11Layout = new org.jdesktop.layout.GroupLayout(jFrame11.getContentPane());
        jFrame11.getContentPane().setLayout(jFrame11Layout);
        jFrame11Layout.setHorizontalGroup(
            jFrame11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame11Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 181, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame11Layout.setVerticalGroup(
            jFrame11Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame11Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 82, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jMenuItem35.setText("Keypad Mode");
        jMenuItem35.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem35ActionPerformed(evt);
            }
        });
        jPopupMenu5.add(jMenuItem35);

        jMenuItem36.setText("String Mode");
        jMenuItem36.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem36ActionPerformed(evt);
            }
        });
        jPopupMenu5.add(jMenuItem36);

        jMenuItem37.setText("Set / Change Forwarding Instructions");
        jMenuItem37.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem37ActionPerformed(evt);
            }
        });
        jPopupMenu6.add(jMenuItem37);

        jMenuItem38.setText("Cancel Forwarding");
        jMenuItem38.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem38ActionPerformed(evt);
            }
        });
        jPopupMenu6.add(jMenuItem38);

        jFrame1.setSize(new Dimension(270, 170));

        jPanel15.setBorder(javax.swing.BorderFactory.createTitledBorder("Forwarding Rules"));
        jPanel15.setPreferredSize(new java.awt.Dimension(225, 160));

        jLabel63.setText("Condition");

        jLabel65.setText("Filter");

        jLabel66.setText("From");

        jLabel67.setText("Forward To");

        jTextField60.setColumns(16);

        jTextField67.setColumns(16);
        jTextField67.setDisabledTextColor(new java.awt.Color(255, 255, 255));

        jComboBox7.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Always", "On Busy", "On No Answer" }));

        jTable4.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Condition", "Filter", "From", "Forward To"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable4.setGridColor(new java.awt.Color(255, 255, 255));
        jTable4.setShowHorizontalLines(false);
        jTable4.setShowVerticalLines(false);
        jTable4.getTableHeader().setReorderingAllowed(false);
        jScrollPane9.setViewportView(jTable4);
        jTable4.getColumnModel().getColumn(0).setResizable(false);
        jTable4.getColumnModel().getColumn(1).setResizable(false);
        jTable4.getColumnModel().getColumn(2).setResizable(false);
        jTable4.getColumnModel().getColumn(3).setResizable(false);

        jComboBox8.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "All", "Internal", "External", "Specific Address" }));

        jButton38.setText("Add Rule");
        jButton38.setToolTipText("Add Rule");
        jButton38.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton38ActionPerformed(evt);
            }
        });

        jButton39.setText("Update Rule");
        jButton39.setToolTipText("Update Rule");
        jButton39.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton39ActionPerformed(evt);
            }
        });

        jButton40.setText("Delete Rule");
        jButton40.setToolTipText("Delete Rule");
        jButton40.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton40ActionPerformed(evt);
            }
        });

        jButton41.setText("OK");
        jButton41.setToolTipText("Apply Forwarding Rule(s)");
        jButton41.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton41ActionPerformed(evt);
            }
        });

        jButton42.setText("Cancel");
        jButton42.setToolTipText("Cancel Forwarding Rules Update");
        jButton42.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton42ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel15Layout = new org.jdesktop.layout.GroupLayout(jPanel15);
        jPanel15.setLayout(jPanel15Layout);
        jPanel15Layout.setHorizontalGroup(
            jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel15Layout.createSequentialGroup()
                .add(jButton38)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton39)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton40)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton41, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton42)
                .addContainerGap())
            .add(jPanel15Layout.createSequentialGroup()
                .add(jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane9, 0, 0, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel15Layout.createSequentialGroup()
                        .add(jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel15Layout.createSequentialGroup()
                                .add(jComboBox7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jComboBox8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jTextField67, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 93, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(jPanel15Layout.createSequentialGroup()
                                .add(99, 99, 99)
                                .add(jLabel65)
                                .add(84, 84, 84)
                                .add(jLabel66))
                            .add(jLabel63, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 55, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel67)
                            .add(jTextField60, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 97, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(111, 111, 111))
        );
        jPanel15Layout.setVerticalGroup(
            jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel15Layout.createSequentialGroup()
                .add(jScrollPane9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel65)
                    .add(jLabel66)
                    .add(jLabel63)
                    .add(jLabel67))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jComboBox7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jComboBox8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTextField67, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTextField60, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton38)
                    .add(jButton39)
                    .add(jButton40)
                    .add(jButton41)
                    .add(jButton42))
                .add(52, 52, 52))
        );

        org.jdesktop.layout.GroupLayout jFrame12Layout = new org.jdesktop.layout.GroupLayout(jFrame12.getContentPane());
        jFrame12.getContentPane().setLayout(jFrame12Layout);
        jFrame12Layout.setHorizontalGroup(
            jFrame12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame12Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel15, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 426, Short.MAX_VALUE))
        );
        jFrame12Layout.setVerticalGroup(
            jFrame12Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame12Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 193, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame13.setTitle("Enter DTMF Digits");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel16.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel16.setPreferredSize(new java.awt.Dimension(225, 160));

        jLabel64.setText("DTMF Generation");

        jButton43.setText("OK");
        jButton43.setToolTipText("Generate DTMF");
        jButton43.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton43.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton43ActionPerformed(evt);
            }
        });

        jButton44.setText("Cancel");
        jButton44.setToolTipText("Cancel");
        jButton44.setDefaultCapable(false);
        jButton44.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton44.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton44ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel16Layout = new org.jdesktop.layout.GroupLayout(jPanel16);
        jPanel16.setLayout(jPanel16Layout);
        jPanel16Layout.setHorizontalGroup(
            jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel16Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jTextField61)
                    .add(jLabel64, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(18, 18, 18)
                .add(jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jButton44, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jButton43, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(17, Short.MAX_VALUE))
        );
        jPanel16Layout.setVerticalGroup(
            jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel16Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel64)
                    .add(jButton43, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextField61, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton44, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame13Layout = new org.jdesktop.layout.GroupLayout(jFrame13.getContentPane());
        jFrame13.getContentPane().setLayout(jFrame13Layout);
        jFrame13Layout.setHorizontalGroup(
            jFrame13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame13Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 207, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame13Layout.setVerticalGroup(
            jFrame13Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame13Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 82, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame14.setTitle("Event Log");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel17.setBorder(javax.swing.BorderFactory.createTitledBorder("Notifications"));
        jPanel17.setPreferredSize(new java.awt.Dimension(225, 160));

        jTextArea3.setColumns(20);
        jTextArea3.setRows(5);
        jScrollPane12.setViewportView(jTextArea3);

        org.jdesktop.layout.GroupLayout jPanel17Layout = new org.jdesktop.layout.GroupLayout(jPanel17);
        jPanel17.setLayout(jPanel17Layout);
        jPanel17Layout.setHorizontalGroup(
            jPanel17Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel17Layout.createSequentialGroup()
                .add(jScrollPane12, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 631, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel17Layout.setVerticalGroup(
            jPanel17Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel17Layout.createSequentialGroup()
                .add(jScrollPane12, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 248, Short.MAX_VALUE)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout jFrame14Layout = new org.jdesktop.layout.GroupLayout(jFrame14.getContentPane());
        jFrame14.getContentPane().setLayout(jFrame14Layout);
        jFrame14Layout.setHorizontalGroup(
            jFrame14Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame14Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel17, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 657, Short.MAX_VALUE)
                .addContainerGap())
        );
        jFrame14Layout.setVerticalGroup(
            jFrame14Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame14Layout.createSequentialGroup()
                .add(jPanel17, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 289, Short.MAX_VALUE)
                .addContainerGap())
        );

        jFrame15.setTitle("Capabilities");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel18.setBorder(javax.swing.BorderFactory.createTitledBorder("Device Details"));
        jPanel18.setPreferredSize(new java.awt.Dimension(225, 160));

        jScrollPane17.setViewportView(jTree4);

        jLabel70.setText("Terminal Detail:");

        jLabel71.setText("Address Detail:");

        jLabel72.setText("Type:");

        jLabel73.setText("State:");

        jLabel74.setText("Permission:");

        jLabel75.setText("Type:");

        jLabel76.setText("State:");

        jLabel77.setText("Permission:");

        jTextField62.setColumns(16);
        jTextField62.setEditable(false);

        jTextField63.setColumns(16);
        jTextField63.setEditable(false);

        jTextField64.setColumns(16);
        jTextField64.setEditable(false);

        jTextField65.setColumns(16);
        jTextField65.setEditable(false);

        jTextField66.setColumns(16);
        jTextField66.setEditable(false);

        jTextField68.setColumns(16);
        jTextField68.setEditable(false);

        jTextField69.setColumns(16);
        jTextField69.setEditable(false);

        jTextField70.setColumns(16);
        jTextField70.setEditable(false);

        jTextField71.setColumns(16);
        jTextField71.setEditable(false);

        jTextField72.setColumns(16);
        jTextField72.setEditable(false);

        jTextField73.setColumns(16);
        jTextField73.setEditable(false);

        jTextField74.setColumns(16);
        jTextField74.setEditable(false);

        jTextField75.setColumns(16);
        jTextField75.setEditable(false);

        jTextField76.setColumns(16);
        jTextField76.setEditable(false);

        jLabel78.setText("Do Not Disturb:");

        jLabel79.setText("Is Forwarded:");

        jLabel80.setText("Agent Login ID:");

        jLabel81.setText("Is Ready:");

        jLabel82.setText("Not Ready Code:");

        jLabel83.setText("Do Not Disturb:");

        jLabel84.setText("Contact Type(s):");
                       
        jTextField77.setColumns(16);
        jTextField77.setEditable(false);

        jTextField78.setColumns(16);
        jTextField78.setEditable(false);

        jLabel85.setText("Is Forwarded:");

        jLabel86.setText("Message Waiting:");

        jTextField79.setColumns(16);
        jTextField79.setEditable(false);

        jLabel87.setText("Activity Code:");

        jTextField80.setColumns(16);
        jTextField80.setEditable(false);

        jLabel88.setText("Is Controlled:");

        jTable9.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable9.setGridColor(new java.awt.Color(255, 255, 255));
        jTable9.setShowHorizontalLines(false);
        jTable9.setShowVerticalLines(false);
        jTable9.getTableHeader().setReorderingAllowed(false);
        jScrollPane18.setViewportView(jTable9);
        jTable9.getColumnModel().getColumn(0).setResizable(false);
        jTable9.getColumnModel().getColumn(1).setResizable(false);

        jTable10.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable10.setGridColor(new java.awt.Color(255, 255, 255));
        jTable10.setShowHorizontalLines(false);
        jTable10.setShowVerticalLines(false);
        jTable10.getTableHeader().setReorderingAllowed(false);
        jScrollPane19.setViewportView(jTable10);
        jTable10.getColumnModel().getColumn(0).setResizable(false);
        jTable10.getColumnModel().getColumn(1).setResizable(false);

        org.jdesktop.layout.GroupLayout jPanel18Layout = new org.jdesktop.layout.GroupLayout(jPanel18);
        jPanel18.setLayout(jPanel18Layout);
        jPanel18Layout.setHorizontalGroup(
            jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel18Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane17, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 139, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel18Layout.createSequentialGroup()
                        .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel18Layout.createSequentialGroup()
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel88, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel83, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel71, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 86, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel85, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel86, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                    .add(jLabel76)
                                    .add(jLabel75))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(jTextField68, 0, 0, Short.MAX_VALUE)
                                    .add(jTextField80, 0, 0, Short.MAX_VALUE)
                                    .add(jTextField78, 0, 0, Short.MAX_VALUE)
                                    .add(jTextField77, 0, 0, Short.MAX_VALUE)
                                    .add(jTextField76, 0, 0, Short.MAX_VALUE)
                                    .add(jTextField69, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 103, Short.MAX_VALUE)
                                    .add(jTextField66, 0, 0, Short.MAX_VALUE)
                                    .add(jTextField65, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 103, Short.MAX_VALUE)))
                            .add(jLabel77))
                        .add(18, 18, 18)
                        .add(jScrollPane18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 128, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel18Layout.createSequentialGroup()
                        .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel74)
                            .add(jPanel18Layout.createSequentialGroup()
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                        .add(jLabel82, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(jLabel81, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(jLabel80, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(jLabel79, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(jLabel78, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel72)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel73)
                                        .add(jLabel70, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 88, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel87, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                    .add(jLabel84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 82, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jTextField75, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 97, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                        .add(jTextField62, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                                        .add(jTextField70, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                                        .add(jTextField63, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                                        .add(jTextField64, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                                        .add(jTextField71, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                                        .add(jTextField72, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                                        .add(jTextField73, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                                        .add(jTextField74, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE)
                                        .add(jTextField79, 0, 0, Short.MAX_VALUE)
                                        .add(jComboBox10, 97, 97, 97)))))
                        .add(18, 18, 18)
                        .add(jScrollPane19, 0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel18Layout.setVerticalGroup(
            jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel18Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane17, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 514, Short.MAX_VALUE)
                    .add(jPanel18Layout.createSequentialGroup()
                        .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel18Layout.createSequentialGroup()
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel70)
                                    .add(jTextField70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel72)
                                    .add(jTextField62, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel73)
                                    .add(jTextField63, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel74)
                                    .add(jTextField64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel78)
                                    .add(jTextField71, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel79)
                                    .add(jTextField72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel80)
                                    .add(jTextField73, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel81)
                                    .add(jTextField74, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel82)
                                    .add(jTextField75, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel87)
                                    .add(jTextField79, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jComboBox10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jLabel84)))
                            .add(jScrollPane19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 272, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(28, 28, 28)
                        .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel18Layout.createSequentialGroup()
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel71)
                                    .add(jTextField65, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .add(9, 9, 9)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel75)
                                    .add(jTextField66, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel76)
                                    .add(jTextField68, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel77)
                                    .add(jTextField69, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .add(8, 8, 8)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel83)
                                    .add(jTextField76, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel85)
                                    .add(jTextField77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel86)
                                    .add(jTextField78, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jPanel18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(jLabel88)
                                    .add(jTextField80, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(jScrollPane18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 198, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(10, 10, 10)))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout jFrame15Layout = new org.jdesktop.layout.GroupLayout(jFrame15.getContentPane());
        jFrame15.getContentPane().setLayout(jFrame15Layout);
        jFrame15Layout.setHorizontalGroup(
            jFrame15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame15Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 526, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame15Layout.setVerticalGroup(
            jFrame15Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame15Layout.createSequentialGroup()
                .add(jPanel18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 566, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame16.setTitle("UUI");
        jFrame3.setSize(new Dimension(310, 200));

        jPanel19.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel19.setToolTipText("User - User Info (UUI)");
        jPanel19.setPreferredSize(new java.awt.Dimension(225, 160));

        jButton47.setText("Cancel");
        jButton47.setToolTipText("Cancel");
        jButton47.setDefaultCapable(false);
        jButton47.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton47.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton47ActionPerformed(evt);
            }
        });

        jTextArea4.setColumns(20);
        jTextArea4.setLineWrap(true);
        jTextArea4.setRows(5);
        jScrollPane5.setViewportView(jTextArea4);

        jButton48.setText("Update");
        jButton48.setToolTipText("Update UUI");
        jButton48.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton48.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton48ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel19Layout = new org.jdesktop.layout.GroupLayout(jPanel19);
        jPanel19.setLayout(jPanel19Layout);
        jPanel19Layout.setHorizontalGroup(
            jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel19Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 311, Short.MAX_VALUE)
                    .add(jPanel19Layout.createSequentialGroup()
                        .add(jButton48, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton47, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel19Layout.setVerticalGroup(
            jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel19Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane5, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 113, Short.MAX_VALUE)
                .add(18, 18, 18)
                .add(jPanel19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton47, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton48, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout jFrame16Layout = new org.jdesktop.layout.GroupLayout(jFrame16.getContentPane());
        jFrame16.getContentPane().setLayout(jFrame16Layout);
        jFrame16Layout.setHorizontalGroup(
            jFrame16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame16Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 335, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame16Layout.setVerticalGroup(
            jFrame16Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame16Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel19, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 182, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame17.setTitle("Intrinsics");
        jFrame3.setSize(new Dimension(310, 200));

        jPanel20.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel20.setToolTipText("Set Intrinsic Data");
        jPanel20.setPreferredSize(new java.awt.Dimension(225, 160));

        jButton49.setText("Cancel");
        jButton49.setToolTipText("Cancel");
        jButton49.setDefaultCapable(false);
        jButton49.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton49.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton49ActionPerformed(evt);
            }
        });

        jButton50.setText("Done");
        jButton50.setToolTipText("Update Contact Intrinsics");
        jButton50.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton50.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton50ActionPerformed(evt);
            }
        });

        jTable1.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Key", "Value"
            }
        ));
        jScrollPane6.setViewportView(jTable1);

        jButton51.setText("Remove");
        jButton51.setToolTipText("Remove Intrinsics from Contact");
        jButton51.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton51.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton51ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel20Layout = new org.jdesktop.layout.GroupLayout(jPanel20);
        jPanel20.setLayout(jPanel20Layout);
        jPanel20Layout.setHorizontalGroup(
            jPanel20Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel20Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel20Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel20Layout.createSequentialGroup()
                        .add(jButton51, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 80, Short.MAX_VALUE)
                        .add(jButton50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton49, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jScrollPane6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 311, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel20Layout.setVerticalGroup(
            jPanel20Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel20Layout.createSequentialGroup()
                .add(11, 11, 11)
                .add(jScrollPane6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel20Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton49, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton51, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout jFrame17Layout = new org.jdesktop.layout.GroupLayout(jFrame17.getContentPane());
        jFrame17.getContentPane().setLayout(jFrame17Layout);
        jFrame17Layout.setHorizontalGroup(
            jFrame17Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame17Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 335, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame17Layout.setVerticalGroup(
            jFrame17Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame17Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 182, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame18.setTitle("Error");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel21.setBorder(javax.swing.BorderFactory.createTitledBorder("Error Details"));
        jPanel21.setPreferredSize(new java.awt.Dimension(225, 160));

        jTextArea5.setColumns(20);
        jTextArea5.setRows(5);
        jScrollPane20.setViewportView(jTextArea5);

        org.jdesktop.layout.GroupLayout jPanel21Layout = new org.jdesktop.layout.GroupLayout(jPanel21);
        jPanel21.setLayout(jPanel21Layout);
        jPanel21Layout.setHorizontalGroup(
            jPanel21Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel21Layout.createSequentialGroup()
                .add(jScrollPane20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 455, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel21Layout.setVerticalGroup(
            jPanel21Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel21Layout.createSequentialGroup()
                .add(jScrollPane20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 124, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame18Layout = new org.jdesktop.layout.GroupLayout(jFrame18.getContentPane());
        jFrame18.getContentPane().setLayout(jFrame18Layout);
        jFrame18Layout.setHorizontalGroup(
            jFrame18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame18Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 481, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame18Layout.setVerticalGroup(
            jFrame18Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame18Layout.createSequentialGroup()
                .add(jPanel21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 165, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jFrame19.setTitle("Enter Not Ready Reason");
        jFrame1.setSize(new Dimension(270, 170));

        jPanel25.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel25.setPreferredSize(new java.awt.Dimension(225, 160));

        jLabel69.setText("Not Ready Reason");

        jButton46.setText("OK");
        jButton46.setToolTipText("Set to Not Ready");
        jButton46.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton46.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton46ActionPerformed(evt);
            }
        });

        jButton52.setText("Cancel");
        jButton52.setToolTipText("Cancel");
        jButton52.setDefaultCapable(false);
        jButton52.setPreferredSize(new java.awt.Dimension(75, 25));
        jButton52.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton52ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel25Layout = new org.jdesktop.layout.GroupLayout(jPanel25);
        jPanel25.setLayout(jPanel25Layout);
        jPanel25Layout.setHorizontalGroup(
            jPanel25Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel25Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel25Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jTextField81)
                    .add(jLabel69, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .add(18, 18, 18)
                .add(jPanel25Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jButton52, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(jButton46, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel25Layout.setVerticalGroup(
            jPanel25Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel25Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel25Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel69)
                    .add(jButton46, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel25Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jTextField81, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton52, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout jFrame19Layout = new org.jdesktop.layout.GroupLayout(jFrame19.getContentPane());
        jFrame19.getContentPane().setLayout(jFrame19Layout);
        jFrame19Layout.setHorizontalGroup(
            jFrame19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame19Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 207, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame19Layout.setVerticalGroup(
            jFrame19Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jFrame19Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 82, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jMenu17.setText("File");
        jMenuBar5.add(jMenu17);

        jMenu18.setText("Edit");
        jMenuBar5.add(jMenu18);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("SOA Reference Client");
        setResizable(false);

        jAgentStatusPanel.setBorder(createBorder("Agent Status"));
        jAgentStatusPanel.setToolTipText("Agent Status");

        jTextField2.setBackground(new java.awt.Color(204, 204, 204));

        jButton6.setToolTipText("Agent Login to Terminal");
        jButton6.setActionCommand("Agent Login >>");
        jButton6.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jButton6.setLabel("Agent Login >>");
        jButton6.setPreferredSize(new java.awt.Dimension(120, 25));
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        jButton7.setText("Ready Status >>");
        jButton7.setToolTipText("Toggle Ready Status");
        jButton7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jButton7.setPreferredSize(new java.awt.Dimension(120, 25));
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        jComboBox3.setMinimumSize(new java.awt.Dimension(18, 18));

        jTextField36.setBackground(new java.awt.Color(204, 204, 204));

        jButton21.setText("Pull Contact >>");
        jButton21.setToolTipText("");
        jButton21.setEnabled(false);
        jButton21.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jButton21.setPreferredSize(new java.awt.Dimension(120, 25));
        jButton21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton21ActionPerformed(evt);
            }
        });

        jCheckBox1.setText("Represent Human Agent");

        org.jdesktop.layout.GroupLayout jAgentStatusPanelLayout = new org.jdesktop.layout.GroupLayout(jAgentStatusPanel);
        jAgentStatusPanel.setLayout(jAgentStatusPanelLayout);
        jAgentStatusPanelLayout.setHorizontalGroup(
        		jAgentStatusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jAgentStatusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jAgentStatusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jButton7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jAgentStatusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jTextField2)
                    .add(jComboBox3, 0, 66, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jAgentStatusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jTextField36)
                    .add(jButton21, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 109, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jAgentStatusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(jTextField37)
                    .add(jCheckBox1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(36, Short.MAX_VALUE))
        );
        jAgentStatusPanelLayout.setVerticalGroup(
        		jAgentStatusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jAgentStatusPanelLayout.createSequentialGroup()
            	.addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(jAgentStatusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jComboBox3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTextField36, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jCheckBox1))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jAgentStatusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTextField2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jTextField37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jInitiateContactsPanel.setBorder(createBorder("Initiate Contacts"));
        originateButton.setText("Originate >>");
        originateButton.setToolTipText("Make a Call");
        originateButton.setEnabled(false);
        originateButton.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        originateButton.setPreferredSize(new java.awt.Dimension(100, 25));

        DefaultMutableTreeNode root = new DefaultMutableTreeNode(ROOT);
        DefaultTreeModel model = new DefaultTreeModel(root);
        jTree1 = new JTree(model);
        jTree1.setRootVisible(false);
        jTree1.setShowsRootHandles(true);
        jScrollPane1.setViewportView(jTree1);
        jTextField10.setBackground(new java.awt.Color(204, 204, 204));
        jTextField10.setEditable(false);

        jLabel3.setText("Origination Terminal / Address");

        jTextField11.setBackground(new java.awt.Color(204, 204, 204));
        jTextField11.setEditable(false);
        
        jButton20.setToolTipText("Call a Supervisor");
        jButton20.setEnabled(false);
        jButton20.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jButton20.setLabel("Call Supervisor");
        jButton20.setPreferredSize(new java.awt.Dimension(120, 25));
        jButton20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton20ActionPerformed(evt);
            }
        });

        jLabel9.setText("Terminal / Address State");

        jLabel10.setText("Available Devices");

        activityCodeButton.setText("Activity Code");
        activityCodeButton.setToolTipText("");
        activityCodeButton.setEnabled(false);
        activityCodeButton.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        activityCodeButton.setPreferredSize(new java.awt.Dimension(100, 25));
        activityCodeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton22ActionPerformed(evt);
            }
        });

        forwardingButton.setFont(new java.awt.Font("Tahoma", 1, 11));
        forwardingButton.setText("FWD");
        forwardingButton.setToolTipText("Set Forwarding Instructions on Terminal");
        forwardingButton.setEnabled(false);
        forwardingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton23ActionPerformed(evt);
            }
        });

        dndButton.setFont(new java.awt.Font("Tahoma", 1, 11));
        dndButton.setText("DND");
        dndButton.setToolTipText("Toggle Terminal DND Status");
        dndButton.setEnabled(false);
        dndButton.setMaximumSize(new java.awt.Dimension(60, 25));
        dndButton.setMinimumSize(new java.awt.Dimension(60, 25));
        dndButton.setPreferredSize(new java.awt.Dimension(60, 25));
        dndButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton24ActionPerformed(evt);
            }
        });

        jButton25.setFont(new java.awt.Font("Tahoma", 1, 11));
        jButton25.setText("FWD");
        jButton25.setToolTipText("Set Forwarding Instructions on Address");
        jButton25.setEnabled(false);
        jButton25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton25ActionPerformed(evt);
            }
        });

        jButton26.setFont(new java.awt.Font("Tahoma", 1, 11));
        jButton26.setText("DND");
        jButton26.setToolTipText("Toggle Address DND Status");
        jButton26.setEnabled(false);
        jButton26.setMaximumSize(new java.awt.Dimension(60, 25));
        jButton26.setMinimumSize(new java.awt.Dimension(60, 25));
        jButton26.setPreferredSize(new java.awt.Dimension(60, 25));
        jButton26.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton26ActionPerformed(evt);
            }
        });

        jButton27.setFont(new java.awt.Font("Tahoma", 1, 11));
        jButton27.setText("AGT");
        jButton27.setToolTipText("Agent Login / Ready Status");
        jButton27.setEnabled(false);
        jButton27.setMaximumSize(new java.awt.Dimension(59, 23));
        jButton27.setMinimumSize(new java.awt.Dimension(59, 23));
        jButton27.setPreferredSize(new java.awt.Dimension(59, 23));
        jButton27.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton27ActionPerformed(evt);
            }
        });

        jButton28.setFont(new java.awt.Font("Tahoma", 1, 11));
        jButton28.setText("MSG");
        jButton28.setToolTipText("Attach a Message");
        jButton28.setEnabled(false);
        jButton28.setMaximumSize(new java.awt.Dimension(59, 23));
        jButton28.setMinimumSize(new java.awt.Dimension(59, 23));
        jButton28.setPreferredSize(new java.awt.Dimension(59, 23));

        jLabel20.setText("Contact Types");

        org.jdesktop.layout.GroupLayout jInitiateContactsPanelLayout = new org.jdesktop.layout.GroupLayout(jInitiateContactsPanel);
        jInitiateContactsPanel.setLayout(jInitiateContactsPanelLayout);
        jInitiateContactsPanelLayout.setHorizontalGroup(
            jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jInitiateContactsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(jInitiateContactsPanelLayout.createSequentialGroup()
                        .add(jLabel10)
                        .add(42, 42, 42))
                    .add(jInitiateContactsPanelLayout.createSequentialGroup()
                        .add(jLabel20)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jComboBox2, 60, 60 , 60))
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 129, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jInitiateContactsPanelLayout.createSequentialGroup()
                        .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jInitiateContactsPanelLayout.createSequentialGroup()
                                .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(dndButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jButton26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(jButton25)
                                    .add(forwardingButton)))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel9))
                        .add(6, 6, 6)
                        .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jButton27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, activityCodeButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, originateButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)))
                .add(13, 13, 13)
                .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jButton20, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField9)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField11)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jTextField10))
                .addContainerGap())
        );
        jInitiateContactsPanelLayout.setVerticalGroup(
            jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jInitiateContactsPanelLayout.createSequentialGroup()
            	.addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)	
                .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel9)
                    .add(jLabel3)
                    .add(jLabel10))
                .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jInitiateContactsPanelLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jTextField11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(dndButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(forwardingButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jTextField10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                .add(jButton25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(jButton26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(jButton28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jTextField9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(originateButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jScrollPane1, 0, 0, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 8, Short.MAX_VALUE)
                .add(jInitiateContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(activityCodeButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jComboBox2, 18, 18, 18)
                    .add(jLabel20))
                .addContainerGap())
        );

        originateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jCurrentContactsPanel.setBorder(createBorder("Current Contacts"));
        jButton8.setText("Answer");
        jButton8.setToolTipText("Answer selected contact");
        jButton8.setEnabled(false);
        jButton8.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        jButton9.setText("Release");
        jButton9.setToolTipText("Release selected contact");
        jButton9.setEnabled(false);
        jButton9.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });

        jButton10.setText("Hold");
        jButton10.setToolTipText("Hold / Unhold selected contact");
        jButton10.setEnabled(false);
        jButton10.setPreferredSize(new java.awt.Dimension(80, 25));

        jButton11.setText("Transfer");
        jButton11.setToolTipText("Transfer selected contact");
        jButton11.setEnabled(false);
        jButton11.setMaximumSize(new java.awt.Dimension(75, 25));
        jButton11.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });

        jButton12.setText("Init Conf");
        jButton12.setToolTipText("Conference in another party");
        jButton12.setEnabled(false);
        jButton12.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton12ActionPerformed(evt);
            }
        });

        jButton14.setText("Emergency");
        jButton14.setToolTipText("Alert a Supervisor");
        jButton14.setEnabled(false);
        jButton14.setPreferredSize(new java.awt.Dimension(85, 25));
        jButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton14ActionPerformed(evt);
            }
        });

        jButton13.setText("Data");
        jButton13.setToolTipText("Attach data to selected contact");
        jButton13.setEnabled(false);
        jButton13.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton13ActionPerformed(evt);
            }
        });

        jContactsTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null}
            },
            new String [] {
                "Terminal/Addr", "Local", "Remote", "Contact", "Type", "Calling", "Called"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit[columnIndex];
            }
        });
        jContactsTable.setGridColor(new java.awt.Color(255, 255, 255));
        jContactsTable.setShowHorizontalLines(false);
        jContactsTable.setShowVerticalLines(false);
        jContactsTable.getTableHeader().setReorderingAllowed(false);
        jScrollPane13.setViewportView(jContactsTable);
        jContactsTable.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jContactsTable.setFillsViewportHeight(true);
        jContactsTable.getColumnModel().getColumn(0).setResizable(true);
        jContactsTable.getColumnModel().getColumn(0).setPreferredWidth(50);
        jContactsTable.getColumnModel().getColumn(1).setResizable(true);
        jContactsTable.getColumnModel().getColumn(1).setPreferredWidth(35);
        jContactsTable.getColumnModel().getColumn(2).setResizable(true);
        jContactsTable.getColumnModel().getColumn(2).setPreferredWidth(35);
        jContactsTable.getColumnModel().getColumn(3).setResizable(true);
        jContactsTable.getColumnModel().getColumn(3).setPreferredWidth(15);
        jContactsTable.getColumnModel().getColumn(4).setResizable(true);
        jContactsTable.getColumnModel().getColumn(4).setPreferredWidth(10);
        jContactsTable.getColumnModel().getColumn(5).setResizable(true);
        jContactsTable.getColumnModel().getColumn(5).setPreferredWidth(10);
        jContactsTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                ListSelectionModel lsm = (ListSelectionModel)e.getSource();
				initiateButtonUpdate(lsm);
            }
        });

        jButton31.setText("DTMF");
        jButton31.setToolTipText("DTMF");
        jButton31.setEnabled(false);
        jButton31.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton31.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton31ActionPerformed(evt);
            }
        });

        jButton32.setText("UUI");
        jButton32.setToolTipText("UUI");
        jButton32.setEnabled(false);
        jButton32.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton32.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton32ActionPerformed(evt);
            }
        });

        jIntrinsicsButton.setText("Intrinsics");
        jIntrinsicsButton.setToolTipText("Intrinsics");
        jIntrinsicsButton.setEnabled(false);
        jIntrinsicsButton.setPreferredSize(new java.awt.Dimension(85, 25));
        jIntrinsicsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton33ActionPerformed(evt);
            }
        });
        
        org.jdesktop.layout.GroupLayout jCurrentContactsPanelLayout = new org.jdesktop.layout.GroupLayout(jCurrentContactsPanel);
        jCurrentContactsPanel.setLayout(jCurrentContactsPanelLayout);
       
        jCurrentContactsPanelLayout.setHorizontalGroup(
        		jCurrentContactsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
        			.add(jCurrentContactsPanelLayout.createSequentialGroup()
        					.add(jContactPanel))
        			.add(jCurrentContactsPanelLayout.createSequentialGroup()
        					.add(jContactPanelButtons)));
        jCurrentContactsPanelLayout.setVerticalGroup(
        		jCurrentContactsPanelLayout.createSequentialGroup()
        			.add(jContactPanel)
        			.add(jContactPanelButtons));
        	
        org.jdesktop.layout.GroupLayout jContactPanelLayout = new org.jdesktop.layout.GroupLayout(jContactPanel);
        jContactPanel.setLayout(jContactPanelLayout);
        jContactPanelLayout.setHorizontalGroup(
        		jContactPanelLayout.createSequentialGroup()
        			.addContainerGap()
        			.add(jScrollPane13)
        			.addContainerGap());
        jContactPanelLayout.setVerticalGroup(
        		jContactPanelLayout.createSequentialGroup()
        			.addContainerGap()
        			.add(jContactPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING,true)
        			.add(jScrollPane13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,  94, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)));
       
        org.jdesktop.layout.GroupLayout jContactPanelButtonsLayout = new org.jdesktop.layout.GroupLayout(jContactPanelButtons);
        jContactPanelButtons.setLayout(jContactPanelButtonsLayout);
        jContactPanelButtonsLayout.setHorizontalGroup(
        		jContactPanelButtonsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
        			.add(jContactPanelButtonsLayout.createSequentialGroup()
        					.addContainerGap()	
        					.add(jContactPanelButtonsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
        						.add(jButton8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        						.add(jButton9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
							.addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
							.add(jContactPanelButtonsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
								.add(jButton10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
								.add(jButton12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
							.addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
							.add(jContactPanelButtonsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
								.add(jButton11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
								.add(jButton31, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
							.addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
							.add(jContactPanelButtonsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
								.add(jButton13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
								.add(jButton32, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
							.addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
							.add(jContactPanelButtonsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
								.add(jIntrinsicsButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
								.add(jButton14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
							.addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)));
        
        jContactPanelButtonsLayout.setVerticalGroup(
        		jContactPanelButtonsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                	.add(jContactPanelButtonsLayout.createSequentialGroup()
                			.addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)	
                			.add(jContactPanelButtonsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                				.add(jButton8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                				.add(jButton10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                				.add(jButton11, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                				.add(jButton13, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                				.add(jIntrinsicsButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        					.addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
        					.add(jContactPanelButtonsLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
        						.add(jButton9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        						.add(jButton12, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        						.add(jButton31, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        						.add(jButton32, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        						.add(jButton14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        					.addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)));
        
        jInformationTextField.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jInformationTextField.setEditable(false);
        jInformationTextField.setBorder(createBorder("Information"));
        
		jRoutePointPanel.setBorder(createBorder("Route Point"));

        jLabel17.setText("Contacts");

        jLabel18.setText("Addresses");

        jLabel39.setText("Contact Control");

        jTable12.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Contact", "Address", "State", "Treatment", "Caller"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, true, false, true, true
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable12.setGridColor(new java.awt.Color(255, 255, 255));
        jTable12.setShowHorizontalLines(false);
        jTable12.setShowVerticalLines(false);
        jTable12.getTableHeader().setReorderingAllowed(false);
        jScrollPane24.setViewportView(jTable12);
        jTable12.getColumnModel().getColumn(0).setResizable(false);
        jTable12.getColumnModel().getColumn(1).setResizable(false);

        jButton53.setText("Silence");
        jButton53.setToolTipText("Silence");
        jButton53.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton53.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton53ActionPerformed(evt);
            }
        });

        jButton54.setText("Music >>");
        jButton54.setToolTipText("Give Music Treatment");
        jButton54.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton54.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton54ActionPerformed(evt);
            }
        });

        jButton55.setText("Ringback");
        jButton55.setToolTipText("Ringback");
        jButton55.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton55.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton55ActionPerformed(evt);
            }
        });

        jButton56.setText("Route >>");
        jButton56.setToolTipText("Route Selected RoutePoint Connection");
        jButton56.setEnabled(false);
        jButton56.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton56.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton56ActionPerformed(evt);
            }
        });

        jButton57.setText("Disconnect");
        jButton57.setToolTipText("Disconnect selected RoutePoint Connection");
        jButton57.setEnabled(false);
        jButton57.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton57.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton57ActionPerformed(evt);
            }
        });

        jButton58.setText("Retrieve");
        jButton58.setToolTipText("Retrieve selected RoutePoint Connection");
        jButton58.setEnabled(false);
        jButton58.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton58.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton58ActionPerformed(evt);
            }
        });

        jButton59.setText("Acquire");
        jButton59.setToolTipText("Acquire selected RoutePoint Address");
        jButton59.setEnabled(false);
        jButton59.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton59.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton59ActionPerformed(evt);
            }
        });

        jButton60.setText("Deacquire");
        jButton60.setToolTipText("Deacquire selected RoutePoint Address");
        jButton60.setEnabled(false);
        jButton60.setPreferredSize(new java.awt.Dimension(80, 25));
        jButton60.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton60ActionPerformed(evt);
            }
        });

        jTable13.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "Controlled", "Address", "Default Treatment"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable13.setGridColor(new java.awt.Color(255, 255, 255));
        jTable13.setShowHorizontalLines(false);
        jTable13.setShowVerticalLines(false);
        jTable13.getTableHeader().setReorderingAllowed(false);
        jScrollPane25.setViewportView(jTable13);
        jTable13.getColumnModel().getColumn(0).setResizable(false);
        jTable13.getColumnModel().getColumn(1).setResizable(false);   

        org.jdesktop.layout.GroupLayout jRoutePointPanelLayout = new org.jdesktop.layout.GroupLayout(jRoutePointPanel);
        jRoutePointPanel.setLayout(jRoutePointPanelLayout);
        jRoutePointPanelLayout.setHorizontalGroup(
            jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jRoutePointPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 200, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jRoutePointPanelLayout.createSequentialGroup()
                        .add(jButton59, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jButton60, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jLabel18))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel17)
                    .add(jScrollPane24, 0, 0, Short.MAX_VALUE)
                    .add(jLabel39)
                    .add(jRoutePointPanelLayout.createSequentialGroup()
                        .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(jButton57, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jButton55, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jButton53, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 88, Short.MAX_VALUE))
                        .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jRoutePointPanelLayout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(jButton54, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jTextField14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 107, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(jRoutePointPanelLayout.createSequentialGroup()
                                .add(10, 10, 10)
                                .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jButton58, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(jRoutePointPanelLayout.createSequentialGroup()
                                        .add(jButton56, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(jTextField15, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE)))))))
                .add(19, 19, 19))
        );
        jRoutePointPanelLayout.setVerticalGroup(
            jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jRoutePointPanelLayout.createSequentialGroup()
                .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel18)
                    .add(jLabel17))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jRoutePointPanelLayout.createSequentialGroup()
                        .add(jScrollPane24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 54, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel39)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jTextField14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton54, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton53, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jTextField15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton56, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jButton55, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jScrollPane25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 136, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jRoutePointPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton59, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton60, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton57, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButton58, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jMenu13.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jMenu13.setText("Session");

        jMenuItem41.setText("Login to CCT");
        jMenuItem41.setToolTipText("Login to a CCTServer");
        jMenuItem41.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu13.add(jMenuItem41);

        jMenuItem42.setText("Logout of CCT");
        jMenuItem42.setToolTipText("Logout of the CCTServer");
        jMenuItem42.setEnabled(false);
        jMenuItem42.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu13.add(jMenuItem42);
        jMenu13.add(jSeparator3);

        jMenuItem43.setText("Exit");
        jMenuItem43.setToolTipText("Close the SOA Reference Client");
        jMenuItem43.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu13.add(jMenuItem43);

        jMenuBar4.add(jMenu13);

        jMenu14.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jMenu14.setText("View");

        jMenuItem44.setText("Agent Details");
        jMenuItem44.setEnabled(false);
        jMenuItem44.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem40jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu14.add(jMenuItem44);

        jMenuItem45.setText("Device Details");
        jMenuItem45.setEnabled(false);
        jMenuItem45.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu14.add(jMenuItem45);

        jMenuItem46.setText("Contact Details");
        jMenuItem46.setEnabled(false);
        jMenuItem46.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu14.add(jMenuItem46);
        jMenu14.add(jSeparator4);

        jMenuItem47.setText("Event Log");
        jMenuItem47.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem39jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu14.add(jMenuItem47);

        jMenuBar4.add(jMenu14);

        jMenu15.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jMenu15.setText("Preferences");

        jMenuItem48.setText("Server");
        jMenuItem48.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem20ActionPerformed(evt);
            }
        });
        jMenu15.add(jMenuItem48);

        jMenuBar4.add(jMenu15);

        jMenu16.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jMenu16.setText("Help");

        jMenuItem49.setText("About...");
        jMenuItem49.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem21ActionPerformed(evt);
            }
        });
        jMenu16.add(jMenuItem49);

        jMenuBar4.add(jMenu16);

        setJMenuBar(jMenuBar4);
     
        org.jdesktop.layout.GroupLayout mainWindowContainerLayout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(mainWindowContainerLayout);
        mainWindowContainerLayout.setHorizontalGroup(
            mainWindowContainerLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, mainWindowContainerLayout.createSequentialGroup()
                .addContainerGap()
                .add(mainWindowContainerLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jRoutePointPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jInformationTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, mainWindowContainerLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, true)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jInitiateContactsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jCurrentContactsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jAgentStatusPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        mainWindowContainerLayout.setVerticalGroup(
            mainWindowContainerLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mainWindowContainerLayout.createSequentialGroup()
                .add(jAgentStatusPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jInitiateContactsPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jCurrentContactsPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jInformationTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jRoutePointPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)   
        ));

        jInitiateContactsPanel.getAccessibleContext().setAccessibleName("Current Contacts");
        
        javax.swing.JPanel jPanelKeyboard = new javax.swing.JPanel();
        jPanelKeyboard.setLayout(new java.awt.GridLayout(4,3));
        for (char digit : "123456789*0#".toCharArray()){
        	javax.swing.JButton button = new javax.swing.JButton(String.valueOf(digit));
        	
        	button.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    jKeyPadButtonActionPerformed(evt);
                }			
            });
        	
        	jPanelKeyboard.add(button);        	
        }
        
        jTextField82.setPreferredSize(new Dimension(120, 20));
        jTextField82.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        jTextField82.setColumns(16);
        jTextField82.setEditable(false);
        jTextField82.setBorder(null);
        
        jFrame20.setTitle("Keypad");
        jFrame20.setSize(new Dimension(140, 150));
        jFrame20.setResizable(false);
        jFrame20.getContentPane().setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER));
                     
        jFrame20.add(jPanelKeyboard);
        jFrame20.add(jTextField82);        	
        
        pack();
    }// </editor-fold>                        

    private void initLookAndFeel()
    {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch (Exception e) {
        	reportError("GUI initialization", "Error while setting look and feel "+e.getMessage());
        }
        SwingUtilities.updateComponentTreeUI(this);
        SwingUtilities.updateComponentTreeUI(jFrame1);
        SwingUtilities.updateComponentTreeUI(jFrame2);
        SwingUtilities.updateComponentTreeUI(jFrame3);
        SwingUtilities.updateComponentTreeUI(jFrame4);
        SwingUtilities.updateComponentTreeUI(jFrame5);
        SwingUtilities.updateComponentTreeUI(jFrame6);
        SwingUtilities.updateComponentTreeUI(jFrame7);
        SwingUtilities.updateComponentTreeUI(jFrame8);
        SwingUtilities.updateComponentTreeUI(jFrame9);
        SwingUtilities.updateComponentTreeUI(jFrame10);
        SwingUtilities.updateComponentTreeUI(jFrame11);
        SwingUtilities.updateComponentTreeUI(jFrame12);
        SwingUtilities.updateComponentTreeUI(jFrame13);
        SwingUtilities.updateComponentTreeUI(jFrame14);
        SwingUtilities.updateComponentTreeUI(jFrame15);
        SwingUtilities.updateComponentTreeUI(jFrame16);
        SwingUtilities.updateComponentTreeUI(jFrame17);
        SwingUtilities.updateComponentTreeUI(jFrame18);
        SwingUtilities.updateComponentTreeUI(jFrame19);
        SwingUtilities.updateComponentTreeUI(jFrame20);
        SwingUtilities.updateComponentTreeUI(jPopupMenu1);
        SwingUtilities.updateComponentTreeUI(jPopupMenu2);
        SwingUtilities.updateComponentTreeUI(jPopupMenu3);
        SwingUtilities.updateComponentTreeUI(jPopupMenu4);
        SwingUtilities.updateComponentTreeUI(jPopupMenu5);
        SwingUtilities.updateComponentTreeUI(jPopupMenu6);
       // this.setSize(650, 780);
        this.setResizable(true);
        jAgentStatusPanel.setVisible(false);
        this.setSize(this.getWidth(), this.getHeight()-jAgentStatusPanel.getHeight());
        jRoutePointPanel.setVisible(false);
        this.setSize(this.getWidth(), this.getHeight()-jRoutePointPanel.getHeight());
    }
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {     
        
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null)
        {
            params.put("terminal", termTO);

            AddressTO addrTO = termTO.getAddress(jTextField10.getText());
            if(addrTO != null)
            {
                params.put("address", addrTO);
            }
        }
        AddressTO remAddr = new AddressTO();
        remAddr.setAddressName(jTextField9.getText());
        remAddr.setAddressType("GENERIC");
        params.put("remoteAddress", remAddr);
        
        getRequestHandler().handle("CreateContact", params);
    }
    
    private void jButton6AgentLoginActionPerformed(java.awt.event.ActionEvent evt) {                                         
        jTextField5.setText(jComboBox3.getSelectedItem().toString());
        jFrame2.setLocationRelativeTo(jButton27);
        List<TerminalTO> terminals = userContext.getTerminals();
        Vector<String> terminalNames = new Vector<String>(terminals.size());
        getRequestHandler().handle("GetAgentState", new HashMap<String, Object>());
        AgentTO selAgent = agents.get(jComboBox3.getSelectedItem().toString());
        // Selected Device Name (in the "Available Devices" list)
        String selDeviceName = (jTree1.getSelectionPath() != null)?jTree1.getSelectionPath().toString():null;
        // The static voice terminal for this Agent
        String staticVoiceTerm = (selAgent.getStaticVoiceTerminal() != null)?selAgent.getStaticVoiceTerminal().getTerminalName():null;
        // Selected voice terminal
        String selVoiceTerminal = null;
        if (staticVoiceTerm != null) {
            // When the static voice terminal is present only this terminal should be
            // displayed in the list of voice terminals 
            for(TerminalTO term : terminals)
            {
                if (term.getTerminalName().equals(staticVoiceTerm)) {
                    selVoiceTerminal = selAgent.getStaticVoiceTerminal().getTerminalName();
                    terminalNames.add(term.getTerminalName());
                    break;
                }
            }
        } else {
            for(TerminalTO term : terminals)
            {
                terminalNames.add(term.getTerminalName());
                // For convenience select the terminal selected in the "Available Devices" list
                if ((selDeviceName != null) && (selDeviceName.contains(term.getTerminalName()))) {
                    selVoiceTerminal = term.getTerminalName();
                }
            }
        }
        
        //If there were no terminals - disable the terminal dropdown
        if(terminalNames.isEmpty())
        {
            terminalNames.add("             ");
            jComboBox9.setModel(new DefaultComboBoxModel(terminalNames));
            jComboBox9.setEnabled(false);
        }
        else
        {
            jComboBox9.setModel(new DefaultComboBoxModel(terminalNames));
            jComboBox9.setEnabled(true);
            if (selVoiceTerminal != null) {
                jComboBox9.setSelectedItem(selVoiceTerminal);
            }
        }
        jFrame2.setVisible(true);
        jFrame2.getRootPane().setDefaultButton(jButton4);
        jFrame2.setSize(250, 260);
        getRequestHandler().handle("SwitchOverHandler", new HashMap<String, Object>());
    }
    
    private void jButton6AgentLogoutActionPerformed(java.awt.event.ActionEvent evt) {                                         
        AgentTO agent = agents.get(getSelectedAgent());
        if(agent != null)
        {
            TerminalTO termTO = agent.getStaticVoiceTerminal();
            if(termTO != null)
            {
                params.put("terminal", termTO);
            }
            getRequestHandler().handle("AgentLogout", params);
        }
    }
    
    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        jPopupMenu3.show(jButton7, 12, 20);
    }                                        

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        getRequestHandler().handle("AnswerContact", getContactParams());
    }                                        

    private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        getRequestHandler().handle("DropContact", getContactParams());
    }                                        

    private void jButton10HoldActionPerformed(java.awt.event.ActionEvent evt) {                                          
        getRequestHandler().handle("HoldContact", getContactParams());
    }                                         

    private void jButton10UnHoldActionPerformed(java.awt.event.ActionEvent evt) {                                         
        getRequestHandler().handle("UnholdContact", getContactParams());
    }
    
    private void jButton12InitiateConferenceActionPerformed(java.awt.event.ActionEvent evt) {
        Map<String, Object> contactParams = getContactParams();
        getRequestHandler().handle("InitiateConference", contactParams);
        StateEventTO currContact = (StateEventTO)contactParams.get(PARAM_NAME_STATE_EVENT_TO);
        if (currContact != null) {
            currContact.setConferenceInitiated(true);
        }
    }
    
    private void jButton12CompleteConferenceActionPerformed(java.awt.event.ActionEvent evt) {
        Map<String, Object> contactParams = getContactParams();
        getRequestHandler().handle("CompleteConference", getContactParams());
        StateEventTO currContact = (StateEventTO)contactParams.get(PARAM_NAME_STATE_EVENT_TO);
        // The Avaya Aura switch allows one to begin a transfer and complete a conference and vice versa
        if (currContact != null) {
            if (currContact.isConferenceInitiated()) { 
                currContact.setConferenceInitiated(false);
            }
            if (currContact.isTransferInitiated()) {
                currContact.setTransferInitiated(false);
            }
        }
    }
    
    private void jButton14ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        getRequestHandler().handle("EmergencyKey", getContactParams());
    }                                         

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {                                           
        dispose();
    }                                          

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {                                           
        //Start the popup
        jFrame1.setLocationRelativeTo(jTree1);
        jFrame1.setSize(270, 185);
        jFrame1.getRootPane().setDefaultButton(jButton1);
        jFrame1.setVisible(true);
    }                                          

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {                                           
        getRequestHandler().handle("CCTLogout", new HashMap<String, Object>());
        deviceContextInitialized = false;
        prevHadNoRoutePoints = true;
        prevHadNoAgents = true;
        DefaultMutableTreeNode root = new DefaultMutableTreeNode(ROOT);
        DefaultTreeModel model = new DefaultTreeModel(root);
        jTree1 = new JTree(model);
        jTree1.setRootVisible(false);
        jTree1.setShowsRootHandles(true);
        jScrollPane1.setViewportView(jTree1);
        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel(new String[]{}));
        //Current Terminal and Address
        jTextField10.setText("");
        jTextField11.setText("");
        //Current Login and Ready status
        jTextField36.setText("");
        jTextField36.setBackground(Color.LIGHT_GRAY);
        jTextField2.setText("");
        jTextField2.setBackground(Color.LIGHT_GRAY);
        //DND, FWD Buttons
        forwardingButton.setEnabled(false);
        forwardingButton.setForeground(Color.BLACK);
        dndButton.setEnabled(false);
        dndButton.setForeground(Color.BLACK);
        jButton25.setEnabled(false);
        jButton26.setEnabled(false);
        jButton27.setEnabled(false);
        jButton27.setForeground(Color.BLACK);
        jButton28.setEnabled(false);
        
        //Current Contacts Table
        jContactsTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null}
            },
            new String [] {
                "Terminal/Addr", "Local", "Remote", "Contact", "Type", "Calling", "Called"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jContactsTable.setColumnSelectionAllowed(false);
        jContactsTable.setGridColor(new java.awt.Color(255, 255, 255));
        jContactsTable.setShowHorizontalLines(false);
        jContactsTable.setShowVerticalLines(false);
        jContactsTable.getTableHeader().setReorderingAllowed(false);
        jContactsTable.setFillsViewportHeight(true);
        jScrollPane13.setViewportView(jContactsTable);
        
        //Current RoutePoint Contacts Table
        jTable12.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Contact", "Address", "State", "Treatment", "Caller"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, true, false, true, true
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable12.setGridColor(new java.awt.Color(255, 255, 255));
        jTable12.setShowHorizontalLines(false);
        jTable12.setShowVerticalLines(false);
        jTable12.getTableHeader().setReorderingAllowed(false);
        jScrollPane24.setViewportView(jTable12);
        jTable12.getColumnModel().getColumn(0).setResizable(false);
        jTable12.getColumnModel().getColumn(1).setResizable(false);
        
        //Reset the buttons
        resetButtons();
        jMenuItem41.setEnabled(true);
        jMenuItem42.setEnabled(false);
        
        //Collapse Top Panel if it was not already
        if(agents != null && !agents.isEmpty())
        {
        	jAgentStatusPanel.setVisible(false);
            this.setSize(this.getWidth(), this.getHeight()-jAgentStatusPanel.getHeight());
        }
        
        if(userContext != null && userContext.getUnmappedAddresses() != null && !userContext.getUnmappedAddresses().isEmpty())
        {
            jRoutePointPanel.setVisible(false);
            this.setSize(this.getWidth(), this.getHeight()-jRoutePointPanel.getHeight());
        }
        
        userContext = null;
        contactStateEventData = new Vector<StateEventTO>();
        routePointStateEventData = new Vector<StateEventTO>();
        agents = null;
    }                                          

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        cctUname = jTextField1.getText();
        params.put("cctUname", cctUname);
        
        cctPwd = jPasswordField1.getText();
        params.put("cctPwd", cctPwd);
        
        cctDom = jTextField4.getText();
        params.put("cctDom", cctDom);
        
        getRequestHandler().handle("CCTLogin", params);
        
        //Hide the popup, clear the fields
        jFrame1.setVisible(false);
        jPasswordField1.setText("");
      
        this.requestFocus();
    }                                        

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        jFrame1.setVisible(false);
        jPasswordField1.setText("");
        
        this.requestFocus();
    }                                        

    private void jButton12ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        // TODO add your handling code here:
    }                                         

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        
        String terminalName = (jComboBox9.getSelectedItem() != null ? jComboBox9.getSelectedItem().toString() : jComboBox9.getItemAt(0).toString());        
        TerminalTO termTO = userContext.getTerminal(terminalName);
        params.put("terminal", termTO);

        AgentTO agent = agents.get(getSelectedAgent());        
        if(agent != null)
        {
            agent.setPassword(jPasswordField2.getText());
            agentState = jComboBox1.getSelectedItem().toString();
            if(agentState.equals("Ready"))
            {
                params.put("agentState", "2");
                
            }
            else
            {
                params.put("agentState", "1");
            }
        }
        params.put("agent", agent);
        
        getRequestHandler().handle("AgentLogin", params);
        getRequestHandler().handle("GetAgentState", params);
        jFrame2.setVisible(false);
        
        this.requestFocus();
    }                                        

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        jFrame2.setVisible(false);
        jPasswordField2.setText("");
        
        this.requestFocus();
    }                                        

    private void jButton13ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jButton13.setText("Data");
        clearAttachedData();
        if (!getRequestHandler().handle("GetAttachedData", getContactParams()))
        {
           jFrame3.setSize(355, 335);
           jFrame3.setLocationRelativeTo(jButton13);
           jFrame3.getRootPane().setDefaultButton(jButton45);
           jFrame3.setVisible(true);
        }
    }                                         

    private void jButton15ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jButton13.setText("Data");        
        jTable11StopCellEditing();
        Map<String, Object> params = getContactParams();
        params.put("attachedData", null);    	
        getRequestHandler().handle("SetAttachedData", params);
        clearAttachedData();
    }                                         

    private void jButton16ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jButton13.setText("Data");
        jFrame3.setVisible(false);
    }                                         

    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {                                           
        //Clear the tables from any previous usage
        clearContactCapabilities();
        
        //Start the popup
        jFrame15.setSize(550, 590);
        jFrame15.setLocationRelativeTo(jAgentStatusPanel);
        jFrame15.setVisible(true);        
    }                                          

   private void jMenuItem5ActionPerformed( java.awt.event.ActionEvent evt )
   {
      setRootNode(new DefaultMutableTreeNode( ROOT )); 
      int countRows = jContactsTable.getRowCount();
      Set<String> contactIDs = new TreeSet<String>();
      for (int i = 0; i < countRows; i++)
      {
        if (contactIDs.add(contactStateEventData.get( i ).getExternalContactId()))
        {
           getRequestHandler().handle( "GetContactDetails",getContactParams( i ) );
        }
      }
      // Clear the tables from any previous usage
      clearContactCapabilities();
      jFrame5.setSize( 650, 730 );
      jFrame5.setLocationRelativeTo( jAgentStatusPanel );
      jFrame5.setVisible( true );
   }

    private void jButton19ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        System.exit(0);
    }                                         

    private void jButton20ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null)
        {
            params.put("terminal", termTO);
            AddressTO addrTO = termTO.getAddress(jTextField10.getText());
            if(addrTO != null)
            {
                params.put("address", addrTO);
            }
        }
        
        getRequestHandler().handle("CallSupervisor", params);
    }                                         

    private void jButton21ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        AgentTO agent = new AgentTO();
        agent.setAgentUsername(jComboBox3.getSelectedItem().toString());
        agent.setAgentLoginId(jComboBox3.getSelectedItem().toString());
        params.put("agent", agent);
        params.put("externalContactId", jTextField37.getText());
        getRequestHandler().handle("RetrieveContact", params);
    }                                         
    
    private void jButton24ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null)
        {
            params.put("terminal", termTO);
        }
        
        getRequestHandler().handle("SetDoNotDisturbTerminal", params);
    }                                         

    private void jButton23ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jPopupMenu6.show(forwardingButton, 50, 20);
    }                                         

    private void jButton25ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null)
        {
            AddressTO addrTO = termTO.getAddress(jTextField10.getText());
            if(addrTO != null)
            {
                params.put("address", addrTO);
            }
        }
        
        getRequestHandler().handle("SetForwardingAddress", params);
    }                                         

    private void jButton26ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null)
        {
            AddressTO addrTO = termTO.getAddress(jTextField10.getText());
            if(addrTO != null)
            {
                params.put("address", addrTO);
            }
        }
        
        getRequestHandler().handle("SetDoNotDisturbAddress", params);
    }                                         

    private void jButton27ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jPopupMenu1.show(jButton27, 50, 20);
    }                                         

    private void jMenuItem22ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        jFrame8.setLocationRelativeTo(jButton27);
        jFrame8.setSize(270, 185);
        jFrame8.getRootPane().setDefaultButton(jButton17);
        jFrame8.setVisible(true);
    }                                           

    private void jButton17ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        params.put("terminal", termTO);
        
        AgentTO agent = new AgentTO();
        agent.setAgentUsername(jTextField57.getText());
        agent.setAgentLoginId(jTextField57.getText());
        agent.setPassword(jPasswordField3.getText());      
        
        agentState = jComboBox6.getSelectedItem().toString();
        if(agentState.equals("Ready"))
        {
            params.put("agentState", "2");
        }
        else
        {
            params.put("agentState", "1");
        }
        params.put("agent", agent);      
        getRequestHandler().handle("AgentTerminalLogin", params);
        
        //Close the popup and Disable this Menu Item
        jFrame8.setVisible(false);
    }                                         

    private void jButton18ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jFrame8.setVisible(false);
        jPasswordField3.setText("");
        
        this.requestFocus();
    }                                         

    private void jMenuItem23ActionPerformed(java.awt.event.ActionEvent evt) {                                            
    	TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null){
                params.put("terminal", termTO);
            getRequestHandler().handle("AgentTerminalLogout", params);
        }
    }                                           

    private void jMenuItem24ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        params.put("terminal", termTO);
        
        getRequestHandler().handle("SetIsReady", params);
    }                                           

    private void jMenuItem25ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        params.put("terminal", termTO);        
        
        getRequestHandler().handle("SetIsNotReadyState", params);
    }                                           

    private void jMenuItem26ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        jFrame19.setSize(250, 135);
        jFrame19.setLocationRelativeTo(jButton27);
        jFrame19.setVisible(true);
    }                                           

    private void jTextField57ActionPerformed(java.awt.event.ActionEvent evt) {                                             
        // TODO add your handling code here:
    }                                            

    private void jMenuItem21ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        jFrame7.setSize(200, 125);
        jFrame7.setLocationRelativeTo(jMenu16);
        jFrame7.setVisible(true);
    }                                           

    private void jMenuItem20ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        getRequestHandler().handle("GetServerDetails", new HashMap<String, Object>());
        jFrame9.setSize(250, 210);
        jFrame9.setLocationRelativeTo(jMenuItem48);
        jFrame9.getRootPane().setDefaultButton(jButton29);
        jFrame9.setVisible(true);
    }                                           

    private void jButton29ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        params.put("newServer", jTextField23.getText());
        params.put("newPort", jTextField58.getText());
        params.put("newProtocol", httpsRadioButton.getSelectedObjects() != null && httpsRadioButton.getSelectedObjects()[0] != null ? "https" : "http");
        getRequestHandler().handle("SetServerDetails", params);
        jFrame9.setVisible(false);
    }                                         

    private void jButton30ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jTextField23.setText("");
        jTextField58.setText("");
        jFrame9.setVisible(false);
    }                                         

    private void transferActionPerformed(java.awt.event.ActionEvent evt) {                                                 
        jPopupMenu2.show(jButton11, 50, 20);        
    }
    
    private void jMenuItem27InitiateSupervisedTransferActionPerformed(java.awt.event.ActionEvent evt) {
        Map<String, Object> contactParams = getContactParams();
        getRequestHandler().handle("InitiateSupervisedTransfer", contactParams);
        StateEventTO currContact = (StateEventTO)contactParams.get(PARAM_NAME_STATE_EVENT_TO);
        if (currContact != null) {
            currContact.setTransferInitiated(true);
        }
    }
    
    private void jMenuItem27CompleteSupervisedTransferActionPerformed(java.awt.event.ActionEvent evt) {
        Map<String, Object> contactParams = getContactParams();
        getRequestHandler().handle("CompleteSupervisedTransfer", contactParams);
        StateEventTO currContact = (StateEventTO)contactParams.get(PARAM_NAME_STATE_EVENT_TO);
        // The Avaya Aura switch allows one to begin a transfer and complete a conference and vice versa
        if (currContact != null) {
            if (currContact.isConferenceInitiated()) { 
                currContact.setConferenceInitiated(false);
            }
            if (currContact.isTransferInitiated()) {
                currContact.setTransferInitiated(false);
            }
        }
    }
    
    private void jMenuItem28ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        getRequestHandler().handle("TransferContact", getContactParams());
    }                                           

    private void jButton31ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jPopupMenu5.show(jButton31, 50, 20);
    }                                         

    private void jButton33ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jIntrinsicsButton.setText("Intrinsics");
        getRequestHandler().handle("GetIntrinsicData", getContactParams());
        jFrame17.setSize(355, 235);
        jFrame17.setLocationRelativeTo(jIntrinsicsButton);
        jFrame17.getRootPane().setDefaultButton(jButton50);
        jFrame17.setVisible(true);
    }                                         

    private void jMenuItem29ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        AgentTO agent = agents.get(getSelectedAgent());
        if(agent != null)
        {
            TerminalTO termTO = agent.getStaticVoiceTerminal();
            if(termTO != null)
            {
                params.put("terminal", termTO);
            }
            getRequestHandler().handle("SetToReadyState", params);
        }
    }                                           

    private void jMenuItem30ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        AgentTO agent = agents.get(getSelectedAgent());
        if(agent != null)
        {
            TerminalTO termTO = agent.getStaticVoiceTerminal();
            if(termTO != null)
            {
                termTO.setTerminalNotReadyReason(null);
                params.put("terminal", termTO);
            }
            getRequestHandler().handle("SetToNotReadyState", params);
        }
    }                                           

    private void jMenuItem31ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        jFrame10.setSize(250, 115);
        jFrame10.setLocationRelativeTo(jButton7);
        jFrame10.getRootPane().setDefaultButton(jButton34);
        jFrame10.setVisible(true);
    }                                           

   private void jButton34ActionPerformed( java.awt.event.ActionEvent evt ) {
      AgentTO agent = agents.get(getSelectedAgent());
      if (agent != null)
      {
         TerminalTO termTO = agent.getStaticVoiceTerminal();
         if (termTO != null)
         {
            termTO.setTerminalNotReadyReason( jTextField56.getText() );
            params.put( "terminal", termTO );
         }
         getRequestHandler().handle( "SetToNotReadyState", params );
         jFrame10.setVisible( false );
         jTextField56.setText( "" );
      }
   }                           

    private void jButton35ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jTextField56.setText("");
        jFrame10.setVisible(false);
    }                                         

    private void jButton22ActionPerformed(java.awt.event.ActionEvent evt) {                                          
           	
        String activityCode = userContext.getTerminal(getSelectedTerminal()).getTerminalActivityCode();
        jMenuItem32.setText("Activity:"+(activityCode == null || activityCode.equals("") ? "<none>" : activityCode));
        
        jPopupMenu4.show(activityCodeButton, 14, 20);
    }                                         

    private void jMenuItem32ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        // TODO add your handling code here:
    }                                           

    private void jMenuItem33ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null)
        {
            params.put("terminal", termTO);
        }
        getRequestHandler().handle("GetActivityCode", params);
        
        jFrame11.setSize(225, 140);
        jFrame11.setLocationRelativeTo(activityCodeButton);
        jFrame11.getRootPane().setDefaultButton(jButton36);
        jFrame11.setVisible(true);
    }                                           

    private void jMenuItem34ActionPerformed(java.awt.event.ActionEvent evt) {                                            
                
        TerminalTO termTO = userContext.getTerminal(getSelectedTerminal());
        if(termTO != null)
        {
            termTO.setTerminalActivityCode(null);
            params.put("terminal", termTO);
            
        }
        getRequestHandler().handle("SetActivityCode", params);
    }                                           

    private void jButton36ActionPerformed(java.awt.event.ActionEvent evt) {                                          
                
        TerminalTO termTO = userContext.getTerminal(getSelectedTerminal());
        if(termTO != null)
        {
            termTO.setTerminalActivityCode(jTextField59.getText());
            params.put("terminal", termTO);
        }
        getRequestHandler().handle("SetActivityCode", params);
        
        jFrame11.setVisible(false);
        jTextField59.setText("");
    }                                         

    private void jButton37ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jTextField59.setText("");
        jFrame11.setVisible(false);
    }                                         

	private void jMenuItem35ActionPerformed(java.awt.event.ActionEvent evt) {
		jTextField82.setText("");		
		jFrame20.setLocationRelativeTo(jButton31);		
		jFrame20.setVisible(true);
	}                                        

    private void jMenuItem36ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        jFrame13.setSize(230, 140);
        jFrame13.setLocationRelativeTo(jMenuItem36);
        jFrame13.getRootPane().setDefaultButton(jButton43);
        jFrame13.setVisible(true);
    }                                           

    private void jMenuItem37ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        if(userContext.getTerminal(jTextField11.getText()).isForwarding())
        {
            TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
            if(termTO != null)
            {
                params.put("terminal", termTO);
            }
            getRequestHandler().handle("GetForwardingTerminal", params);
        }
        
        jFrame12.setTitle("Forwarding Instructions - "+jTextField11.getText());
        jPanel12.setPreferredSize(new java.awt.Dimension(230, 160));
        jFrame12.setSize(475, 250);
        jFrame12.setLocationRelativeTo(activityCodeButton);
        jFrame12.getRootPane().setDefaultButton(jButton41);
        jFrame12.setVisible(true);
    }                                           

    private void jMenuItem38ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null)
        {
            params.put("terminal", termTO);
        }
        
        getRequestHandler().handle("CancelForwardingTerminal", params);
    }                                           

	private void jButton43ActionPerformed(java.awt.event.ActionEvent evt) {
		Map<String, Object> contactParams = getContactParams();

		contactParams.put("GenerateDTMF_digits", jTextField61.getText());

		getRequestHandler().handle("GenerateDTMF", contactParams);

		jTextField61.setText("");
		jFrame13.setVisible(false);
	}

	private void jKeyPadButtonActionPerformed(ActionEvent evt) {
		jTextField82.setText(jTextField82.getText()+evt.getActionCommand());
		
		Map<String, Object> contactParams = getContactParams();
		contactParams.put("GenerateDTMF_digits", evt.getActionCommand());	
		
		getRequestHandler().handle("GenerateDTMF", contactParams);		
	}

    private void jButton44ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jTextField61.setText("");
        jFrame13.setVisible(false);
    }                                         

    private void jButton42ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jFrame12.setVisible(false);
        clearForwardingFrame();
    }                                         

    private void jButton41ActionPerformed(java.awt.event.ActionEvent evt) {                                          
                
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null)
        {
            params.put("terminal", termTO);
        }
        
        DefaultTableModel model = (DefaultTableModel)jTable4.getModel();
        List<ForwardInstructionTO> instructions = new ArrayList<ForwardInstructionTO>();
        for(int i=0; i<model.getRowCount(); i++)
        {
        	if((String)model.getValueAt(i, 3) != null && !((String)model.getValueAt(i, 3)).isEmpty())
        	{
				ForwardInstructionTO forward = new ForwardInstructionTO();
				forward.setCondition((String)model.getValueAt(i, 0));
				forward.setFilter((String)model.getValueAt(i, 1));
				forward.setFrom((String)model.getValueAt(i, 2));
				forward.setForwardTo((String)model.getValueAt(i, 3));
				instructions.add(forward);
        	}
        }
        if(instructions.isEmpty())
        	getRequestHandler().handle("CancelForwardingTerminal", params);
        else
        {
            params.put("forwardingInstructions", instructions);
            getRequestHandler().handle("SetForwardingTerminal", params);
        }
        jFrame12.setVisible(false);
        clearForwardingFrame();
    }                                         

    private void jButton38ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        Vector newRow = new Vector();
        newRow.add(jComboBox7.getSelectedItem());
        newRow.add(jComboBox8.getSelectedItem());
        newRow.add(jTextField67.getText());
        newRow.add(jTextField60.getText());
        DefaultTableModel tableModel =(DefaultTableModel) jTable4.getModel();
        tableModel.addRow(newRow);
    }                                         

    private void jTable11StopCellEditing(){
    	javax.swing.table.TableCellEditor cellEditor = jTable11.getCellEditor();
    	if (cellEditor != null)
    		cellEditor.stopCellEditing();
    }
    
    private void jButton45ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jButton13.setText("Data");
        boolean validUpdate = true;        
    	attachedData = new AttachedDataTO();
    	
    	JPanel dataPanel = (JPanel)jTabbedPane1.getSelectedComponent();
    	if (dataPanel != null){
    		if(dataPanel.getName().equals("String"))
    		{
    			attachedData.setType(AttachedDataType.STRING);
    			attachedData.setStringData(jTextArea1.getText());
    		}
    		else if(dataPanel.getName().equals("Binary"))
    		{
    			attachedData.setType(AttachedDataType.BINARY);
    			try
    			{
    				attachedData.setBinaryData(jTextArea6.getText());
    			}
    			catch(NumberFormatException nfe)
    			{
    				jTextArea6.setText(jTextArea6.getText()+" - Invalid Hexadecimal Input");
    				return;
    			}
    		}
    		else if(dataPanel.getName().equals("KVP"))
    		{
           
    			jTable11StopCellEditing();
    			attachedData.setType(AttachedDataType.KVP);
    			List<KeyValuePairTO> kvps = new ArrayList<KeyValuePairTO>();
    			for(int i=0; i<jTable11.getRowCount(); i++)
    			{
    				String key = (String)jTable11.getModel().getValueAt(i, 0);
    				if(key != null && !key.equals(""))
    				{
	                    KeyValuePairTO kvp = new KeyValuePairTO();
	                    kvp.setKey(key);
	                    kvp.setValue((String)jTable11.getModel().getValueAt(i, 1));
	                    kvps.add(kvp);
    				}
	            }
	            KeyValuePairTO[] kvpArray = new KeyValuePairTO[kvps.size()];
	            for(int i=0; i<kvps.size(); i++)
	            {
	                kvpArray[i] = kvps.get(i);
	            }
	            attachedData.setKeyValueData(kvpArray);
	        }
	        else
	        {
	        	validUpdate = false;
	        }
    	} 
    	else
    	{
         	reportError("SetAttachedData", "No data populated on chosen tab to update");
        }
        
        if(validUpdate)
        {
	        Map<String, Object> params = getContactParams();
	        params.put("attachedData", attachedData);    	
	        getRequestHandler().handle("SetAttachedData", params);
        }
        else
        {
        	reportError("SetAttachedData", "No data populated on chosen tab to update");
        }
    }                                         

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {                                         
        // TODO add your handling code here:
    }                                        

    private void jButton39ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        DefaultTableModel tableModel =(DefaultTableModel) jTable4.getModel();
        
        int row = jTable4.getSelectedRow();
        if(row != -1)
        {
           tableModel.setValueAt(jComboBox7.getSelectedItem(), row, 0);
           tableModel.setValueAt(jComboBox8.getSelectedItem(), row, 1);
           tableModel.setValueAt(jTextField67.getText(), row, 2);
           tableModel.setValueAt(jTextField60.getText(), row, 3);
        }
        else
        {
            Vector updatedRow = new Vector();
            updatedRow.add(jComboBox7.getSelectedItem());
            updatedRow.add(jComboBox8.getSelectedItem());
            updatedRow.add(jTextField67.getText());
            updatedRow.add(jTextField60.getText());
            tableModel.addRow(updatedRow);
        }
    }                                         

    private void jButton40ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        DefaultTableModel tableModel =(DefaultTableModel) jTable4.getModel();
        
        int row = jTable4.getSelectedRow();
        if(row != -1)
        {
           tableModel.removeRow(row);
        }
        else
        {
            if(jTable4.getRowCount() == 1)
            {
                tableModel.removeRow(0);
            }
        }
    }                                         

	private void jMenuItem39jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt)
	{
		FileReader freader = null;

		try
		{
			freader = new FileReader(NotificationManager.EVENT_LOG_FILE);
			jTextArea3.read(freader, null);
			jFrame14.setSize(650, 350);
			jFrame14.setLocationRelativeTo(jMenu14);
			jFrame14.setVisible(true);
		}
		catch (IOException ioe)
		{
			reportError("Server Settings", "Unable to file at " + NotificationManager.EVENT_LOG_FILE + " - " + ioe.getMessage());
		}
		finally
		{
			if (freader != null)
			{
				try
				{
					freader.close();
				}
				catch (IOException e)
				{
				}
			}
		}
	}

    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        // TODO add your handling code here:
    }                                         

    private void jMenuItem27ActionPerformed(java.awt.event.ActionEvent evt) {                                            
        // TODO add your handling code here:
    }                                           

    private void jButton32ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jButton32.setText("UUI");
        getRequestHandler().handle("GetUUIData", getContactParams());
        jFrame16.setSize(355, 235);
        jFrame16.setLocationRelativeTo(jButton32);
        jFrame16.getRootPane().setDefaultButton(jButton48);
        jFrame16.setVisible(true);
    }                                         

    private void jButton47ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jButton32.setText("UUI");
        jFrame16.setVisible(false);
    }                                         

    private void jButton48ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jButton32.setText("UUI");
        getRequestHandler().handle("SetUUIData", getContactParams());
    }                                         

    private void jButton49ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jIntrinsicsButton.setText("Intrinsics");
        jFrame17.setVisible(false);
    }                                         

    private void jButton50ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jIntrinsicsButton.setText("Intrinsics");
        jFrame17.setVisible(false);
        getRequestHandler().handle("SetIntrinsicData", getContactParams());
    }                                         

    private void jButton51ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jIntrinsicsButton.setText("Intrinsics");
        
        //Remove the entry before we set the remaining intrinsic
        DefaultTableModel model = (DefaultTableModel)jTable1.getModel();
        if(jTable1.getSelectedRow() != -1)
        {
            model.removeRow(jTable1.getSelectedRow());
        }
        getRequestHandler().handle("SetIntrinsicData", getContactParams());
    }                                         

    private void jMenuItem40jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {                                                      
        DefaultMutableTreeNode root = new DefaultMutableTreeNode(ROOT);
        for(AgentTO agent : agents.values())
        {
            DefaultMutableTreeNode agentNode = new DefaultMutableTreeNode(agent.getAgentLoginId());
            root.add(agentNode);
        }
    
        DefaultTreeModel model = new DefaultTreeModel(root);
        jTree2 = new JTree(model);
        jTree2.setRootVisible(false);
        jTree2.setShowsRootHandles(true);
        jTree2.addTreeSelectionListener(new TreeSelectionListener() {

            public void valueChanged(TreeSelectionEvent e) {
            	
                DefaultMutableTreeNode node = (DefaultMutableTreeNode)jTree2.getLastSelectedPathComponent();
                
				if (node == null) {
					if (log.isDebugEnabled()) {
						log.debug("The selection in the tree was empty will not perform any view change. Returning early.");
					}
					return;
				}
				
                //Update the terminal agent details
                AgentTO agent = agents.get(node.toString());
                List<CapabilityTO> caps = agent.getAgentCapabilities().getCapabilityList();
                String[][] values = new String[caps.size()][2];
                String[] colNames = {"Capability", "Able"};

                for(int i=0; i<caps.size();i++)
                {
                    values[i][0] = caps.get(i).getName();
                    values[i][1] = ""+caps.get(i).isAble();
                }

                jTable5 = new JTable(values , colNames);
                jTable5.setColumnSelectionAllowed(false);
                jTable5.setGridColor(new java.awt.Color(255, 255, 255));
                jTable5.setShowHorizontalLines(false);
                jTable5.setShowVerticalLines(false);
                jTable5.getTableHeader().setReorderingAllowed(false);
                jScrollPane14.setViewportView(jTable5);
                jTable5.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
                jTable5.getColumnModel().getColumn(0).setPreferredWidth(75);
                jTable5.getColumnModel().getColumn(1).setPreferredWidth(20);

                //Populate Contact Information
                jTextField18.setText(agent.getAgentUsername());
                jTextField18.setCaretPosition(0);                
                //jTextField8.setText(agent.getState());
                jTextField12.setText(""+agent.isLoggedIn());
                jTextField13.setText(""+agent.isReady());
                jTextField38.setText(agent.getNotReadyReasonCode());
                jTextField39.setText(agent.getStaticVoiceTerminal() != null ? agent.getStaticVoiceTerminal().getTerminalName(): "");
                jTextField40.setText(agent.getSupervisor() != null ? agent.getSupervisor().getAgentUsername(): "");
                jTextField40.setCaretPosition(0);
                
                List<String> conTypes = agent.getContactTypes();
                String[][] conTypeValues = new String[conTypes.size()][1];
                String[] conTypeColNames = {"Contact Types"};

                for(int i=0; i<conTypes.size();i++)
                {
                    conTypeValues[i][0] = conTypes.get(i);
                }

                jTable3 = new JTable(conTypeValues , conTypeColNames);
                jTable3.setColumnSelectionAllowed(false);
                jTable3.setGridColor(new java.awt.Color(255, 255, 255));
                jTable3.setShowHorizontalLines(false);
                jTable3.setShowVerticalLines(false);
                jTable3.getTableHeader().setReorderingAllowed(false);
                jScrollPane21.setViewportView(jTable3);
                jTable3.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
                jTable3.getColumnModel().getColumn(0).setPreferredWidth(60);
            }
        });
        jScrollPane2.setViewportView(jTree2);
        
        //Clear the tables from any previous usage
        clearAgentCapabilities();
        
        //Start the popup
        jFrame4.setSize(550, 350);
        jFrame4.setLocationRelativeTo(jAgentStatusPanel);
        jFrame4.setVisible(true); 
    }                                                     

    private void jButton46ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        TerminalTO termTO = userContext.getTerminal(jTextField11.getText());
        if(termTO != null)
        {
            termTO.setTerminalNotReadyReason(jTextField81.getText());
            params.put("terminal", termTO);
            
        }
        getRequestHandler().handle("SetIsNotReadyState", params);
        
        jFrame19.setVisible(false);
        jTextField81.setText("");
    }                                         

    private void jButton52ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        jTextField81.setText("");
        jFrame19.setVisible(false);
    }                                         

    private void jButton53ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        params.put("treatmentTerminal", jTextField14.getText());
        params.put("treatmentAddress", jTextField15.getText());
        ConnectionTO connection = (routePointStateEventData == null || jTable12.getSelectedRow() == -1 ? null : routePointStateEventData.get(jTable12.getSelectedRow()).getConnection());
        params.put("connection", connection);
        params.put("type", "silence");
        getRequestHandler().handle("GiveMediaTreatment", params);
    }                                         

    private void jButton54ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        //params.put("treatmentTerminal", jTextField14.getText());
        //params.put("treatmentAddress", jTextField15.getText());
        ConnectionTO connection = (routePointStateEventData == null || jTable12.getSelectedRow() == -1 ? null : routePointStateEventData.get(jTable12.getSelectedRow()).getConnection());
        params.put("connection", connection);
        //params.put("type", "music");
        //getRequestHandler().handle("GiveMediaTreatment", params);
        getRequestHandler().handle("GetRoutePointConnectionCapabilities", params);
    }                                         

    private void jButton55ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        params.put("treatmentTerminal", jTextField14.getText());
        params.put("treatmentAddress", jTextField15.getText());
        ConnectionTO connection = (routePointStateEventData == null || jTable12.getSelectedRow() == -1 ? null : routePointStateEventData.get(jTable12.getSelectedRow()).getConnection());
        params.put("connection", connection);
        params.put("type", "ringBack");
        getRequestHandler().handle("GiveMediaTreatment", params);
    }                                         

    private void jButton56ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        params.put("addressName", jTextField15.getText());
        ConnectionTO connection = (routePointStateEventData == null || jTable12.getSelectedRow() == -1 ? null : routePointStateEventData.get(jTable12.getSelectedRow()).getConnection());
        params.put("connection", connection);
        getRequestHandler().handle("RouteRoutePointContact", params);
    }                                         

    private void jButton57ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        params.put("address", userContext.getUnmappedAddresses().get(jTable12.getSelectedRow()));
        getRequestHandler().handle("DisconnectRoutePointContact", params);
    }                                         

    private void jButton58ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        params.put("address", userContext.getUnmappedAddresses().get(jTable12.getSelectedRow()));
        getRequestHandler().handle("RetrieveRoutePointContact", params);
    }                                         

    private void jButton59ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        int selectedAddressIndex = (jTable13.getRowCount() > 0 && jTable13.getSelectedRow() == -1) ? 0 : jTable13.getSelectedRow();
        params.put("address", userContext.getUnmappedAddresses().get(selectedAddressIndex));
        getRequestHandler().handle("ControlRoutePoint", params);
    }                                         

    private void jButton60ActionPerformed(java.awt.event.ActionEvent evt) {                                          
        int selectedAddressIndex = (jTable13.getRowCount() > 0 && jTable13.getSelectedRow() == -1) ? 0 : jTable13.getSelectedRow();
        params.put("address", userContext.getUnmappedAddresses().get(selectedAddressIndex));
        getRequestHandler().handle("ReleaseRoutePoint", params);
    }                                         
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
	//workaround for jre 1.6_37
    	Runtime.getRuntime().addShutdownHook(new Thread(){
    		public void run(){
    			Runtime.getRuntime().halt(0);//close jvm
    		}
    	});
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                ClassPathResource res = new ClassPathResource("spring-beans.xml");
                XmlBeanFactory beanFactory = new XmlBeanFactory(res);
                
                SOARefClient rc = (SOARefClient)beanFactory.getBean("refClient");
                if (rc != null)
                	rc.setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify                     
    private static javax.swing.JRadioButton httpRadioButton;
    private static javax.swing.JRadioButton httpsRadioButton;
    private javax.swing.JButton jButton1;
    private static javax.swing.JButton jButton10;
    private static javax.swing.JButton jButton11;
    private static javax.swing.JButton jButton12;
    private static javax.swing.JButton jButton13;
    private static javax.swing.JButton jButton14;
    private javax.swing.JButton jButton15;
    private javax.swing.JButton jButton16;
    private javax.swing.JButton jButton17;
    private javax.swing.JButton jButton18;
    private javax.swing.JButton jButton19;
    private javax.swing.JButton originateButton;
    private static javax.swing.JButton jButton20;
    private static javax.swing.JButton jButton21;
    private static javax.swing.JButton activityCodeButton;
    private static javax.swing.JButton forwardingButton;
    private static javax.swing.JButton dndButton;
    private static javax.swing.JButton jButton25;
    private static javax.swing.JButton jButton26;
    private static javax.swing.JButton jButton27;
    private static javax.swing.JButton jButton28;
    private javax.swing.JButton jButton29;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton30;
    private static javax.swing.JButton jButton31;
    private static javax.swing.JButton jButton32;
    private static javax.swing.JButton jIntrinsicsButton;
    private javax.swing.JButton jButton34;
    private javax.swing.JButton jButton35;
    private javax.swing.JButton jButton36;
    private javax.swing.JButton jButton37;
    private javax.swing.JButton jButton38;
    private javax.swing.JButton jButton39;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton40;
    private javax.swing.JButton jButton41;
    private javax.swing.JButton jButton42;
    private javax.swing.JButton jButton43;
    private javax.swing.JButton jButton44;
    private javax.swing.JButton jButton45;
    private javax.swing.JButton jButton46;
    private javax.swing.JButton jButton47;
    private javax.swing.JButton jButton48;
    private javax.swing.JButton jButton49;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton50;
    private javax.swing.JButton jButton51;
    private javax.swing.JButton jButton52;
    private static javax.swing.JButton jButton53;
    private static javax.swing.JButton jButton54;
    private static javax.swing.JButton jButton55;
    private static javax.swing.JButton jButton56;
    private static javax.swing.JButton jButton57;
    private static javax.swing.JButton jButton58;
    private static javax.swing.JButton jButton59;
    private static javax.swing.JButton jButton6;
    private static javax.swing.JButton jButton60;
    private static javax.swing.JButton jButton7;
    private static javax.swing.JButton jButton8;
    private static javax.swing.JButton jButton9;
    private javax.swing.JCheckBox jCheckBox1;
    private static javax.swing.JComboBox jComboBox1;
    private static javax.swing.JComboBox jComboBox10;
    private static javax.swing.JComboBox jComboBox2;
    private static javax.swing.JComboBox jComboBox3;
    private javax.swing.JComboBox jComboBox4;
    private static javax.swing.JComboBox jComboBox6;
    private static javax.swing.JComboBox jComboBox7;
    private static javax.swing.JComboBox jComboBox8;
    private static javax.swing.JComboBox jComboBox9;
    private static javax.swing.JFrame jFrame1;
    private static javax.swing.JFrame jFrame10;
    private static javax.swing.JFrame jFrame11;
    private javax.swing.JFrame jFrame12;
    private static javax.swing.JFrame jFrame13;
    private javax.swing.JFrame jFrame14;
    private javax.swing.JFrame jFrame15;
    private javax.swing.JFrame jFrame16;
    private javax.swing.JFrame jFrame17;
    private javax.swing.JFrame jFrame18;
    private static javax.swing.JFrame jFrame19;
    private static javax.swing.JFrame jFrame2;
    private javax.swing.JFrame jFrame20;
    private javax.swing.JFrame jFrame3;
    private javax.swing.JFrame jFrame4;
    private javax.swing.JFrame jFrame5;
    private static javax.swing.JFrame jFrame6;
    private static javax.swing.JFrame jFrame7;
    private static javax.swing.JFrame jFrame8;
    private static javax.swing.JFrame jFrame9;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel48;
    private javax.swing.JLabel jLabel49;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel50;
    private javax.swing.JLabel jLabel51;
    private javax.swing.JLabel jLabel52;
    private javax.swing.JLabel jLabel53;
    private javax.swing.JLabel jLabel54;
    private javax.swing.JLabel jLabel55;
    private javax.swing.JLabel jLabel56;
    private javax.swing.JLabel jLabel57;
    private javax.swing.JLabel jLabel58;
    private javax.swing.JLabel jLabel59;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel60;
    private javax.swing.JLabel jLabel61;
    private javax.swing.JLabel jLabel62;
    private javax.swing.JLabel jLabel63;
    private javax.swing.JLabel jLabel64;
    private javax.swing.JLabel jLabel65;
    private javax.swing.JLabel jLabel66;
    private javax.swing.JLabel jLabel67;
    private javax.swing.JLabel jLabel68;
    private javax.swing.JLabel jLabel69;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel70;
    private javax.swing.JLabel jLabel71;
    private javax.swing.JLabel jLabel72;
    private javax.swing.JLabel jLabel73;
    private javax.swing.JLabel jLabel74;
    private javax.swing.JLabel jLabel75;
    private javax.swing.JLabel jLabel76;
    private javax.swing.JLabel jLabel77;
    private javax.swing.JLabel jLabel78;
    private javax.swing.JLabel jLabel79;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel80;
    private javax.swing.JLabel jLabel81;
    private javax.swing.JLabel jLabel82;
    private javax.swing.JLabel jLabel83;
    private javax.swing.JLabel jLabel84;
    private javax.swing.JLabel jLabel85;
    private javax.swing.JLabel jLabel86;
    private javax.swing.JLabel jLabel87;
    private javax.swing.JLabel jLabel88;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenu jMenu13;
    private javax.swing.JMenu jMenu14;
    private javax.swing.JMenu jMenu15;
    private javax.swing.JMenu jMenu16;
    private javax.swing.JMenu jMenu17;
    private javax.swing.JMenu jMenu18;
    private javax.swing.JMenuBar jMenuBar4;
    private javax.swing.JMenuBar jMenuBar5;
    private static javax.swing.JMenuItem jMenuItem22;
    private static javax.swing.JMenuItem jMenuItem23;
    private static javax.swing.JMenuItem jMenuItem24;
    private static javax.swing.JMenuItem jMenuItem25;
    private static javax.swing.JMenuItem jMenuItem26;
    private static javax.swing.JMenuItem jMenuItem27;
    private static javax.swing.JMenuItem jMenuItem28;
    private static javax.swing.JMenuItem jMenuItem29;
    private static javax.swing.JMenuItem jMenuItem30;
    private static javax.swing.JMenuItem jMenuItem31;
    private static javax.swing.JMenuItem jMenuItem32;
    private javax.swing.JMenuItem jMenuItem33;
    private static javax.swing.JMenuItem jMenuItem34;
    private javax.swing.JMenuItem jMenuItem35;
    private javax.swing.JMenuItem jMenuItem36;
    private javax.swing.JMenuItem jMenuItem37;
    private javax.swing.JMenuItem jMenuItem38;
    private static javax.swing.JMenuItem jMenuItem41;
    private static javax.swing.JMenuItem jMenuItem42;
    private javax.swing.JMenuItem jMenuItem43;
    private static javax.swing.JMenuItem jMenuItem44;
    private static javax.swing.JMenuItem jMenuItem45;
    private static javax.swing.JMenuItem jMenuItem46;
    private static javax.swing.JMenuItem jMenuItem47;
    private javax.swing.JMenuItem jMenuItem48;
    private javax.swing.JMenuItem jMenuItem49;
    private javax.swing.JPanel jAgentStatusPanel;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jInitiateContactsPanel;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel22;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel24;
    private javax.swing.JPanel jPanel25;
    private javax.swing.JPanel jRoutePointPanel;
    private javax.swing.JPanel jCurrentContactsPanel;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPanel jContactPanel;
    private javax.swing.JPanel jContactPanelButtons;
    private javax.swing.JPasswordField jPasswordField1;
    private javax.swing.JPasswordField jPasswordField2;
    private javax.swing.JPasswordField jPasswordField3;
    private javax.swing.JPopupMenu jPopupMenu1;
    private static javax.swing.JPopupMenu jPopupMenu2;
    private javax.swing.JPopupMenu jPopupMenu3;
    private javax.swing.JPopupMenu jPopupMenu4;
    private javax.swing.JPopupMenu jPopupMenu5;
    private javax.swing.JPopupMenu jPopupMenu6;
    private static javax.swing.JScrollPane jScrollPane1;
    private static javax.swing.JScrollPane jScrollPane10;
    private javax.swing.JScrollPane jScrollPane11;
    private javax.swing.JScrollPane jScrollPane12;
    private static javax.swing.JScrollPane jScrollPane13;
    private static javax.swing.JScrollPane jScrollPane14;
    private static javax.swing.JScrollPane jScrollPane15;
    private static javax.swing.JScrollPane jScrollPane16;
    private static javax.swing.JScrollPane jScrollPane17;
    private static javax.swing.JScrollPane jScrollPane18;
    private static javax.swing.JScrollPane jScrollPane19;
    private static javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane20;
    private javax.swing.JScrollPane jScrollPane21;
    private javax.swing.JScrollPane jScrollPane22;
    private javax.swing.JScrollPane jScrollPane23;
    private static javax.swing.JScrollPane jScrollPane24;
    private static javax.swing.JScrollPane jScrollPane25;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private static javax.swing.JScrollPane jScrollPane8;
    private static javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JTabbedPane jTabbedPane1;
    private static javax.swing.JTable jTable1;
    private static javax.swing.JTable jTable10;
    private static javax.swing.JTable jTable11;
    private static javax.swing.JTable jTable12;
    private javax.swing.JTable jTable13;
    private static javax.swing.JTable jContactsTable;
    private javax.swing.JTable jTable3;
    private static javax.swing.JTable jTable4;
    private static javax.swing.JTable jTable5;
    private static javax.swing.JTable jTable6;
    private static javax.swing.JTable jTable7;
    private static javax.swing.JTable jTable8;
    private static javax.swing.JTable jTable9;
    private static javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextArea jTextArea3;
    private static javax.swing.JTextArea jTextArea4;
    private javax.swing.JTextArea jTextArea5;
    private static javax.swing.JTextArea jTextArea6;
    private static javax.swing.JTextField jTextField1;
    private static javax.swing.JTextField jTextField10;
    private static javax.swing.JTextField jTextField11;
    private static javax.swing.JTextField jTextField12;
    private static javax.swing.JTextField jTextField13;
    private static javax.swing.JTextField jTextField14;
    private static javax.swing.JTextField jTextField15;
    private static javax.swing.JTextField jTextField18;
    private static javax.swing.JTextField jTextField19;
    private static javax.swing.JTextField jTextField2;
    private static javax.swing.JTextField jTextField20;
    private static javax.swing.JTextField jTextField21;
    private static javax.swing.JTextField jTextField22;
    private static javax.swing.JTextField jTextField23;
    private static javax.swing.JTextField jTextField24;
    private static javax.swing.JTextField jTextField25;
    private static javax.swing.JTextField jTextField26;
    private static javax.swing.JTextField jTextField27;
    private static javax.swing.JTextField jTextField28;
    private static javax.swing.JTextField jTextField29;
    private static javax.swing.JTextField jTextField30;
    private static javax.swing.JTextField jTextField31;
    private static javax.swing.JTextField jTextField32;
    private static javax.swing.JTextField jTextField33;
    private static javax.swing.JTextField jTextField34;
    private static javax.swing.JTextField jInformationTextField;
    private static javax.swing.JTextField jTextField36;
    private static javax.swing.JTextField jTextField37;
    private static javax.swing.JTextField jTextField38;
    private static javax.swing.JTextField jTextField39;
    private static javax.swing.JTextField jTextField4;
    private static javax.swing.JTextField jTextField40;
    private static javax.swing.JTextField jTextField48;
    private static javax.swing.JTextField jTextField49;
    private static javax.swing.JTextField jTextField5;
    private static javax.swing.JTextField jTextField50;
    private static javax.swing.JTextField jTextField51;
    private static javax.swing.JTextField jTextField52;
    private static javax.swing.JTextField jTextField53;
    private static javax.swing.JTextField jTextField54;
    private static javax.swing.JTextField jTextField55;
    private static javax.swing.JTextField jTextField56;
    private static javax.swing.JTextField jTextField57;
    private static javax.swing.JTextField jTextField58;
    private static javax.swing.JTextField jTextField59;
    private static javax.swing.JTextField jTextField60;
    private static javax.swing.JTextField jTextField61;
    private static javax.swing.JTextField jTextField62;
    private static javax.swing.JTextField jTextField63;
    private static javax.swing.JTextField jTextField64;
    private static javax.swing.JTextField jTextField65;
    private static javax.swing.JTextField jTextField66;
    private static javax.swing.JTextField jTextField67;
    private static javax.swing.JTextField jTextField68;
    private static javax.swing.JTextField jTextField69;
    private static javax.swing.JTextField jTextField7;
    private static javax.swing.JTextField jTextField70;
    private static javax.swing.JTextField jTextField71;
    private static javax.swing.JTextField jTextField72;
    private static javax.swing.JTextField jTextField73;
    private static javax.swing.JTextField jTextField74;
    private static javax.swing.JTextField jTextField75;
    private static javax.swing.JTextField jTextField76;
    private static javax.swing.JTextField jTextField77;
    private static javax.swing.JTextField jTextField78;
    private static javax.swing.JTextField jTextField79;
    private static javax.swing.JTextField jTextField8;
    private static javax.swing.JTextField jTextField80;
    private static javax.swing.JTextField jTextField81;
    private static javax.swing.JTextField jTextField82;
    private static javax.swing.JTextField jTextField9;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JTextPane jTextPane3;
    private static javax.swing.JTree jTree1;
    private static javax.swing.JTree jTree2;
    private javax.swing.JTree jTree3;
    private javax.swing.JTree jTree4;
    // End of variables declaration                   
    
    private transient ActionListener agentLoginActionListener = new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jButton6AgentLoginActionPerformed(evt);
                    }
                };
    private transient ActionListener agentLogoutActionListener = new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jButton6AgentLogoutActionPerformed(evt);
                    }
                };
                
    private transient ActionListener holdActionListener = new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jButton10HoldActionPerformed(evt);
                    }
                };
    private transient ActionListener unHoldActionListener = new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jButton10UnHoldActionPerformed(evt);
                    }
                };
    
    private transient ActionListener showTransferMenuActionListener = new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                        transferActionPerformed(evt);
                    }
                };
                
    private transient ActionListener initSupervisedTransferActionListener = new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jMenuItem27InitiateSupervisedTransferActionPerformed(evt);
                    }
                };
    private transient ActionListener compSupervisedTransferActionListener = new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jMenuItem27CompleteSupervisedTransferActionPerformed(evt);
                    }
                };
                
    private transient ActionListener initConferenceActionListener = new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jButton12InitiateConferenceActionPerformed(evt);
                    }
                };
    private transient ActionListener compConferenceActionListener = new java.awt.event.ActionListener() {
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        jButton12CompleteConferenceActionPerformed(evt);
                    }
                };
                
    //Need ActionListeners for enabling buttons based on textfield being empty
    //Originate, PullContact
    
                
    private transient KeyListener originateActionListener = new java.awt.event.KeyListener() {

            public void keyTyped(KeyEvent e) {
            }

            public void keyPressed(KeyEvent e) {
            }

            public void keyReleased(KeyEvent e) {
            	AddressTO addr = userContext.getAddress(jTextField10.getText());
            	if(addr!=null) {
            		originateButton.setEnabled(jTextField9.getText().length() > 0 && addr.getCapabilities().isCanOriginate());
            	} else {
            		originateButton.setEnabled(false);
            	}
            	initiateButtonUpdate(jContactsTable.getSelectionModel());
            }                    
        };

		private void initiateButtonUpdate(ListSelectionModel lsm) {
			if (!lsm.isSelectionEmpty() && !contactStateEventData.isEmpty())
			{
				int selectedRow = lsm.getMinSelectionIndex();

				StateEventTO processedEventTO = contactStateEventData.get(selectedRow);
				String chosenContactId = processedEventTO.getContactId();
				String terminal = processedEventTO.getTerminal();
				String address = processedEventTO.getAddress();
				ContactTO contact = userContext.findContact(chosenContactId);

				if (contact != null && StringUtils.isNotEmpty(address))
				{
					if (StringUtils.isNotEmpty(terminal))
					{
						ConnectionTO conTO = contact.getConnection(address);
						TerminalConnectionTO tc = contact.getTerminalConnection(terminal, address);
						TerminalConnectionCapabilitiesTO termConnCaps = null;
						if (tc != null)
						{
							termConnCaps = tc.getCapabilities();
							if (tc.getStateSummary()!=null)
							{
								termConnCaps.setHeldReason( tc.getStateSummary().getReason() );
							}
						}
						updateButtons(termConnCaps, conTO);
					}

					ConnectionTO conTO = contact.getConnection(address);
					if (conTO != null)
					{
						ConnectionCapabilitiesTO connCaps = conTO.getCapabilities();
						updateButtons(connCaps);
					}
				}
			}
		}

    private transient KeyListener pullContactActionListener = new java.awt.event.KeyListener() {

            public void keyTyped(KeyEvent e) {
            }

            public void keyPressed(KeyEvent e) {
            }

            public void keyReleased(KeyEvent e) {
                jButton21.setEnabled(jTextField37.getText().length() > 0);
            }
                    
        };
    
    private transient ActionListener repHumanAgentListener = new ActionListener() {
        public void actionPerformed(ActionEvent actionEvent) {
            AbstractButton abstractButton = (AbstractButton)actionEvent.getSource();
            if(abstractButton.getModel().isSelected())
            {
                //Do something so that we are representing a human agent
            }
            else
            {
                //Not representing a human agent
            }
        }
    };
    
    private transient MouseListener errorMsgDisplayListener = new MouseListener() {

        public void mouseClicked(MouseEvent e) {
            if(jInformationTextField.getToolTipText() != null && jInformationTextField.getToolTipText().length() > 0)
            {
                jTextArea5.setText(jInformationTextField.getToolTipText());
                jTextArea5.setLineWrap(true);
                jFrame18.setSize(500, 220);
                jFrame18.setLocationRelativeTo(jInformationTextField);
                jFrame18.setVisible(true);
            }
        }

        public void mousePressed(MouseEvent e) {
        }

        public void mouseReleased(MouseEvent e) {
        }

        public void mouseEntered(MouseEvent e) {
        }

        public void mouseExited(MouseEvent e) {
        }
    };
    
    private Map getContactParams()
    {
       return getContactParams( jContactsTable.getSelectedRow() );
    }
    
    private Map getContactParams(int indexRow) {
        //Reset the error message
        jInformationTextField.setText("");
                
    	params = new HashMap<String, Object>();
    	
        if(userContext != null)
        {
            terminal = null;
            address = null;
            StateEventTO currContact = ((contactStateEventData == null || indexRow == -1) ? null : contactStateEventData.get(indexRow));
            if (currContact != null) {
            	params.put(PARAM_NAME_STATE_EVENT_TO, currContact);
            }
            terminal = (contactStateEventData == null || indexRow  == -1 ? null : contactStateEventData.get(indexRow).getTerminal());
            address = (contactStateEventData == null || indexRow == -1 ? null : contactStateEventData.get(indexRow).getAddress());            
            if(terminal == null && contactStateEventData != null && contactStateEventData.size() > 0)
            {
                terminal = contactStateEventData.get(0).getTerminal();
                address = contactStateEventData.get(0).getAddress();
            }
            TerminalTO termTO = userContext.getTerminal(terminal);
            if(termTO != null)
            {
                params.put("terminal", termTO);

                AddressTO addrTO = termTO.getAddress(address);
                if(addrTO != null)
                {
                    params.put("address", addrTO);
                }
            }
        }        
        AddressTO remAddr = new AddressTO();
        remAddr.setAddressName(jTextField9.getText());
        remAddr.setAddressType("GENERIC");
        params.put("remoteAddress", remAddr);
        StateEventTO chosenLine = (contactStateEventData == null || indexRow == -1 ? null : contactStateEventData.get(indexRow));
        if(chosenLine == null && contactStateEventData != null && contactStateEventData.size() >= 1){
        	chosenLine = contactStateEventData.get(0);
        }        
        if (chosenLine != null){
        	params.put("contactId", chosenLine.getContactId());
        	params.put("externalContactId", chosenLine.getExternalContactId());
       
        	//Get the consulted contactId using the original contact id
        	//Same Terminal and Address
        	for(StateEventTO line : contactStateEventData)
        	{
            	if(line.getTerminal().equals(chosenLine.getTerminal())
                            	&& line.getAddress().equals(chosenLine.getAddress())
                            	&& !line.getContactId().equals(chosenLine.getContactId()))
            	{
                	consultedContactId = line.getContactId();
                	break;
            	}
        	}        
        	params.put("consultedContactId", consultedContactId);
        }       
        uuiData = jTextArea4.getText();
        params.put("uuiData", uuiData);
        
        intrinsics = new ArrayList<IntrinsicTO>();
        if(userContext != null && params.get("contactId") != null && userContext.findContact((String)params.get("contactId")) != null)
        {
            //Set the selected cell to any other cell - otherwise won't use the last value entered
            if(jTable1.getRowCount() > 0)
            {
                jTable1.setCellSelectionEnabled(true);
                jTable1.getSelectionModel().setSelectionInterval(1, 1);
                jTable1.getColumnModel().getSelectionModel().setSelectionInterval(1, 1);

                for(int i=0; i<jTable1.getRowCount(); i++)
                {
                    IntrinsicTO intrinsic = new IntrinsicTO();
                    intrinsic.setKey((String)jTable1.getModel().getValueAt(i, 0));
                    intrinsic.setValue((String)jTable1.getModel().getValueAt(i, 1));
                    List<IntrinsicTO> prevIntr = userContext.findContact((String)params.get("contactId")).getIntrinsicData();
                     if(prevIntr != null)
                    {
                        for(IntrinsicTO intr : prevIntr)
                        {
                            if(intr.getKey().equals(intrinsic.getKey()))
                            {
                                intrinsic.setImmutable(intr.isImmutable());
                                break;
                            }
                        }
                    }
                    intrinsics.add(intrinsic);
                }
            }
    	}
        params.put("intrinsicData", intrinsics);        
        return params;
    }

    private void initAppComponents()
    {
    	//Initialise the RequestHandler
        reqHandler = getRequestHandler();
	
        //For updating contact information
	contactStateEventData = new Vector<StateEventTO>();
        
        //For updating contact information
	routePointStateEventData = new Vector<StateEventTO>();        
        
        //For updating/toggling the Init/Complete Supervised Transfer button
        jMenuItem27.addActionListener(initSupervisedTransferActionListener);
        
        //Originate available only when text populated
        jTextField9.addKeyListener(originateActionListener);
        
        //Pull Contact available only when text populated
        jTextField37.addKeyListener(pullContactActionListener);
        
        //HTTP Radion button for Server Settings
        ButtonGroup group = new ButtonGroup();
        group.add(httpRadioButton);
        group.add(httpsRadioButton);
        
        //Represent Human Agent Checkbox
        jCheckBox1.addActionListener(repHumanAgentListener);
        
        //Error Message Display
        jInformationTextField.addMouseListener(errorMsgDisplayListener);
    }
    
    //Populates the Tree containing the Terminals and Addresses
    //associated with a particular CCT user
    public void initUserContext(UserContextDO userCtxt)
    {
        userContext = userCtxt;
        updateDevices();
        updateRoutePointContext();
        getRequestHandler().handle("GetAgentState", new HashMap<String, Object>());
        //Disable Login Item, enable Logout
        jMenuItem41.setEnabled(false);
        jMenuItem42.setEnabled(true);
        this.setTitle(TITLE+" - "+jTextField1.getText());
    }
    
    //Updates the display of terminals, addresses as well as their DND,FWD,AGT
    //Bases display on contents of userContext object
    public void updateDevices()
    {
        boolean defaultFound = false;
        String defaultTerminalName = "";
        String defaultAddressName = "";
	int[] rowsSelected = jTree1.getSelectionRows();
        
        //Populate mapped addresses
        DefaultMutableTreeNode root = new DefaultMutableTreeNode(ROOT);
        for(TerminalTO terminalTO : userContext.getTerminals())
        {
            DefaultMutableTreeNode term = new DefaultMutableTreeNode(terminalTO.getTerminalName());
            if(terminalTO.isOutOfService())
            {
                
            }
            for(AddressTO addressTO : terminalTO.getAddresses())
            {
                DefaultMutableTreeNode addr = new DefaultMutableTreeNode(addressTO.getAddressName());
                term.add(addr);
                if(!defaultFound && addressTO.getCapabilities() != null && addressTO.getCapabilities().isCanOriginate())
                {
                    //Record Default
                    defaultFound = true;
                    defaultTerminalName = terminalTO.getTerminalName();
                    defaultAddressName = addressTO.getAddressName();
//                    jButton2.setEnabled(true);
                }
            }
            root.add(term);
        }
    
        //Initialize tree and add a listener to update info
        //associated with each terminal and address selected
        DefaultTreeModel model = new DefaultTreeModel(root);
        if(!deviceContextInitialized)
        {
            //Enable in case the user logged in, having logged out.
            forwardingButton.setEnabled(true);
            dndButton.setEnabled(true);
            jButton27.setEnabled(true);
            
            jTree1 = new JTree(model);
            jTree1.setRootVisible(false);
            jTree1.setShowsRootHandles(true);
            jTree1.setCellRenderer(new DeviceTreeCellRenderer(userContext));
			jTree1.addTreeSelectionListener(new TreeSelectionListener() {
				public void valueChanged(TreeSelectionEvent e) {
					// only react and update if address is chosen
					// Avoids root appearing in Terminal Listing
					DefaultMutableTreeNode chosenNode = (DefaultMutableTreeNode) jTree1
							.getLastSelectedPathComponent();
					String currentTerminal = "";
					String currentAddress = "";
					if (chosenNode != null
							&& chosenNode.toString().equalsIgnoreCase("ROOT")) {
						// There are no resources - disable buttons
						forwardingButton.setEnabled(false);
						dndButton.setEnabled(false);
					} else {
						if (chosenNode != null) {
							if (chosenNode.isLeaf()) {
								DefaultMutableTreeNode terminalNode = (DefaultMutableTreeNode) chosenNode
										.getParent();
								currentTerminal = terminalNode.toString();
								currentAddress = chosenNode.toString();
							} else {
								currentTerminal = chosenNode.toString();
								for (AddressTO addressTO : userContext
										.getTerminal(chosenNode.toString())
										.getAddresses()) {
									if (addressTO.getCapabilities() != null
											&& addressTO.getCapabilities()
													.isCanOriginate()) {
										currentAddress = addressTO
												.getAddressName();
										break;
									}
								}
							}
						} else {
							// Set to default
							for (TerminalTO terminalTO : userContext
									.getTerminals()) {
								for (AddressTO addressTO : terminalTO
										.getAddresses()) {
									if (addressTO.getCapabilities() != null
											&& addressTO.getCapabilities()
													.isCanOriginate()) {
										// Record Default
										currentTerminal = terminalTO
												.getTerminalName();
										currentAddress = addressTO
												.getAddressName();
										break;
									}
								}
							}
						}

						jTextField11.setText(currentTerminal);
						jTextField10.setText(currentAddress);

						TerminalTO terminal = userContext
								.getTerminal(currentTerminal);

						// set activity to terminal is unsupported we set
						// activity to terminal connection
						// so changes active terminal or address can't change
						// activity button
						forwardingButton
								.setEnabled(terminal.getTerminalCapabilities() != null ? terminal
										.getTerminalCapabilities()
										.isCanForward() : false);
						dndButton
								.setEnabled(terminal.getTerminalCapabilities() != null ? terminal
										.getTerminalCapabilities()
										.isCanDoNotDisturb() : false);

						forwardingButton.setForeground(terminal.isForwarding() ? Color.RED
								: Color.BLUE);

						dndButton.setForeground(terminal.isDoNotDisturb() ? Color.RED
								: Color.BLUE);

						// Set the display for the AGT Button
						if (terminal.isAgentLoggedIn()
								&& terminal.isTerminalReady()) {
							jButton27.setForeground(Color.GREEN);
						} else if (terminal.isAgentLoggedIn()
								&& !terminal.isTerminalReady()) {
							jButton27.setForeground(Color.PINK);
						} else {
							jButton27.setForeground(Color.RED);
						}
						// Menu Items
						jMenuItem22.setEnabled(!terminal.isAgentLoggedIn());
						jMenuItem23.setEnabled(terminal.isAgentLoggedIn());
						jMenuItem24.setEnabled(!terminal.isTerminalReady());
						jMenuItem25.setEnabled(terminal.isTerminalReady());
						jMenuItem26.setEnabled(terminal.isAgentLoggedIn());
						jMenuItem38.setEnabled(terminal.isForwarding());

						// Set the Contact Types Combobox
						jComboBox2
								.setModel(new javax.swing.DefaultComboBoxModel(
										terminal.getContactTypes().toArray()));

					}
					AddressTO chosenAddress = userContext
							.getAddress(jTextField10.getText());
					if (chosenAddress != null) {
						AddressCapabilitiesTO addressCapabilities = chosenAddress
								.getCapabilities();
						if (addressCapabilities != null) {
							originateButton.setEnabled(jTextField9.getText().length() > 0
									&& addressCapabilities.isCanOriginate());
						}
					} else {
						originateButton.setEnabled(false);
					}
				}
			});
            deviceContextInitialized = true;
        }
        else
        {
            jTree1.setModel(model);
        }
        
        //Populate the tree with the selected row if there is one 
        //Populate the default that can originate otherwise
        if(rowsSelected != null && rowsSelected.length>0)
        {
        	jTree1.setSelectionRows(rowsSelected);
        }
        else
        {
	        if(defaultFound)
	        {
	            jTextField11.setText(defaultTerminalName);
	            jTextField10.setText(defaultAddressName);
                    
                TerminalTO term = userContext.getTerminal(defaultTerminalName);
	            
                activityCodeButton.setEnabled(isCanSetActivityCode());
	            forwardingButton.setEnabled(term.getTerminalCapabilities() != null ? term.getTerminalCapabilities().isCanForward() : false);
                dndButton.setEnabled(term.getTerminalCapabilities() != null ? term.getTerminalCapabilities().isCanDoNotDisturb() : false);
                
                if(forwardingButton.isEnabled())
                {
                    forwardingButton.setForeground(term.isForwarding()?Color.RED:Color.BLUE);
                }
	            if(dndButton.isEnabled())
                {
                    dndButton.setForeground(term.isDoNotDisturb()?Color.RED:Color.BLUE);
                }
	            
	            //Set the display for the AGT Button
	            if(term.isAgentLoggedIn() && term.isTerminalReady())
	            {
	                jButton27.setForeground(Color.GREEN);
	            }
	            else if(term.isAgentLoggedIn() && !term.isTerminalReady())
	            {
	            	jButton27.setForeground(Color.PINK);
	            }
	            else
	            {
	            	jButton27.setForeground(Color.RED);
	            }
                //Menu Items
                jMenuItem22.setEnabled(!term.isAgentLoggedIn());
                jMenuItem23.setEnabled(term.isAgentLoggedIn());
                jMenuItem24.setEnabled(!term.isTerminalReady());
                jMenuItem25.setEnabled(term.isTerminalReady());
                jMenuItem26.setEnabled(term.isTerminalReady());
                jMenuItem38.setEnabled(term.isForwarding());
                    
                //Set the Contact Types Combobox
                jComboBox2.setModel(new javax.swing.DefaultComboBoxModel(term.getContactTypes().toArray()));
	        }
        }
        //Paint the tree
        jScrollPane1.setViewportView(jTree1);
        
        if(userContext.getTerminals().size() > 0)
        {
            jMenuItem45.setEnabled(true);        
            updateDeviceCapabilities();
        }
        else
        {
            jMenuItem45.setEnabled(false);
        }
        
        
    }
    
    public void updateTerminalProperty(TerminalPropertyEventTO terminalPropertyEventTO)
    {
        if(terminalPropertyEventTO.getPropertyType().equals(TerminalPropertyEventTO.TerminalProperty.DO_NOT_DISTURB))
        {
            userContext.getTerminal(terminalPropertyEventTO.getTerminalName()).setDoNotDisturb(terminalPropertyEventTO.isActive());
        }
        else if(terminalPropertyEventTO.getPropertyType().equals(TerminalPropertyEventTO.TerminalProperty.FORWARDING))
        {
            userContext.getTerminal(terminalPropertyEventTO.getTerminalName()).setForwarding(terminalPropertyEventTO.isActive());
        }
        else if(terminalPropertyEventTO.getPropertyType().equals(TerminalPropertyEventTO.TerminalProperty.AGENT_LOGIN_SESSION))
        {
            TerminalTO terminal = userContext.getTerminal(terminalPropertyEventTO.getTerminalName());
            if (terminal != null){
                terminal.setAgentLoggedIn(terminalPropertyEventTO.isActive());
                if (terminal.isAgentLoggedIn()){
                	Map<String, Object> params = new HashMap<String, Object>();
                	params.put("terminal", terminal);
                	getRequestHandler().handle("GetTerminalLoginId", params);                
                }
            }
        }
        else if(terminalPropertyEventTO.getPropertyType().equals(TerminalPropertyEventTO.TerminalProperty.AGENT_LOGIN_SESSION_ENDED))
        {
            TerminalTO terminal = userContext.getTerminal(terminalPropertyEventTO.getTerminalName());
            if (terminal != null){
                terminal.setAgentLoggedIn(!terminalPropertyEventTO.isActive());
                terminal.setLoginId("");
            }    
        }
        else if(terminalPropertyEventTO.getPropertyType().equals(TerminalPropertyEventTO.TerminalProperty.READY_STATUS))
        {
            userContext.getTerminal(terminalPropertyEventTO.getTerminalName()).setTerminalReady(terminalPropertyEventTO.isActive());
            userContext.getTerminal(terminalPropertyEventTO.getTerminalName()).setTerminalNotReadyReason(terminalPropertyEventTO.getValue());
        }
        else if(terminalPropertyEventTO.getPropertyType().equals(TerminalPropertyEventTO.TerminalProperty.ACTIVITY_CODE))
        {
            userContext.getTerminal(terminalPropertyEventTO.getTerminalName()).setTerminalActivityCode(terminalPropertyEventTO.getValue());
        }
        userContext.getTerminal(terminalPropertyEventTO.getTerminalName()).setTerminalCapabilities((TerminalCapabilitiesTO)terminalPropertyEventTO.getCapabilities());
        updateDevices();
    }
    
    public void updateAgentProperty(AgentPropertyEventTO agentPropertyEventTO)
    {
        if(agentPropertyEventTO.getPropertyType().equals(AgentPropertyEventTO.AgentProperty.LOGIN_STATUS))
        {
            agents.get(agentPropertyEventTO.getAgentLoginId()).setLoggedIn(agentPropertyEventTO.isActive());
        }
        else if(agentPropertyEventTO.getPropertyType().equals(AgentPropertyEventTO.AgentProperty.READY_STATUS))
        {
            agents.get(agentPropertyEventTO.getAgentLoginId()).setReady(agentPropertyEventTO.isActive());
            agents.get(agentPropertyEventTO.getAgentLoginId()).setNotReadyReasonCode(agentPropertyEventTO.getReason());
        }
        agents.get(agentPropertyEventTO.getAgentLoginId()).setAgentCapabilities((AgentCapabilitiesTO)agentPropertyEventTO.getCapabilities());
        updateAgentContext(agents);
    }
    
    public void updateContactProperty(ContactPropertyEventTO contactPropertyEventTO)
    {
        if(contactPropertyEventTO.getPropertyType().equals(ContactPropertyEventTO.ContactProperty.ATTACHED_DATA))
        {
            updateAttachedData(contactPropertyEventTO.getContactId(), (AttachedDataTO)contactPropertyEventTO.getObject());
        }
        else if(contactPropertyEventTO.getPropertyType().equals(ContactPropertyEventTO.ContactProperty.UUI))
        {
            updateUUIData(contactPropertyEventTO.getContactId(), contactPropertyEventTO.getValue());
        }
        else if(contactPropertyEventTO.getPropertyType().equals(ContactPropertyEventTO.ContactProperty.INTRINSICS))
        {
            updateIntrinsicData(contactPropertyEventTO.getContactId(), (List<IntrinsicTO>)contactPropertyEventTO.getObject());
        }
        else if(contactPropertyEventTO.getPropertyType().equals(ContactPropertyEventTO.ContactProperty.CALLED_ADDRESS))
        {
            for(StateEventTO contactItem: contactStateEventData)
            {
                if(contactItem.getContactId().equals(contactPropertyEventTO.getContactId()))
                {
                	contactItem.setCalled(((Address)contactPropertyEventTO.getObject()).getAddressName());
                }
            }
            updateContactsDisplay(null, false);
        }
        userContext.findContact(contactPropertyEventTO.getContactId()).setCapabilities((ContactCapabilitiesTO)contactPropertyEventTO.getCapabilities());        
    }
    
    public void updateAddressProperty(AddressPropertyEventTO addressPropertyEventTO)
    {
        if(addressPropertyEventTO.getPropertyType().equals(AddressPropertyEventTO.AddressProperty.DO_NOT_DISTURB))
        {
            userContext.getAddress(addressPropertyEventTO.getAddressName()).setDoNotDisturb(addressPropertyEventTO.isActive());
        }
        else if(addressPropertyEventTO.getPropertyType().equals(AddressPropertyEventTO.AddressProperty.FORWARDING))
        {
            userContext.getAddress(addressPropertyEventTO.getAddressName()).setForwarding(addressPropertyEventTO.isActive());
        }
        else if(addressPropertyEventTO.getPropertyType().equals(AddressPropertyEventTO.AddressProperty.ACQUIRE_STATUS) || 
        		addressPropertyEventTO.getPropertyType().equals(AddressPropertyEventTO.AddressProperty.CONTROLLED))
        {
        	updateRoutePointAddressProperty(addressPropertyEventTO);
        	return;
        } else if (addressPropertyEventTO.getPropertyType().equals(AddressPropertyEventTO.AddressProperty.SPECIFIC_CAPABILITY)) {
        	userContext.getAddress(addressPropertyEventTO.getAddressName()).setCapabilities((AddressCapabilitiesTO)addressPropertyEventTO.getCapabilities());
        	updateButton((AddressCapabilitiesTO)addressPropertyEventTO.getCapabilities());
        	return;
        }
        userContext.getAddress(addressPropertyEventTO.getAddressName()).setCapabilities((AddressCapabilitiesTO)addressPropertyEventTO.getCapabilities());
        updateDevices();
    }
    
    public void updateRoutePointAddressProperty(AddressPropertyEventTO addressPropertyEventTO)
    {
        if(addressPropertyEventTO.getPropertyType().equals(AddressPropertyEventTO.AddressProperty.CONTROLLED))
        {
            AddressTO address = userContext.getAddress(addressPropertyEventTO.getAddressName());
            params.put("address", address);                
            getRequestHandler().handle("GetAcquiredStatus", params);
        }
        else if(addressPropertyEventTO.getPropertyType().equals(AddressPropertyEventTO.AddressProperty.ACQUIRE_STATUS))
        {
            userContext.getAddress(addressPropertyEventTO.getAddressName()).setControlled(addressPropertyEventTO.isActive());
            userContext.getAddress(addressPropertyEventTO.getAddressName()).setCapabilities((AddressCapabilitiesTO)addressPropertyEventTO.getCapabilities());
            updateRoutePointContext();
        }
    }
    
    private void setAddressState(AddressStateEventTO addressStateEventTO, AddressTO address, boolean isOutOfService) {
    	if (address == null) {
			AddressTO newAddress = new AddressTO();
			newAddress.setAddressName(addressStateEventTO.getAddressName());
			newAddress.setAddressType(addressStateEventTO.getAddressType());
			ProviderTO provider = new ProviderTO();
			provider.setProviderName(addressStateEventTO.getProviderName());
			newAddress.setProvider(provider);
			newAddress.setCapabilities(addressStateEventTO.getCapabilities());
			newAddress.setOutOfService(isOutOfService);
			// Get parent terminal from services (then adds address to the userContext)
			params.put("address", newAddress);
			getRequestHandler().handle("GetAddressState", params);
		} else {
			address.setOutOfService(isOutOfService);
			address.setAddressStatus(
					addressStateEventTO.getStateType().toString());
		}
    }
    
    public void updateAddressState(AddressStateEventTO addressStateEventTO)
    {
        if(addressStateEventTO.getStateType().equals(AddressStateEventTO.AddressState.INVALID))
        {
            userContext.removeAddress(addressStateEventTO.getAddressName());
        } else {
			final AddressTO address = userContext.getAddress(addressStateEventTO.getAddressName());
			if(addressStateEventTO.getStateType().equals(AddressStateEventTO.AddressState.IN_SERVICE))
			{
				setAddressState(addressStateEventTO, address, false);
			}
			else if(addressStateEventTO.getStateType().equals(AddressStateEventTO.AddressState.OUT_OF_SERVICE))
			{
				setAddressState(addressStateEventTO, address, true);
			}
		}
        
        if(!addressStateEventTO.isRoutePoint())
        {
            updateDevices();
        }
        else
        {
            updateRoutePointContext();
        }
    }
    
	private void setTerminalState(TerminalStateEventTO terminalStateEventTO, TerminalTO terminal, boolean isOutOfService) {
		if (terminal == null) {
			TerminalTO newTerminal = new TerminalTO();
			newTerminal.setTerminalName(terminalStateEventTO.getTerminalName());
			newTerminal.setTerminalType(terminalStateEventTO.getTerminalType());
			ProviderTO provider = new ProviderTO();
			provider.setProviderName(terminalStateEventTO.getProviderName());
			newTerminal.setProvider(provider);
			newTerminal.setTerminalCapabilities(terminalStateEventTO.getCapabilities());
			newTerminal.setTerminalStatus(terminalStateEventTO.getStateType().toString());
			newTerminal.setOutOfService(isOutOfService);
			// Get more information about terminal from services (adds terminal to the userContext)
			params.put("terminal", newTerminal);
			getRequestHandler().handle("GetTerminalState", params);
		} else {
			terminal.setTerminalStatus(
					terminalStateEventTO.getStateType().toString());
			terminal.setOutOfService(isOutOfService);
		}
	}
    
    public void updateTerminalState(TerminalStateEventTO terminalStateEventTO)
    {
        if(terminalStateEventTO.getStateType().equals(TerminalStateEventTO.TerminalState.INVALID))
        {
            userContext.removeTerminal(terminalStateEventTO.getTerminalName());
        } else {
			final TerminalTO terminal = userContext.getTerminal(terminalStateEventTO.getTerminalName());
			if(terminalStateEventTO.getStateType().equals(TerminalStateEventTO.TerminalState.IN_SERVICE))
			{
				setTerminalState(terminalStateEventTO, terminal, false);
			}
			else if(terminalStateEventTO.getStateType().equals(TerminalStateEventTO.TerminalState.OUT_OF_SERVICE))
			{
				setTerminalState(terminalStateEventTO, terminal, true);
			}
		}
        
        updateDevices();
    }
    
    public void updateAgentState(AgentStateEventTO agentStateEventTO)
    {
        if(agentStateEventTO.getStateType().equals(AgentStateEventTO.AgentState.UNMAPPED))
        {
            AgentTO newAgent = new AgentTO();
            newAgent.setAgentLoginId(agentStateEventTO.getUserId());
            removeAgent(newAgent);
        }
        else if(agentStateEventTO.getStateType().equals(AgentStateEventTO.AgentState.MAPPED))
        {
            AgentTO newAgent = new AgentTO();
            newAgent.setAgentLoginId(agentStateEventTO.getUserId());
            newAgent.setAgentUsername(agentStateEventTO.getUserName());
            newAgent.setAgentCapabilities(agentStateEventTO.getCapabilities());
            
            //Get more information about agent from services (adds agent to the context object)
            params.put("agent", newAgent);                
            getRequestHandler().handle("GetAgentState", params);
        }
    }
    
    public void addNewTerminal(TerminalTO terminal)
    {
        userContext.addTerminal(terminal);
    }
    
    public void addNewAddress(List<TerminalTO> terminals, AddressTO address)
    {
        userContext.addAddress(terminals, address);
    }
    
   public void updateDeviceCapabilities()
    {        
        //Populate mapped addresses
    	DeviceMutableTreeNode root = new DeviceMutableTreeNode(ROOT);
        for(TerminalTO terminalTO : userContext.getTerminals())
        {
        	DeviceMutableTreeNode term = new DeviceMutableTreeNode(terminalTO);
            for(AddressTO addressTO : terminalTO.getAddresses())
            {
            	DeviceMutableTreeNode addr = new DeviceMutableTreeNode(addressTO);
                term.add(addr);
            }
            root.add(term);
        }
        
        //Paint the tree
        jScrollPane1.setViewportView(jTree1);
        
        //Now populate a tree for capabilities
        DefaultTreeModel capabilitiesModel = new DefaultTreeModel(root);
        jTree4 = new JTree(capabilitiesModel);
        jTree4.setRootVisible(false);
        jTree4.setShowsRootHandles(true);
        jTree4.addTreeSelectionListener(new TreeSelectionListener() {

            public void valueChanged(TreeSelectionEvent e) {
            	DeviceMutableTreeNode childNode = (DeviceMutableTreeNode)
                       jTree4.getLastSelectedPathComponent();
            	if (childNode == null) {
            		childNode = (DeviceMutableTreeNode)jTree4.getModel().getRoot();
            	}
            	DeviceMutableTreeNode parentNode = (DeviceMutableTreeNode)childNode.getParent();
                jTable9 = new JTable();
                jTable10 = new JTable();
                String[] colNames = {"Capability", "Able"};
                
				DefaultTableModel dataModel = new DefaultTableModel(colNames, 0);
				
				//Reset Terminal Details
				jTextField70.setText("");
				jTextField70.setText("");
				jTextField62.setText("");
				jTextField63.setText("");
				jTextField64.setText("");
				jTextField71.setText("");
				jTextField72.setText("");
				jTextField73.setText("");
				jTextField74.setText("");
				jTextField75.setText("");
				jTextField79.setText("");
				jComboBox10.setModel(new javax.swing.DefaultComboBoxModel());
				jComboBox10.setEnabled(false);
				jTable10.setModel(dataModel);
				jScrollPane19.setViewportView(jTable10);
				
				//Reset Address Details
				jTextField65.setText("");
				jTextField66.setText("");
				jTextField68.setText("");
				jTextField69.setText("");
				jTextField76.setText("");
				jTextField77.setText("");
				jTextField78.setText("");
				jTextField80.setText("");
				jTable9.setModel(dataModel);
				jScrollPane18.setViewportView(jTable9);
                
                if(parentNode != null )
                {
                    TerminalTO terminal = null;
                    if (parentNode.toString().equals(ROOT)) {
                    	terminal = userContext.getTerminal(childNode.toString());
                    } else {
                    	terminal = userContext.getTerminal(parentNode.toString());
                    }
                    
                    //Update the terminal details
                    jTextField70.setText(terminal.getTerminalName());
                    jTextField70.setCaretPosition(0);
                    jTextField62.setText(terminal.getTerminalType());
                    jTextField63.setText(terminal.getTerminalStatus());
                    jTextField64.setText("TBD");
                    jTextField71.setText(""+terminal.isDoNotDisturb());
                    jTextField72.setText(""+terminal.isForwarding());
                    jTextField73.setText(terminal.isAgentLoggedIn() ? ""+terminal.getLoginId() : "<none>");
                    jTextField74.setText(terminal.isAgentLoggedIn() ? ""+terminal.isTerminalReady() : "<none>");
                    jTextField75.setText("TBD");
                    jTextField79.setText("TBD");
                    jComboBox10.setModel(new javax.swing.DefaultComboBoxModel(terminal.getContactTypes().toArray()));
                    jComboBox10.setEnabled(true);
                    
                    Vector<CapabilityTO> caps = null;
                    //Update the terminal capabilities display
                    if (childNode.isAddress()) {
                    	caps = userContext.findCapabilitySet(parentNode.getParent().toString(), childNode.getParent().toString());
                    } else {
                    	caps = userContext.findCapabilitySet(parentNode.toString(), childNode.toString());
                    }
                    String[][] values = null; 
                    
					if (caps != null) {
						values = new String[caps.size()][2];

						for (int i = 0; i < caps.size(); i++) {
							values[i][0] = caps.get(i).getName();
							values[i][1] = "" + caps.get(i).isAble();
						}
					} else {
						values = new String[1][2];
						values[0][0] = "";
						values[0][1] = "";
					}

                    dataModel = new DefaultTableModel(values, colNames);
                    jTable10.setModel(dataModel);
                    jTable10.setColumnSelectionAllowed(false);
                    jTable10.setGridColor(new java.awt.Color(255, 255, 255));
                    jTable10.setShowHorizontalLines(false);
                    jTable10.setShowVerticalLines(false);
                    jTable10.getTableHeader().setReorderingAllowed(false);
                    jScrollPane19.setViewportView(jTable10);
                    jTable10.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
                    jTable10.getColumnModel().getColumn(0).setPreferredWidth(75);
                    jTable10.getColumnModel().getColumn(1).setPreferredWidth(20);
                    
                    if (!parentNode.toString().equals(ROOT)) {
                        AddressTO address = userContext.getAddress(childNode.toString());
                        //Update the address details
                        jTextField65.setText(address.getAddressName());
                        jTextField65.setCaretPosition(0);
                        jTextField66.setText(address.getAddressType());
                        jTextField68.setText(address.getAddressStatus());
                        jTextField69.setText("TBD");
                        jTextField76.setText(""+address.isDoNotDisturb());
                        jTextField77.setText(""+address.isForwarding());
                        jTextField78.setText("TBD");
                        jTextField80.setText("TBD");

                        //Update the address capabilities display
                        caps = userContext.findCapabilitySet(parentNode.toString(), childNode.toString());
                        values = null;
                        if (caps != null){
                        	values = new String[caps.size()][2];
                                            
                        	for(int i=0; i<caps.size();i++)
                        	{
                            	values[i][0] = caps.get(i).getName();
                            	values[i][1] = ""+caps.get(i).isAble();
                        	}
                        }else{                  	
                        	values = new String[1][2];
                        	values[0][0] = "";values[0][1] = "";                    
                        }

                        dataModel = new DefaultTableModel(values, colNames);
                        jTable9.setModel(dataModel);
                        jTable9.setColumnSelectionAllowed(false);
                        jTable9.setGridColor(new java.awt.Color(255, 255, 255));
                        jTable9.setShowHorizontalLines(false);
                        jTable9.setShowVerticalLines(false);
                        jTable9.getTableHeader().setReorderingAllowed(false);
                        jScrollPane18.setViewportView(jTable9);
                        jTable9.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
                        jTable9.getColumnModel().getColumn(0).setPreferredWidth(75);
                        jTable9.getColumnModel().getColumn(1).setPreferredWidth(20);
                    }
                }
            }
        });
        jScrollPane17.setViewportView(jTree4);
    }
    
    //Add a single agent, mapped after login
    public void updateSingleAgentContext(AgentTO agent)
    {
    	if (agent == null) {
    		return;
    	}
    	
        prevHadNoAgents = (agents ==null || agents.isEmpty() ? true : false);
    	if (agents != null){
    		agents.put(agent.getAgentLoginId(), agent);
    		updateAgentContext(agents);
    	}	
    }
    
    private void removeAgent(AgentTO agent)
    {
    	prevHadNoAgents = (agents ==null || agents.isEmpty() ? true : false);
    	if (agents != null){
    		agents.remove(agent.getAgentLoginId());
    		updateAgentContext(agents);
    	}    	
    }
    
    //Populate the agent dropdown
    public void updateAgentContext(Map<String, AgentTO> agentMap)
    {
        String selectedAgent = getSelectedAgent();
        //Get the collection of agents to be used
        agents = agentMap;
        if(agents.isEmpty())
        {
            if(!prevHadNoAgents)
            {
                //Collapse Top Panel
            	jAgentStatusPanel.setVisible(false);
                this.setSize(this.getWidth(), this.getHeight()-jAgentStatusPanel.getHeight());
                this.pack();
            }
            
            //Disallow viewing of agent details
            jMenuItem44.setEnabled(false);
        }
        else
        {
            if(prevHadNoAgents)
            {
                //Show Top Panel
            	jAgentStatusPanel.setVisible(true);
                this.setSize(this.getWidth(), this.getHeight()+97);
                this.pack();
                prevHadNoAgents = false;
            }
            
            //Disallow viewing of agent details
            jMenuItem44.setEnabled(true);
        }
        
        Set keys = agents.keySet();
        String[] strkeys = (String[])keys.toArray(new String[keys.size()]);
        Arrays.sort(strkeys);
        
        //Set the agents to the combo box for MM Agent Login and add a listener to update
        //whether each agent is logged in and/or ready and to toggle the login accordingly
        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel(strkeys));
        if(!agentContextInitialized)
        {
            jComboBox3.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    AgentTO agent = agents.get(jComboBox3.getSelectedItem().toString());
                    jTextField2.setText(agent.getReadyStatus());
                    jTextField36.setText(agent.getAgentUsername());
                    if(agent.isLoggedIn() && agent.isReady())
                    {
                        jTextField2.setBackground(Color.GREEN);
                        jTextField36.setBackground(Color.GREEN);
                    }
                    else if(agent.isLoggedIn() && !agent.isReady())
                    {
                        jTextField2.setBackground(Color.PINK);
                        jTextField36.setBackground(Color.YELLOW);
                    }
                    else
                    {
                        jTextField2.setBackground(Color.LIGHT_GRAY);
                        jTextField36.setBackground(Color.RED);
                    }
                    
                    jMenuItem29.setEnabled(!agent.isReady());
                    jMenuItem30.setEnabled(agent.isReady());
                    jMenuItem31.setEnabled(agent.isLoggedIn());
                    
                    if(agents.get(jComboBox3.getSelectedItem().toString()).isLoggedIn())
                    {
                        //Make Logout button available
                        jButton6.setText("Agent Logout >>");
                        jButton6.setActionCommand("Agent Logout >>");
                        jButton6.getAccessibleContext().setAccessibleName("Agent Logout >>");
                        jButton6.removeActionListener(agentLoginActionListener);
                        jButton6.removeActionListener(agentLogoutActionListener);
                        jButton6.addActionListener(agentLogoutActionListener);
                    }
                    else
                    {
                        //Make Login available
                        jButton6.setText("Agent Login >>");
                        jButton6.setActionCommand("Agent Login >>");
                        jButton6.getAccessibleContext().setAccessibleName("Agent Login >>");
                        jButton6.removeActionListener(agentLoginActionListener);
                        jButton6.removeActionListener(agentLogoutActionListener);
                        jButton6.addActionListener(agentLoginActionListener);
                    }
                }
            });
            agentContextInitialized = true;
        }
        
        //Set the selected Agent from the list
        //If none selected choose first agent
        int chosenAgentIndex = 0;
        if(jComboBox3.getItemCount() > 0)
        {
            for(int i=jComboBox3.getItemCount()-1; i>=0; i--)
            {
                if(jComboBox3.getItemAt(i).toString().equalsIgnoreCase(selectedAgent))
                {
                    chosenAgentIndex = i;
                    break;
                }
            }
            jComboBox3.setSelectedIndex(chosenAgentIndex);
        }         
    }
    
    public void updateRoutePointContextWithSingle(AddressTO address)
    {
    	if(address.getCapabilities() != null)
    	{
            userContext.getAddress(address.getAddressName()).setCapabilities(address.getCapabilities());
    	}
    	userContext.getAddress(address.getAddressName()).setControlled(address.isControlled());
    	updateRoutePointContext();
    }
    
    public void updateRoutePointContext()
    {
        List<AddressTO> addresses = userContext.getUnmappedAddresses();
        
        if(addresses == null || addresses.isEmpty())
        {
            addresses = new ArrayList<AddressTO>();
        }
        
        //Get the collection of RP Addresses to be used
        if(addresses.isEmpty())
    	{
            if(!prevHadNoRoutePoints)
            {
                //Collapse Top Panel
                jRoutePointPanel.setVisible(false);
                this.setSize(this.getWidth(), this.getHeight()-jRoutePointPanel.getHeight());  
                prevHadNoRoutePoints = true;
            }
    	}
        else
        {
            if(prevHadNoRoutePoints && !jRoutePointPanel.isVisible())
            {
                jRoutePointPanel.setVisible(true);
                this.setSize(this.getWidth(), this.getHeight()+226);
                prevHadNoRoutePoints = false;
            }
        }
        
        String[][] values = new String[addresses.size()][3];
        String[] colNames = {"Controlled", "Address", "Default Treatment"};
        
        for(int i=0; i<addresses.size();i++)
        {
            values[i][0] = addresses.get(i).isControlled() ? "Controlled" : "Not";
            values[i][1] = addresses.get(i).getAddressName();
            values[i][2] = addresses.get(i).getDefaultTreatment();
        }

        jTable13 = new JTable(values , colNames);
        
//        jTable13.getColumnModel().getColumn(0).setCellRenderer(new DefaultTableCellRenderer()
//            {
//                public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
//                    JLabel l = new JLabel();
//                    l.setIcon(new ImageIcon("icons/Ready.ico"));
//                    return l;
//                }
//            }
//        );
        
        jTable13.setGridColor(new java.awt.Color(255, 255, 255));
        jTable13.setShowHorizontalLines(false);
        jTable13.setShowVerticalLines(false);
        jTable13.getTableHeader().setReorderingAllowed(false);
        jScrollPane25.setViewportView(jTable13);
        jTable13.getColumnModel().getColumn(0).setResizable(false);
        jTable13.getColumnModel().getColumn(1).setResizable(false);
        
        if(!routePointContextInitialized)
        {
            jTable13.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent e) {
                    ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                    if (!lsm.isSelectionEmpty())
                    {                    
                        int selectedRow = lsm.getMinSelectionIndex();
                        boolean isControlled = userContext.getUnmappedAddresses().get(selectedRow).isControlled();
                        jButton59.setEnabled(!isControlled);
                        jButton60.setEnabled(isControlled);
                    }

                }
            });
            routePointContextInitialized = true;
        }
        else
        {
            if(addresses.size() == 1)
            {
                 boolean isControlled = userContext.getUnmappedAddresses().get(0).isControlled();
                 jButton59.setEnabled(!isControlled);
                 jButton60.setEnabled(isControlled);
            }
        }
    }       
    
    //Update the caller/called part of a contact as soon as we have it (i.e. the service returns)
    public void supplementContactInfo(ContactTO contact)
    {
        //Update the contact in the user context
    	userContext.updateContact(contact);
      log.info( "supplementContactInfo: " + contact.getAttachedData() );  
        for(StateEventTO n: contactStateEventData)
        {
            if(n.getContactId().equals(contact.getContactId()))
            {
            	if(!n.getAddress().equals(""))
            	{
            		TerminalTO terminal = userContext.deriveTerminal(n.getAddress());
            		if (terminal != null){
            			String termName = terminal.getTerminalName();
            			TerminalConnectionTO tc = contact.getTerminalConnection(termName, n.getAddress()); 
            			n.setType(tc != null ? tc.getContactType() : null);
            		}	
            	}
            	else
            	{
            		TerminalConnectionTO termConnTO = contact.getTerminalConnectionByName(n.getTerminal());
            		if(termConnTO != null)
            		{
            			n.setType(termConnTO.getContactType());	
            		}
            	}
            	
                n.setCalled(contact.getCalledAddress());
                n.setCalling(contact.getCallingAddress());
            }
        }
        
        updateCurrentContactCapabilities(contact);
    }
    
    //Update the current states - add, remove, update StateEventTO in collection
    public void updateContactsInfo(StateEventTO stateEvent)
    {
        //Whether this event warrants updating buttons
        boolean updateButtons = false;
        // Derive the terminal from the address and populate the contacts array
        // It is usually necessary when a connection event arrives for a new contact. 
        // It has the address but doesn't have a terminal 
        if ((!stateEvent.getAddress().equals("")) && (userContext.getAddress(stateEvent.getAddress()) != null))
        {
            TerminalTO term = userContext.deriveTerminal(stateEvent.getAddress());
            if(term != null)
            {
                stateEvent.setTerminal(term.getTerminalName());
            }
        }
        //Add the contact if we are not currently on a call
    	if(contactStateEventData.isEmpty())
    	{
    		//If it's our terminal/address and it's not DISCONNECTED or DROPPED
			if ((userContext.getAddress(stateEvent.getAddress()) != null || 
					userContext.getTerminal(stateEvent.getTerminal()) != null)
					&& !stateEvent.getRemoteState().equals("DISCONNECTED")
					&& !stateEvent.getLocalState().equals("DROPPED"))
    		{
    			
    			addContactLine(stateEvent);
    			updateButtons = true;
    		}
    	}	
    	else
    	{
            //Need to decide whether this is an update for a new or existing contact
            boolean remove = false;
            boolean add = false;
            boolean updateRemote = false;
            boolean updateLocal = false;
            boolean ignore = false;
            int foundAtIndex = 0;
            
            for(StateEventTO n: contactStateEventData)
            {
                TerminalConnectionTO tcTO = n.getTerminalConnection(userContext.findContact(n.getContactId()));
                if (tcTO != null) {
                    TerminalConnectionCapabilitiesTO tcCaps = tcTO.getCapabilities();
                    if ((tcCaps != null) && (n.isConferenceInitiated() || n.isTransferInitiated()) && stateEvent.getReason().equalsIgnoreCase(HELD_REASON_CONSULT_INIT)
                            && !tcCaps.getHeldReason().equalsIgnoreCase(HELD_REASON_CONSULT_INIT)) {
                        tcCaps.setHeldReason(HELD_REASON_CONSULT_INIT);
                    }
                }

                //If we already have this contact in the list
                if(n.getContactId().equals(stateEvent.getContactId()))
                {
                	//If it's not our terminal/address 
                	if (userContext.getAddress(stateEvent.getAddress()) == null && userContext.getTerminal(stateEvent.getTerminal()) == null){
                		updateRemote = true;
                		break;
                	}
                	
                	//If it's DISCONNECTED or DROPPED - mark for removal
                    if((stateEvent.getLocalState().equalsIgnoreCase("DROPPED")
                    		&& (userContext.getTerminal(stateEvent.getTerminal()) != null))                    		
                    	|| (stateEvent.getRemoteState().equalsIgnoreCase("DISCONNECTED")
                    			&& (userContext.getAddress(stateEvent.getAddress()) != null)))
                    {
                    	//But only if it's the same address as this current line
                    	if(n.getTerminal().equals(stateEvent.getTerminal())
                    			|| n.getAddress().equals(stateEvent.getAddress()))
                    	{
                            remove = true;
                            removeNode(stateEvent.getExternalContactId());
                            clearContactCapabilities();
                            break;
                    	}
                    	else
                    	{
                            ignore = true;
                    	}
                    }
                    else
                    {                    	
                    	//If it's our terminal/address
                    	if(userContext.getAddress(stateEvent.getAddress()) != null || userContext.getTerminal(stateEvent.getTerminal()) != null)
                    	{
                            if(!stateEvent.isRemote()) {
                            	if(n.getAddress().equals(stateEvent.getNotifiedAddress())) {
                        			updateRemote = true;
                        			break;
                        		}
                            }
                            else 
                            {
                            	if(!n.getAddress().equals("") && n.getAddress().equals(stateEvent.getAddress()))
                            	{
                            		//Same Address - just mark for update
                            		updateRemote = true;
                                	break;
                            	}
                            	else if (n.getAddress().equals("")
                            			&& n.getTerminal().equals(userContext.deriveTerminalName(stateEvent.getAddress())))
                            	{
                            		//Current line has not address assigned
                            		//Set the address
                            		contactStateEventData.get(foundAtIndex).setAddress(stateEvent.getAddress());
                            		updateRemote = true;
                            		break;
                            	}                            
                            	else if(!n.getTerminal().equals("") && n.getTerminal().equals(stateEvent.getTerminal())
                            			|| (userContext.getTerminal(stateEvent.getTerminal()) != null && userContext.getTerminal(stateEvent.getTerminal()).getAddress(n.getAddress()) != null))
                            	{
                            		//Current line has not terminal assigned
                            		//Set the terminal
                            		contactStateEventData.get(foundAtIndex).setTerminal(stateEvent.getTerminal());
                            		updateLocal = true;
                                	break;
                            	}
                            	else
                            	{
                            		if(!stateEvent.getAddress().equals(""))
                            		{
                            			TerminalTO term = userContext.deriveTerminal(stateEvent.getAddress());
                            			if(term != null)
                            			{
                            				stateEvent.setTerminal(term.getTerminalName());
                            			}
                            		}
                            		add = true;                                
                            	}
                            }
                    	}
                        else
                        {
                            //If none of the above - mark as ignore
                            ignore = true;
                        }
                    }
                }
                foundAtIndex++;
            }
            if(updateLocal)
            {
                contactStateEventData.get(foundAtIndex).setTerminal(stateEvent.getTerminal());
                contactStateEventData.get(foundAtIndex).setLocalState(stateEvent.getLocalState());
                updateButtons = true;
                
                //Now update the Connection Information
                StateSummaryTO stateSummary = new StateSummaryTO();
                stateSummary.setCurrent(stateEvent.getLocalState());
                stateSummary.setPrevious(stateEvent.getPrevLocalState());
                stateSummary.setReason(stateEvent.getReason());
                TerminalConnectionTO tcTO = userContext.findTerminalConnection(stateEvent.getTerminalConnection().getTerminalConnectionId());
                if(tcTO != null)
                {
                	tcTO.setStateSummary(stateSummary);
                }

                //Can optionally set the fields on the Contact Details Frame (update in realtime)
            }
            else if(updateRemote)
            {
                //Now update the Connection Information
                StateSummaryTO stateSummary = new StateSummaryTO();
                stateSummary.setCurrent(stateEvent.getRemoteState());
                stateSummary.setPrevious(stateEvent.getPrevRemoteState());
                stateSummary.setReason(stateEvent.getReason());
                if(stateEvent.getConnection() != null)
                {
                    ConnectionTO conn = userContext.findConnection(stateEvent.getConnection().getConnectionId());
                    if(conn != null){
                        conn.setStateSummary(stateSummary);
                    }else{
                    	userContext.addConnection(stateEvent, stateSummary);
                    }
                    
                }

                contactStateEventData.get(foundAtIndex).setRemoteState(userContext.getContactRemoteState(stateEvent));
                updateButtons = true;
            }
            else if(remove)
            {
                contactStateEventData.remove(foundAtIndex);
                
                if(contactStateEventData.size() == 0)
                {
                    resetButtons();
                }
                
              //Check if there is another line/element involving this contact id
                for(StateEventTO event : contactStateEventData)
                {
                    //If there is - don't remove this contact from the context
                    if(event.getContactId().equals(stateEvent.getContactId()))
                    {
                        remove = false;
                        break;
                    }
                }
                if(remove)
                {
                    userContext.removeContact(stateEvent.getContactId());
                }
            }
            else if(add)
            {
            	addContactLine(stateEvent);
            	updateButtons = true;
            }
            else if(!ignore && contactStateEventData.size() != 0)
            {
            	if(!stateEvent.getLocalState().equals("DROPPED")
                        && !stateEvent.getRemoteState().equals("DISCONNECTED"))
                {
                    addContactLine(stateEvent);
                    updateButtons = true;
                }
            }
    	}
    	
    	updateContactsDisplay(stateEvent, updateButtons);
    }

    private void addContactLine(StateEventTO stateEvent) {
        contactStateEventData.add(stateEvent);

        //New contact - so we need to get more info and
        //add it to our collection of underlying contacts.
        params.put("contactId", stateEvent.getContactId());
        params.put("externalContactId", stateEvent.getExternalContactId());
        getRequestHandler().handle("GetContactDetails", params);

        stateEvent.setRemoteState(userContext.getContactRemoteState(stateEvent));
    }

    private void updateContactsDisplay(StateEventTO event, boolean updateButtons)
    {
        String[][] values = new String[contactStateEventData.size()][7];

        for(int i=0; i<contactStateEventData.size();i++)
        {
            values[i][0] = contactStateEventData.get(i).getTerminal()+"/"+contactStateEventData.get(i).getAddress();
            values[i][1] = contactStateEventData.get(i).getLocalState();
            values[i][2] = contactStateEventData.get(i).getRemoteState();
            values[i][3] = contactStateEventData.get(i).getExternalContactId();
            values[i][4] = contactStateEventData.get(i).getType();
            values[i][5] = contactStateEventData.get(i).getCalling();
            values[i][6] = contactStateEventData.get(i).getCalled();
        }

        jContactsTable.setModel(new javax.swing.table.DefaultTableModel(
            values,
            new String [] {
                "Terminal/Addr", "Local", "Remote", "Contact", "Type", "Calling", "Called"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit[columnIndex];
            }
        });

        //Contact Details
        jMenuItem46.setEnabled(contactStateEventData.size() > 0);
        
        //Update capabilities on Connection or TerminalConnection
        //If in-progress contact, will update both
        if(updateButtons)
        {
            if(event.getTerminalConnection() != null)
            {
                TerminalConnectionCapabilitiesTO termConnCaps = (TerminalConnectionCapabilitiesTO)event.getTerminalConnection().getCapabilities();
                TerminalConnectionTO tcTO = userContext.findTerminalConnection(event.getTerminalConnection().getTerminalConnectionId());
                if(tcTO != null)
                {
                    if (tcTO.getCapabilities().getHeldReason().equalsIgnoreCase(HELD_REASON_CONSULT_INIT)) {
                        termConnCaps.setHeldReason(HELD_REASON_CONSULT_INIT);
                    }
                    tcTO.setCapabilities(termConnCaps);
                    tcTO.setTerminalName(event.getTerminal());                    
                }
            }

            if(event.getConnection() != null)
            {
                ConnectionCapabilitiesTO connCaps = (ConnectionCapabilitiesTO)event.getConnection().getCapabilities();
                ConnectionTO conTO = userContext.findConnection(event.getConnection().getConnectionId()); 
                if(conTO != null)
                {
                	conTO.setCapabilities(connCaps);
                	conTO.setAddressName(event.getAddress());
                }
            }

            if(jContactsTable.getRowCount() > 0)
            {
                int rowSelected= jContactsTable.getSelectedRow() == -1 ? 0 : jContactsTable.getSelectedRow();   
                jContactsTable.getSelectionModel().setSelectionInterval(rowSelected, rowSelected);
            }
        }
    }
    
    public void updateButton(AddressCapabilitiesTO addressCaps) {
        originateButton.setEnabled(jTextField9.getText().length() > 0 && addressCaps.isCanOriginate());
    }
    
    public void updateButtons(ContactCapabilitiesTO contactCaps)
    {
        jButton13.setEnabled(contactCaps.isCanGetAttachedData());
        jButton32.setEnabled(contactCaps.isCanGetUUI());
        jIntrinsicsButton.setEnabled(contactCaps.isCanGetIntrinsics());
        
        //Emergency and Supervisor
        jButton14.setEnabled(true);
        jButton20.setEnabled(true);
    }
    
    public void updateButtons(TerminalConnectionCapabilitiesTO termConnCaps, ConnectionTO conTO)
    {
        if(termConnCaps != null && conTO != null)
        {
            //Check connection state and set flag
            Boolean isAlerting = ConnectionState.ALERTING.toString().equals(conTO.getStateSummary().getCurrent());
            Boolean isOrigiNumNotEmpty = jTextField9.getText().length() > 0;

            //Generate DTMF
            jButton31.setEnabled(termConnCaps.isCanGenerateDTMF());

            //Update the associated buttons
            jButton8.setEnabled(termConnCaps.isCanAnswer());

            // Hold
            if (termConnCaps.isCanHold()) {

                jButton10.setText("Hold");
                jButton10.setToolTipText("Hold the selected call");
                jButton10.setActionCommand("Hold");
                jButton10.getAccessibleContext().setAccessibleName("Hold");
                jButton10.removeActionListener(unHoldActionListener);
                jButton10.removeActionListener(holdActionListener);
                jButton10.addActionListener(holdActionListener);
                jButton10.setEnabled(true);
                jButton10.repaint();

            } else if (termConnCaps.isCanUnhold()) {

                jButton10.setText("UnHold");
                jButton10.setToolTipText("UnHold the selected call");
                jButton10.setActionCommand("UnHold");
                jButton10.getAccessibleContext().setAccessibleName("UnHold");
                jButton10.setPreferredSize(new java.awt.Dimension(80, 25));
                jButton10.removeActionListener(holdActionListener);
                jButton10.removeActionListener(unHoldActionListener);
                jButton10.addActionListener(unHoldActionListener);
                jButton10.setEnabled(true);
                jButton10.repaint();

            } else {

                jButton10.setText("Hold");
                jButton10.setToolTipText("Hold the selected call");
                jButton10.setEnabled(false);
                jButton10.repaint();
            }
            jButton11.setEnabled(termConnCaps.isCanBlindTransfer() || termConnCaps.isCanInitiateTransfer());
            jMenuItem28.setEnabled(termConnCaps.isCanBlindTransfer());
            jMenuItem27.setEnabled(termConnCaps.isCanInitiateTransfer());
            activityCodeButton.setEnabled(isCanSetActivityCode());

            //If we're HELD then this could be Complete Transfer/Conference time
            if(!termConnCaps.isCanHold() && termConnCaps.isCanUnhold()) 
            {
                // For the Aura Switch the Reason is CONSULT_INIT and it allows both
                // complete the transfer and conference 
                if (termConnCaps.getHeldReason().equalsIgnoreCase(HELD_REASON_CONSULT_INIT))
                {
                    if (termConnCaps.isCanCompleteTransfer()) {
                        jButton11.setText("Comp Trans");
                        jButton11.setToolTipText("Complete the supervised transfer");
                        jButton11.setActionCommand("Complete Transfer");
                        jButton11.getAccessibleContext().setAccessibleName("Complete Transfer");
                        jButton11.setPreferredSize(new java.awt.Dimension(80, 25));
                        jButton11.removeActionListener(compSupervisedTransferActionListener);
                        jButton11.removeActionListener(showTransferMenuActionListener);
                        jButton11.addActionListener(compSupervisedTransferActionListener);
                        jButton11.setEnabled(isOrigiNumNotEmpty);
                        jButton11.repaint();
                    } else {
                        jButton11.setText("Transfer");
                        jButton11.setToolTipText("Transfer Contact");
                        jButton11.setActionCommand("TransferContact");
                        jButton11.getAccessibleContext().setAccessibleName("TransferContact");
                        jButton11.removeActionListener(compSupervisedTransferActionListener);
                        jButton11.removeActionListener(showTransferMenuActionListener);
                        jButton11.addActionListener(showTransferMenuActionListener);
                        jButton11.setEnabled(false);
                        jButton11.repaint();
                    }
                    if (termConnCaps.isCanCompleteConference()) {
                        jButton12.setText("Comp Conf");
                        jButton12.setToolTipText("Complete the conference the selected call");
                        jButton12.setActionCommand("Complete Conference");
                        jButton12.getAccessibleContext().setAccessibleName("CompleteConference");
                        jButton12.setPreferredSize(new java.awt.Dimension(80, 25));
                        jButton12.removeActionListener(initConferenceActionListener);
                        jButton12.removeActionListener(compConferenceActionListener);
                        jButton12.addActionListener(compConferenceActionListener);
                        jButton12.setEnabled(isOrigiNumNotEmpty);
                        jButton12.repaint();
                    } else {
                        jButton12.setText("Init Conf");
                        jButton12.setToolTipText("InitiateConference");
                        jButton12.setActionCommand("Initiate Conference");
                        jButton12.getAccessibleContext().setAccessibleName("InitiateConference");
                        jButton12.removeActionListener(compConferenceActionListener);
                        jButton12.removeActionListener(initConferenceActionListener);
                        jButton12.addActionListener(initConferenceActionListener);
                        jButton12.setEnabled(false);
                        jButton12.repaint();
                    }
                }
                // For CS1K the Reason for a transfer is TRANSFER_INIT
                else if(termConnCaps.getHeldReason().equalsIgnoreCase(HELD_REASON_TRANSFER_INIT) && termConnCaps.isCanCompleteTransfer())
                {
                    jButton11.setText("Comp Trans");
                    jButton11.setToolTipText("Complete the supervised transfer");
                    jButton11.setActionCommand("Complete Transfer");
                    jButton11.getAccessibleContext().setAccessibleName("Complete Transfer");
                    jButton11.setPreferredSize(new java.awt.Dimension(80, 25));
                    jButton11.removeActionListener(compSupervisedTransferActionListener);
                    jButton11.removeActionListener(showTransferMenuActionListener);
                    jButton11.addActionListener(compSupervisedTransferActionListener);
                    jButton11.setEnabled(true);
                    jButton11.repaint();
                }
             // For CS1K the Reason for a conference is CONFERENCE_INIT
                else if (termConnCaps.getHeldReason().equalsIgnoreCase(HELD_REASON_CONFERENCE_INIT) && termConnCaps.isCanCompleteConference())
                {
                    jButton12.setText("Comp Conf");
                    jButton12.setToolTipText("Complete the conference the selected call");
                    jButton12.setActionCommand("Complete Conference");
                    jButton12.getAccessibleContext().setAccessibleName("CompleteConference");
                    jButton12.setPreferredSize(new java.awt.Dimension(80, 25));
                    jButton12.removeActionListener(initConferenceActionListener);
                    jButton12.removeActionListener(compConferenceActionListener);
                    jButton12.addActionListener(compConferenceActionListener);
                    jButton12.setEnabled(true);
                    jButton12.repaint();
                }
            }
            else
            {
                // Enable Transfer canHold = true
                jButton11.setText("Transfer");
                jButton11.setToolTipText("Transfer Contact");
                jButton11.setActionCommand("TransferContact");
                jButton11.getAccessibleContext().setAccessibleName("TransferContact");
                jButton11.removeActionListener(compSupervisedTransferActionListener);
                jButton11.removeActionListener(showTransferMenuActionListener);
                jButton11.addActionListener(showTransferMenuActionListener);
                if (!isAlerting)
                    jButton11.setEnabled(isOrigiNumNotEmpty);
                else
                    jButton11.setEnabled(false);
                jButton11.repaint();
                
                // Enable Conference canHold = true
                jButton12.setText("Init Conf");
                jButton12.setToolTipText("InitiateConference");
                jButton12.setActionCommand("Initiate Conference");
                jButton12.getAccessibleContext().setAccessibleName("InitiateConference");
                jButton12.removeActionListener(compConferenceActionListener);
                jButton12.removeActionListener(initConferenceActionListener);
                jButton12.addActionListener(initConferenceActionListener);
                
                if ((!isAlerting) && (termConnCaps.isCanInitiateConference()))
                    jButton12.setEnabled(isOrigiNumNotEmpty);
                else
                    jButton12.setEnabled(false);
                jButton12.repaint();
            }
        }
    }
    
    public void updateButtons(ConnectionCapabilitiesTO connCaps)
    {
    	jButton9.setEnabled(connCaps.isCanDisconnect());
    }
    
    public void updateRoutePointButtons(ConnectionCapabilitiesTO connCaps)
    {
        jButton53.setEnabled(true);
        jButton54.setEnabled(true);
        jButton55.setEnabled(true);
        jButton56.setEnabled(true);
        jButton57.setEnabled(connCaps.isCanDisconnect());
    	jButton58.setEnabled(true);        
    }
    
    public void resetButtons()
    {
        //jButton2.setEnabled(false);
        jButton8.setEnabled(false);
        jButton9.setEnabled(false);
        jButton10.setEnabled(false);
        jButton11.setEnabled(false);
        jButton12.setEnabled(false);
        jButton13.setEnabled(false);
        jButton14.setEnabled(false);
        activityCodeButton.setEnabled(false);
        jButton31.setEnabled(false);
        jButton32.setEnabled(false);
        jIntrinsicsButton.setEnabled(false);
    }
    
    //Update the connection state of the RoutePoints
    public void updateRoutePointContactsInfo(StateEventTO stateEvent)
    {
        if(stateEvent.getRemoteState().equals("DISCONNECTED") && !stateEvent.isTreatment())
        {
            //Remove the contact from routePointStateEvents
            Iterator iter = routePointStateEventData.iterator();
            while(iter.hasNext())
            {
                if(((StateEventTO)iter.next()).getContactId().equals(stateEvent.getContactId()))
                {
                    iter.remove();
                    userContext.removeRoutePointContact(stateEvent.getContactId());
                    break;
                }
            }
        }
        else
        {
            if(userContext.findRoutePointContact(stateEvent.getContactId()) != null)
            {
                //Update the contact in the display
                int foundAtIndex = -1;
                for(int i=0; i<routePointStateEventData.size(); i++)
                {
                    if(routePointStateEventData.get(i).getContactId().equals(stateEvent.getContactId()))
                    {
                        foundAtIndex = i;
                        break;
                    }
                }
                if(foundAtIndex > -1)
                {
                    //If Treatment Event - Update the address with the default treatment
                    if(stateEvent.isTreatment())
                    {
                    	routePointStateEventData.get(foundAtIndex).setDefaultTreatment(stateEvent.getDefaultTreatment());
                    }
                    else
                    {
	                //Replace the entry to also get fresh capabilities
                        routePointStateEventData.setElementAt(stateEvent, foundAtIndex);                    
                    }                    
                }
            }
            else
            {
                //Add the contact
                ContactTO contact = new ContactTO();
            	contact.setContactId(stateEvent.getContactId());
            	contact.setExternalContactId(stateEvent.getExternalContactId());
            	contact.setConnection(stateEvent.getConnection());
            	userContext.addRoutePointContact(contact);
                routePointStateEventData.add(stateEvent);
            }
        }
        updateRoutePointContactsDisplay();
    }
    
    private void updateRoutePointContactsDisplay()
    {
        String[][] values = new String[routePointStateEventData.size()][5];
        String[] colNames = {"Contact",
                                "Address",
                                "State",
                                "Treatment",
                                "Caller"};

        for(int i=0; i<routePointStateEventData.size();i++)
        {
            values[i][0] = routePointStateEventData.get(i).getExternalContactId();
            values[i][1] = routePointStateEventData.get(i).getAddress();
            values[i][2] = routePointStateEventData.get(i).getRemoteState();
            //values[i][3] = userContext.getAddress(routePointStateEventData.get(i).getAddress()).getDefaultTreatment();
            values[i][3] = routePointStateEventData.get(i).getDefaultTreatment();
            values[i][4] = routePointStateEventData.get(i).getCalling();
        }

        jTable12 = new JTable(values , colNames);
        jTable12.setColumnSelectionAllowed(false);
        jTable12.setGridColor(new java.awt.Color(255, 255, 255));
        jTable12.setShowHorizontalLines(false);
        jTable12.setShowVerticalLines(false);
        jTable12.getTableHeader().setReorderingAllowed(false);
        jScrollPane24.setViewportView(jTable12);
        jTable12.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jTable12.getColumnModel().getColumn(0).setPreferredWidth(20);
        jTable12.getColumnModel().getColumn(1).setPreferredWidth(20);
        jTable12.getColumnModel().getColumn(2).setPreferredWidth(30);
        jTable12.getColumnModel().getColumn(3).setPreferredWidth(30);
        jTable12.getColumnModel().getColumn(4).setPreferredWidth(20);

        jTable12.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                if (!lsm.isSelectionEmpty())
                {                    
                    int selectedRow = lsm.getMinSelectionIndex();
                    ConnectionCapabilitiesTO connCaps = routePointStateEventData.get(selectedRow).getConnection().getCapabilities();
                    updateRoutePointButtons(connCaps);
                }
            }
        });
    }
    
    public void updateAttachedData(String contactId, AttachedDataTO data)
    {
        clearAttachedData();
        log.info( "updateAttachedData : " + data );
        //Update with incoming attached data
        if(data != null)
        {
            if(data.getType() != null)
            {
                jButton13.setText("*Data*");
                
                userContext.findContact(contactId).setAttachedData(data);

                //Populate the Attached Data Window according to data format
                if(data.getType().equals(AttachedDataType.STRING))
                {
                    jTextArea1.setText(data.getStringData());
                }
                else if(data.getType().equals(AttachedDataType.BINARY))
                {
                    jTextArea6.setText(data.getBinaryDataString());
                }
                else
                {
                    DefaultTableModel tableModel = new DefaultTableModel(
        		new String[] {"Key", "Value"}, 0) ;
                    for(KeyValuePairTO kvp : data.getKeyValueData())
                    {
                        Vector newRow = new Vector();
                        newRow.add(kvp.getKey());
                        newRow.add(kvp.getValue());
                        tableModel.addRow(newRow);
                    }

                    //Add some empty rows for populating
                    for(int i=0; i<3; i++)
                    {
                        tableModel.addRow(new Vector());
                    }
                    jTable11.setModel(tableModel);
                }
            }
        }    
    }
    
    public void updateUUIData(String contactId, String data)
    {
        if(data != null)
        {
            if(!data.equals(""))
            {
                jButton32.setText("*UUI*");
            }
        }            
        userContext.findContact(contactId).setUuiData(data);
        jTextArea4.setText(data);
    }
    
    public void updateIntrinsicData(String contactId, List<IntrinsicTO> data)
    {
        if(data != null)
        {
            if(!data.isEmpty())
            {
                jIntrinsicsButton.setText("*Intrinsics*");
            }
        }            
        userContext.findContact(contactId).setIntrinsicData(data);
        
        DefaultTableModel tableModel = new DefaultTableModel(
        		new String[] {"Key", "Value"}, 0) ;
		if (data != null) {
			for (IntrinsicTO intrinsic : data) {
				Vector newRow = new Vector();
				newRow.add(intrinsic.getKey());
				newRow.add(intrinsic.getValue());
				tableModel.addRow(newRow);
			}
		}
        
        //Add some empty rows for populating
        for(int i=0; i<3; i++)
        {
            tableModel.addRow(new Vector());
        }
        jTable1.setModel(tableModel);
    }
    
    public void updateServerSettings(String server, String port, boolean https)
    {
        params.put("server", server);
        params.put("port", port);
        params.put("protocol", https ? "https" : "http");
        jTextField23.setText(server);
        jTextField58.setText(port);
        if(https)
        {
            httpsRadioButton.setSelected(true);
        }
        else
        {
            httpRadioButton.setSelected(true);
        }
    }
    
    public void updateTerminalForwards(List<ForwardInstructionTO> forwards)
    {
        DefaultTableModel model = (DefaultTableModel)jTable4.getModel();
        for(int i=0; i<model.getRowCount(); i++)
        {
            model.removeRow(i);
        }
        for(ForwardInstructionTO forward : forwards)
        {
            Vector newRow = new Vector();
//            newRow.add(forward.getCondition());
//            newRow.add(forward.getFilter());
            newRow.add("Always");
            newRow.add("All");
            newRow.add(forward.getFrom());
            newRow.add(forward.getForwardTo());
            model.addRow(newRow);
        }
        jTable4.setModel(model);
    }
    
    public void updateActivityCode(String activityCode)
    {
        jMenuItem32.setText("Activity:"+(StringUtils.isBlank(activityCode) ? "<none>" : activityCode));
    }
    
    //Used to convey errors during processing
    public static void reportError(String operation, String errorMsg)
    {
        jInformationTextField.setText("Error with: "+operation+" - Click for details");
        jInformationTextField.setToolTipText(errorMsg);
    }
    
    public static void reportEvent(String operation, String msg)
    {
         jInformationTextField.setText(operation+" - Click for details");
         jInformationTextField.setToolTipText(msg);
    }
    
    
    
    public void reportFatalError()
    {
        jFrame6.setSize(280, 145);
        jFrame6.setLocationRelativeTo(jTextField36);
        jFrame6.getRootPane().setDefaultButton(jButton19);
        jFrame6.setVisible(true);
        jFrame6.requestFocus();
    }
    
    public void promptForRestart()
    {
    	dispose();
    }
    
   public void removeNode( String externalContactId )
   {   
      TreePath path = jTree3.getNextMatch( externalContactId, 0, Position.Bias.Forward );
      if (null!=path)
      {
         DefaultMutableTreeNode mNode = (DefaultMutableTreeNode)path.getLastPathComponent();
         getContactDetailsModel().removeNodeFromParent(mNode);
      }
   }
   
   public void updateCurrentContactCapabilities( ContactTO contact  )
   {  
      boolean isNodeExist = false;
      userContext.updateContactCapabilities( contact );
      contact = userContext.findContact( contact.getContactId() );
      DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode(
            contact.getExternalContactId() );      
      for (ConnectionTO connection : contact.getConnections())
      {
         DefaultMutableTreeNode connNode = new DefaultMutableTreeNode(
               connection.getAddressName() );
         for (TerminalConnectionTO termConn : connection
               .getTerminalConnections())
         {
            DefaultMutableTreeNode termConnNode = new DefaultMutableTreeNode(
                  termConn.getTerminalName() );
            connNode.add( termConnNode );
         }
         rootNode.add( connNode );
      }
      if (root == null) {
          setRootNode(new DefaultMutableTreeNode(ROOT));
      }
      Enumeration e = root.children();
      while (e.hasMoreElements())
      {
         DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(
               e.nextElement() );
         if (childNode.toString().equals( rootNode.toString() ))
         {
            isNodeExist = true;
         }
      }
      if (!isNodeExist)
      {
         getRootNode().add( rootNode );
      }
     
      setContactDetailsModel( new DefaultTreeModel( getRootNode() ) );      
      jTree3 = new JTree( getContactDetailsModel() );
      jTree3.setRootVisible(false);
      jTree3.setShowsRootHandles(true);
      jTree3.addTreeSelectionListener( new TreeSelectionListener()
      {
         public void valueChanged( TreeSelectionEvent e )
         {
            boolean contactSelected = false;
            boolean connectionSelected = false;
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree3
                  .getLastSelectedPathComponent();
            DefaultMutableTreeNode parentNode = null;
            
            
            if(node != null) {
            	parentNode = (DefaultMutableTreeNode) node.getParent();
			} else {
				if (log.isDebugEnabled()) {
					log.debug("The selection in the tree was empty will not perform any view change. Returning early.");
				}
				return;
			}
            
            if (parentNode != null && !parentNode.toString().equals( ROOT ))
            {
               DefaultMutableTreeNode grandParentNode = (DefaultMutableTreeNode) parentNode
                     .getParent();
               if (grandParentNode.toString().equals( ROOT ))
               {
                  connectionSelected = true;
               }
            }
            else
            {
               contactSelected = true;
            }
                if(contactSelected)
                {                    
                    //Update the terminal capabilities display
                    ContactTO contact = userContext.findContact(node.toString());
                    List<CapabilityTO> caps = contact.getCapabilities().getCapabilityList();
                    String[][] values = new String[caps.size()][2];
                    String[] colNames = {"Capability", "Able"};
                    
                    for(int i=0; i<caps.size();i++)
                    {
                        values[i][0] = caps.get(i).getName();
                        values[i][1] = ""+caps.get(i).isAble();
                    }

                    jTable6 = new JTable(values , colNames);
                    jTable6.setColumnSelectionAllowed(false);
                    jTable6.setGridColor(new java.awt.Color(255, 255, 255));
                    jTable6.setShowHorizontalLines(false);
                    jTable6.setShowVerticalLines(false);
                    jTable6.getTableHeader().setReorderingAllowed(false);
                    jScrollPane10.setViewportView(jTable6);
                    jTable6.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
                    jTable6.getColumnModel().getColumn(0).setPreferredWidth(75);
                    jTable6.getColumnModel().getColumn(1).setPreferredWidth(20);
                    
                    //Populate Contact Information
                    jTextField31.setText(contact.getExternalContactId());
                    jTextField32.setText(contact.getCalledAddress());
                    jTextField33.setText(contact.getCallingAddress());
                    jTextField34.setText(contact.getCallingTerminal());
                    jTextField52.setText(contact.getLastRedirectedAddress());
                    jTextField53.setText(contact.getOriginalDestinationAddress());
                    log.info( "Populate Contact Information: " + contact.getAttachedData( ));
                    jTextField54.setText(contact.getAttachedData() != null && !contact.getAttachedData().toString().equals("") ? contact.getAttachedData().toString() : "<none>");
                    jTextField55.setText(contact.getUuiData() != null && !contact.getUuiData().equals("") ? contact.getUuiData() : "<none>");
                    jComboBox4.setModel(new javax.swing.DefaultComboBoxModel(contact.getContactTypes().toArray()));
                }
                else if(connectionSelected)
                {
                    //Update the connection capabilities display
                    ContactTO contact = userContext.findContact(node.getParent().toString());
                    ConnectionTO connection = contact.getConnection(node.toString());
                    if (connection != null){
                    	List<CapabilityTO> caps = connection.getCapabilities().getCapabilityList();

                    	String[][] values = new String[caps.size()][2];
                    	String[] colNames = { "Capability", "Able" };

                    	for (int i = 0; i < caps.size(); i++) {
	                    	values[i][0] = caps.get(i).getName();
	                    	values[i][1] = "" + caps.get(i).isAble();
                        }

                    	jTable8 = new JTable(values, colNames);
                    	jTable8.setColumnSelectionAllowed(false);
                    	jTable8.setGridColor(new java.awt.Color(255, 255, 255));
                    	jTable8.setShowHorizontalLines(false);
                    	jTable8.setShowVerticalLines(false);
                    	jTable8.getTableHeader().setReorderingAllowed(false);
                    	jScrollPane16.setViewportView(jTable8);
                    	jTable8.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
                    	jTable8.getColumnModel().getColumn(0).setPreferredWidth(75);
                    	jTable8.getColumnModel().getColumn(1).setPreferredWidth(20);

                    	// Populate Connection Information
                    	jTextField7.setText(connection.getAddressName());
                    	jTextField19.setText("TBD");
                    	jTextField20.setText(connection.getStateSummary().getCurrent());
                    	jTextField21.setText(connection.getStateSummary().getPrevious());
                    	jTextField22.setText(connection.getStateSummary().getReason());
                    	jTextField24.setText(connection.getPermission());
                    	jTextField48.setText(connection.getTreatment());
                    }
                }
                else
                {
                    //Update the terminal connection capabilities display
                    ContactTO contact = userContext.findContact(node.getParent().getParent().toString());
                    TerminalConnectionTO termConn = contact.getTerminalConnection(node.toString(), node.getParent().toString());
                     if(termConn != null)
                    {
                        List<CapabilityTO> caps = termConn.getCapabilities().getCapabilityList();

                        String[][] values = new String[caps.size()][2];
                        String[] colNames = {"Capability", "Able"};

                        for(int i=0; i<caps.size();i++)
                        {
                            values[i][0] = caps.get(i).getName();
                            values[i][1] = ""+caps.get(i).isAble();
                        }

                        jTable7 = new JTable(values , colNames);
                        jTable7.setColumnSelectionAllowed(false);
                        jTable7.setGridColor(new java.awt.Color(255, 255, 255));
                        jTable7.setShowHorizontalLines(false);
                        jTable7.setShowVerticalLines(false);
                        jTable7.getTableHeader().setReorderingAllowed(false);
                        jScrollPane15.setViewportView(jTable7);
                        jTable7.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
                        jTable7.getColumnModel().getColumn(0).setPreferredWidth(75);
                        jTable7.getColumnModel().getColumn(1).setPreferredWidth(20);                   

                        //Populate Connection Information
                        jTextField25.setText(termConn.getTerminalName());
                        jTextField26.setText("TBD");
                        jTextField27.setText(termConn.getStateSummary().getCurrent());
                        jTextField28.setText(termConn.getStateSummary().getPrevious());
                        jTextField29.setText(termConn.getStateSummary().getReason());
                        jTextField30.setText("TBD");
                        jTextField49.setText(termConn.getConferenceConsult() != null ? termConn.getConferenceConsult().getExternalContactId() : "none");
                        jTextField50.setText(termConn.getTransferConsult() != null ? termConn.getTransferConsult().getExternalContactId() : "none");
                        jTextField51.setText(termConn.getContactType());
                    }
                }
            }
        });
        jScrollPane8.setViewportView(jTree3);
        
        //Finally update the Contact related buttons
        if(contact.getCapabilities() != null)
        {
            updateButtons(contact.getCapabilities());
        }
    }
    
    @Override
    public void dispose()
    {
        jMenuItem2ActionPerformed(null);
        super.dispose();
        System.exit(0);
    }
    
    private String cctUname = null;
    private String cctPwd = null;
    private String cctDom = null;
    private String agentState = null;
    private String terminal = null;
    private String address = null;
    private String contactId = null;
    private String consultedContactId = null;
    private AttachedDataTO attachedData = null;
    private String uuiData = null;
    private List<IntrinsicTO> intrinsics = null;
    
    private RequestHandler reqHandler;
    private Map<String, Object> params = new HashMap<String, Object>();
    Vector<StateEventTO> contactStateEventData;
    Vector<StateEventTO> routePointStateEventData;
    private UserContextDO userContext;
    private Map<String, AgentTO> agents;
    private boolean prevHadNoAgents = true;
    private boolean prevHadNoRoutePoints = true;
    private boolean agentContextInitialized = false;
    private boolean routePointContextInitialized = false;
    private boolean deviceContextInitialized = false;
    
    private static final String TITLE = "SOA Reference Client";
    
    //Clear the attached data fields
    private void clearAttachedData()
    {
        jTextArea1.setText("");
        jTextArea6.setText("");
        jTable11.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"", ""},
                {"", ""},
                {"", ""}
            },
            new String [] {
                "Key", "Value"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        
    }
    
    //Clear the textfields and the tables showing contact information
    private void clearContactCapabilities()
    {
        //Connection Details
        jTextField7.setText("");
        jTextField19.setText("");
        jTextField20.setText("");
        jTextField21.setText("");
        jTextField22.setText("");
        jTextField48.setText("");
        
        //Terminal Connection Detail
        jTextField25.setText("");
        jTextField26.setText("");
        jTextField27.setText("");
        jTextField28.setText("");
        jTextField29.setText("");
        jTextField30.setText("");
        jTextField49.setText("");
        jTextField50.setText("");
        jTextField51.setText("");
        
        //Contact Detail
        jTextField31.setText("");
        jTextField32.setText("");
        jTextField33.setText("");
        jTextField34.setText("");
        jTextField52.setText("");
        jTextField53.setText("");
        jTextField54.setText("");
        jTextField55.setText("");
        //jComboBox4 = new javax.swing.JComboBox();
        
        //Clear Capabilities Tables
        jTable6.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable6.setGridColor(new java.awt.Color(255, 255, 255));
        jTable6.setShowHorizontalLines(false);
        jTable6.setShowVerticalLines(false);
        jTable6.getTableHeader().setReorderingAllowed(false);
        jScrollPane10.setViewportView(jTable6);
        jTable6.getColumnModel().getColumn(0).setResizable(false);
        jTable6.getColumnModel().getColumn(1).setResizable(false);

        jTable7.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable7.setGridColor(new java.awt.Color(255, 255, 255));
        jTable7.setShowHorizontalLines(false);
        jTable7.setShowVerticalLines(false);
        jTable7.getTableHeader().setReorderingAllowed(false);
        jScrollPane15.setViewportView(jTable7);
        jTable7.getColumnModel().getColumn(0).setResizable(false);
        jTable7.getColumnModel().getColumn(1).setResizable(false);

        jTable8.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable8.setGridColor(new java.awt.Color(255, 255, 255));
        jTable8.setShowHorizontalLines(false);
        jTable8.setShowVerticalLines(false);
        jTable8.getTableHeader().setReorderingAllowed(false);
        jScrollPane16.setViewportView(jTable8);
        jTable8.getColumnModel().getColumn(0).setResizable(false);
        jTable8.getColumnModel().getColumn(1).setResizable(false);
    }
    
    private void clearForwardingFrame()
    {
        jTextField60.setText("");
        jTextField67.setText("");
        
        jTable4.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Condition", "Filter", "From", "Forward To"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable4.setGridColor(new java.awt.Color(255, 255, 255));
        jTable4.setShowHorizontalLines(false);
        jTable4.setShowVerticalLines(false);
        jTable4.getTableHeader().setReorderingAllowed(false);
        jScrollPane9.setViewportView(jTable4);
        jTable4.getColumnModel().getColumn(0).setResizable(false);
        jTable4.getColumnModel().getColumn(1).setResizable(false);
        jTable4.getColumnModel().getColumn(2).setResizable(false);
        jTable4.getColumnModel().getColumn(3).setResizable(false);

        jComboBox8.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "All", "Internal", "External", "Specific Address" }));
    }
    
    private void clearDeviceCapabilities()
    {
        jTable10.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable10.setGridColor(new java.awt.Color(255, 255, 255));
        jTable10.setShowHorizontalLines(false);
        jTable10.setShowVerticalLines(false);
        jTable10.getTableHeader().setReorderingAllowed(false);
        jScrollPane19.setViewportView(jTable10);
        jTable10.getColumnModel().getColumn(0).setResizable(false);
        jTable10.getColumnModel().getColumn(1).setResizable(false);

        jTable9.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable9.setGridColor(new java.awt.Color(255, 255, 255));
        jTable9.setShowHorizontalLines(false);
        jTable9.setShowVerticalLines(false);
        jTable9.getTableHeader().setReorderingAllowed(false);
        jScrollPane18.setViewportView(jTable9);
        jTable9.getColumnModel().getColumn(0).setResizable(false);
        jTable9.getColumnModel().getColumn(1).setResizable(false);
    }
    
    private void clearAgentCapabilities()
    {
        jTable5.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                 {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Capability", "Available"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable5.setGridColor(new java.awt.Color(255, 255, 255));
        jTable5.setShowHorizontalLines(false);
        jTable5.setShowVerticalLines(false);
        jTable5.getTableHeader().setReorderingAllowed(false);
        jScrollPane14.setViewportView(jTable5);
        jTable5.getColumnModel().getColumn(0).setResizable(false);
        jTable5.getColumnModel().getColumn(1).setResizable(false); 
        
        //Same for Agent Contact Types
        jTable3.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                 {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Contact Types"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable3.setGridColor(new java.awt.Color(255, 255, 255));
        jTable3.setShowHorizontalLines(false);
        jTable3.setShowVerticalLines(false);
        jTable3.getTableHeader().setReorderingAllowed(false);
        jScrollPane21.setViewportView(jTable3);
        jTable3.getColumnModel().getColumn(0).setResizable(false);
    }
    
    public RequestHandler getRequestHandler() {
        jInformationTextField.setText("");
        jInformationTextField.setToolTipText("");
        return reqHandler;
    }

    public void setRequestHandler(RequestHandler reqHandler) {
        this.reqHandler = reqHandler;
    }
    
    private String getSelectedTerminal()
    {
    	String selectedTerminalName = null;
    	ListSelectionModel lsm = jContactsTable.getSelectionModel();
    	if (!lsm.isSelectionEmpty()) 
    	{
    		selectedTerminalName = contactStateEventData.get(lsm.getMinSelectionIndex()).getTerminal();
        }
        else
        {
        	selectedTerminalName = jTextField11.getText();
        }
    	return selectedTerminalName;
    }
    
    private Boolean isCanSetActivityCode()
    {
    	Boolean isCanSetActivityCode = false;
    	ListSelectionModel lsm = jContactsTable.getSelectionModel();
        if (!lsm.isSelectionEmpty() && !contactStateEventData.isEmpty()) {       	
            int selectedRow = lsm.getMinSelectionIndex();
            String chosenContactId = contactStateEventData.get(selectedRow).getContactId();
            String terminal = contactStateEventData.get(selectedRow).getTerminal();
            String address = contactStateEventData.get(selectedRow).getAddress();
            String remoteState = contactStateEventData.get(selectedRow).getRemoteState();
            ContactTO contact= userContext.findContact(chosenContactId);
			if (contact != null && StringUtils.isNotEmpty(terminal) && StringUtils.isNotEmpty(address) && !StringUtils.equals(remoteState, "<n/a>"))
			{
				getRequestHandler().handle("GetContactDetails", getContactParams());
				TerminalConnectionTO tc = contact.getTerminalConnection(terminal, address);
				TerminalConnectionCapabilitiesTO termConnCaps = tc != null ? tc.getCapabilities() : null;
				if(termConnCaps != null)
				{
					isCanSetActivityCode = termConnCaps.isCanSetActivityCode();
				}
			}
        }
    	return isCanSetActivityCode;
    }
    
    
    
    public String getSelectedAgent()
    {
       return (jComboBox3.getSelectedItem() != null ? jComboBox3.getSelectedItem().toString() : null);
    }
    
    public DefaultMutableTreeNode getRootNode()
    {
       return root;
    }
    
    public void setRootNode(DefaultMutableTreeNode rootNode )
    {
       this.root = rootNode;
    }
    
    public DefaultTreeModel getContactDetailsModel()
    {
       return contactDetailsModel;
    }
    
    public void setContactDetailsModel(DefaultTreeModel treeModel)
    {
       this.contactDetailsModel = treeModel;
    }
    
    private Border createBorder(String borderTitle){
    	return javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createTitledBorder(" "+borderTitle+" "), 
    			javax.swing.BorderFactory.createBevelBorder(BevelBorder.LOWERED));
    }
    
}
